2011-10-19  Adam Barth  <abarth@webkit.org>

        Another attempted build fix.  I managed to screw up every line of this file.

        * CodeGenerators.pri:

2011-10-19  Adam Barth  <abarth@webkit.org>

        Attempt to fix the Qt build.

        * CodeGenerators.pri:

2011-10-19  Adam Barth  <abarth@webkit.org>

        Document.cpp shouldn't need to know about every event for every feature
        https://bugs.webkit.org/show_bug.cgi?id=70469

        Reviewed by Eric Seidel.

        make_event_factory.pl generates the implementation of EventFactory
        based on a simple ".in" file.

        * CodeGenerators.pri:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.gyp/WebCore.gyp:
        * WebCore.gyp/scripts/action_makenames.py:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/Document.cpp:
        (WebCore::Document::createEvent):
        * dom/EventFactory.h: Added.
        * dom/EventFactory.in: Added.
        * dom/make_event_factory.pl: Added.
        (defaultEventPropertyHash):
        (eventHandler):
        (parametersHandler):
        (readNames):
        (readEvents):
        (interfaceForEvent):
        (printCppFile):
        (printLicenseHeader):

2011-10-19  Kentaro Hara  <haraken@chromium.org>

        Added a ConstructorMode check to all existing custom V8 constructors.
        https://bugs.webkit.org/show_bug.cgi?id=70464

        Reviewed by Adam Barth.

        This patch adds the following two lines to all existing custom V8 constructors:

            if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
                return args.Holder();

        This checks whether a programmer is trying to allocate an object via "new X",
        or C++ is trying to allocate an object via the function template and wrap the
        object with a JS flavor. (See here for more details: bug 70015) In the latter case,
        a constructor callback should not be executed (i.e. should return immediately).

        No new tests. No change in behavior.

        * bindings/v8/custom/V8ArrayBufferCustom.cpp: Added the ConstructorMode check.
        (WebCore::V8ArrayBuffer::constructorCallback):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h: Ditto.
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8AudioContextCustom.cpp: Ditto.
        (WebCore::V8AudioContext::constructorCallback):
        * bindings/v8/custom/V8DOMFormDataCustom.cpp: Ditto.
        (WebCore::V8DOMFormData::constructorCallback):
        * bindings/v8/custom/V8DataViewCustom.cpp: Ditto.
        (WebCore::V8DataView::constructorCallback):
        * bindings/v8/custom/V8HTMLAudioElementConstructor.cpp: Ditto.
        (WebCore::v8HTMLAudioElementConstructorCallback):
        * bindings/v8/custom/V8HTMLImageElementConstructor.cpp: Ditto.
        (WebCore::v8HTMLImageElementConstructorCallback):
        * bindings/v8/custom/V8HTMLOptionElementConstructor.cpp: Ditto.
        (WebCore::v8HTMLOptionElementConstructorCallback):
        * bindings/v8/custom/V8MessageChannelConstructor.cpp: Ditto.
        (WebCore::V8MessageChannel::constructorCallback):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp: Ditto.
        (WebCore::V8WebKitMutationObserver::constructorCallback):
        * bindings/v8/custom/V8WebKitPointConstructor.cpp: Ditto.
        (WebCore::V8WebKitPoint::constructorCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp: Ditto.
        (WebCore::V8WebSocket::constructorCallback):
        * bindings/v8/custom/V8XMLHttpRequestConstructor.cpp: Ditto.
        (WebCore::V8XMLHttpRequest::constructorCallback):

2011-10-19  Carol Szabo  <carol@webkit.org>

        CSS Counters have wrong values
        https://bugs.webkit.org/show_bug.cgi?id=69605

        Reviewed by Darin Adler.

        Test: fast/css/counters/after-continuation.html

        Added a new method for getting the renderer of the "after"
        pseudo-element that handles continuations.
        Hooked up the new method with the CSS counter code.

        * rendering/RenderCounter.cpp:
        (WebCore::rendererOfAfterPseudoElement):
        (WebCore::previousInPreOrder):
        (WebCore::nextInPreOrder):
        * rendering/RenderObject.h:

2011-10-19  Anna Cavender  <annacc@chromium.org>

        Adding some IDL files for <track>.
        https://bugs.webkit.org/show_bug.cgi?id=62887

        Reviewed by Adam Barth.

        Tests:
        MutableTextTrack.idl and addTrack() in HTMLMediaElement.idl are tested by:
        media/track/track-mutable.html

        TextTrack.idl is tested by:
        media/track/track-text-track.html

        TextTrackCue.idl is tested by:
        media/track/track-webvtt-tc006-cue-identifiers.html
        media/track/track-webvtt-tc007-cue-no-id.html
        media/track/track-webvtt-tc008-timings-no-hours.html
        media/track/track-webvtt-tc009-timings-hour.html
        media/track/track-webvtt-tc013-settings.html
        media/track/track-webvtt-tc023-markup.html

        TextTrackCueList.idl is tested by:
        media/track/track-text-track-cue-list.html

        * CMakeLists.txt: Adding files to build systems.
        * CodeGenerators.pri: Adding files to build systems.
        * DerivedSources.cpp: Adding files to build systems.
        * DerivedSources.make: Adding files to build systems.
        * GNUmakefile.list.am: Adding files to build systems.
        * WebCore.gypi: Adding files to build systems.
        * WebCore.pro: Adding files to build systems.
        * WebCore.xcodeproj/project.pbxproj: Adding files to build systems.
        * bindings/gobject/GNUmakefile.am: Adding files to build systems.
        * bindings/gobject/WebKitHTMLElementWrapperFactory.cpp: Adding files to build systems.
        * bindings/js/JSBindingsAllInOne.cpp: Adding files to build systems.

        * bindings/js/JSTextTrackCustom.cpp: Added.
        (WebCore::toJS):

        * bindings/scripts/CodeGeneratorV8.pm:
        (HasCustomToV8Implementation): Special check for TextTrack since V8 can auto-generate
        it, but JS cannot yet.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::addTrack): creates and returns a new MutableTextTrack.
        * html/HTMLMediaElement.h: Adding addTrack() function.
        * html/HTMLMediaElement.idl: Adding addTrack() function.
        * html/HTMLTrackElement.cpp:
        (WebCore::HTMLTrackElement::track): Adding track getter.
        * html/HTMLTrackElement.h: Adding track getter.
        * html/HTMLTrackElement.idl: Adding track getter.
        * html/MutableTextTrack.idl: Added.
        * html/TextTrack.idl: Added.
        * html/TextTrackCue.idl: Added.
        * html/TextTrackCueList.cpp:
        (WebCore::TextTrackCueList::length):
        (WebCore::TextTrackCueList::item): Used for [] operator.
        * html/TextTrackCueList.h: Added item() for [] operator.
        * html/TextTrackCueList.idl: Added.
        * page/DOMWindow.idl: Adding TextTrackCue new operator.

2011-10-19  Shawn Singh  <shawnsingh@chromium.org>

        [chromium] Fix webkit style on a few files.
        https://bugs.webkit.org/show_bug.cgi?id=70441

        Reviewed by James Robinson.

        Tested with existing layout and unit tests.

        * platform/graphics/chromium/LayerChromium.cpp:
        * platform/graphics/chromium/LayerChromium.h:
        (WebCore::LayerChromium::setIsMask):
        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::initialize):
        * platform/graphics/chromium/LayerRendererChromium.h:

2011-10-19  Nat Duca  <nduca@chromium.org>

        [chromium] Route requestAnimationFrame through CCProxy in threaded mode
        https://bugs.webkit.org/show_bug.cgi?id=70160

        Reviewed by James Robinson.

        * platform/graphics/chromium/cc/CCLayerTreeHost.cpp:
        (WebCore::CCLayerTreeHost::setNeedsAnimate):
        * platform/graphics/chromium/cc/CCLayerTreeHost.h:
        * platform/graphics/chromium/cc/CCProxy.h:
        * platform/graphics/chromium/cc/CCScheduler.cpp:
        (WebCore::CCScheduler::requestAnimate):
        * platform/graphics/chromium/cc/CCScheduler.h:
        * platform/graphics/chromium/cc/CCSingleThreadProxy.cpp:
        (WebCore::CCSingleThreadProxy::setNeedsAnimate):
        * platform/graphics/chromium/cc/CCSingleThreadProxy.h:
        * platform/graphics/chromium/cc/CCThreadProxy.cpp:
        (WebCore::CCThreadProxy::setNeedsAnimate):
        (WebCore::CCThreadProxy::setNeedsAnimateOnCCThread):
        * platform/graphics/chromium/cc/CCThreadProxy.h:

2011-10-19  Kent Tamura  <tkent@chromium.org>

        Reject invalid MIME type strings for a file selection dialog parameter
        https://bugs.webkit.org/show_bug.cgi?id=70095

        Reviewed by Darin Fisher and Darin Adler.

        No new tests. This affect only a value passed to WebKit layer.

        * html/HTMLInputElement.cpp:
        (WebCore::isRFC2616TokenCharacter): Added.
        (WebCore::HTMLInputElement::acceptMIMETypes):
        Validate a MIME type string, and don't add invalid strings to the output Vector.

2011-10-19  Darin Adler  <darin@apple.com>

        Remove OptionElement (first half)
        https://bugs.webkit.org/show_bug.cgi?id=70276

        Reviewed by Kent Tamura.

        Refactoring that does not require new tests.

        * css/SelectorChecker.cpp:
        (WebCore::SelectorChecker::checkOneSelector): Use hasTagName
        and toHTMLOptionElement instead of toOptionElement.

        * dom/OptionElement.cpp: Deleted contents. Remove file later.
        * dom/OptionElement.h: Ditto.

        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::HTMLOptionElement): Initialize m_isSelected.
        (WebCore::HTMLOptionElement::createForJSConstructor): Initialize the
        selected attribute rather than calling setDefaultSelected.
        (WebCore::HTMLOptionElement::text): Moved the code here from
        OptionElement::collectOptionLabelOrText.
        (WebCore::HTMLOptionElement::index): Moved the code here from
        OptionElement::optionIndex.
        (WebCore::HTMLOptionElement::parseMappedAttribute): Removed unneeded
        code to call setValue and setLabel. Changed the code that called
        setSelected to instead set m_isSelected and added a FIXME about why
        that's probably wrong, but same behavior as before.
        (WebCore::HTMLOptionElement::value): Moved the code here from
        OptionElement::collectOptionValue. Added a FIXME about incorrect
        whitespace stripping.
        (WebCore::HTMLOptionElement::selected): Use m_isSelected.
        (WebCore::HTMLOptionElement::setSelected): Use m_isSelected and
        call setSelectedState instead of OptionElement::setSelectedState.
        (WebCore::HTMLOptionElement::setSelectedState): Moved the code
        here from OptionElement::setSelectedState.
        (WebCore::HTMLOptionElement::label): Streamlined the code.
        (WebCore::HTMLOptionElement::textIndentedToRespectGroupLabel):
        Moved the code here from OptionElement::collectOptionTextRespectingGroupLabel.
        (WebCore::HTMLOptionElement::insertedIntoTree): Use m_isSelected
        and rewrote comment for clarity.
        (WebCore::HTMLOptionElement::collectOptionInnerText): Moved this
        here from OptionElement, and changed to use StringBuilder.
        (WebCore::toHTMLOptionElement): Added.

        * html/HTMLOptionElement.h: Removed OptionElement.h include.
        Removed OptionElement base class. Removed unneeded friend declarations.
        Made value and selected functions non-virtual. Removed unneeded
        defaultSelected and setDefaultSelected functions. Made the
        textIndentedToRespectGroupLabel and setSelectedState functions
        be non-virtual and public. Added a collectOptionInnerText function.
        Replaced m_data with m_value, m_label, and m_selected.

        * html/HTMLSelectElement.cpp:
        (WebCore::toOptionElement): Added. Helper to keep existing code
        close to the same.
        (WebCore::HTMLSelectElement::nextValidIndex): Use hasTagName
        instead of isOptionElement.
        (WebCore::HTMLSelectElement::saveLastSelection): Use HTMLOptionElement
        type instead of OptionElement.
        (WebCore::HTMLSelectElement::setActiveSelectionAnchorIndex): Ditto.
        (WebCore::HTMLSelectElement::updateListBoxSelection): Ditto.
        (WebCore::HTMLSelectElement::listBoxOnChange): Ditto.
        (WebCore::HTMLSelectElement::recalcListItems): Ditto.
        (WebCore::HTMLSelectElement::selectedIndex): Ditto.
        (WebCore::HTMLSelectElement::setSelectedIndex): Ditto.
        (WebCore::HTMLSelectElement::optionToListIndex): Ditto.
        (WebCore::HTMLSelectElement::listToOptionIndex): Ditto.
        (WebCore::HTMLSelectElement::deselectItemsWithoutValidation): Ditto.
        (WebCore::HTMLSelectElement::saveFormControlState): Ditto.
        (WebCore::HTMLSelectElement::restoreFormControlState): Ditto.
        (WebCore::HTMLSelectElement::appendFormData): Ditto.
        (WebCore::HTMLSelectElement::reset): Ditto.
        (WebCore::HTMLSelectElement::updateSelectedState): Ditto.
        (WebCore::HTMLSelectElement::lastSelectedListIndex): Ditto.
        (WebCore::HTMLSelectElement::typeAheadFind): Ditto.
        (WebCore::HTMLSelectElement::accessKeySetSelectedIndex): Ditto.
        (WebCore::HTMLSelectElement::length): Ditto.

        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::updateFromElement): Use HTMLOptionElement,
        hasTagName, and toHTMLOptionElement.
        (WebCore::RenderListBox::addFocusRingRects): Ditto.
        (WebCore::RenderListBox::paintItemForeground): Ditto.
        (WebCore::RenderListBox::paintItemBackground): Ditto.
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::updateOptionsWidth): Ditto.
        (WebCore::RenderMenuList::setTextFromOption): Ditto.
        (WebCore::RenderMenuList::itemText): Ditto.
        (WebCore::RenderMenuList::itemIsSelected): Ditto.

2011-10-19  Raymond Toy  <rtoy@google.com>

        Flush denormals to zero on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=70140

        Reviewed by Kenneth Russell.

        * platform/audio/AudioBus.cpp:
        (WebCore::AudioBus::processWithGainFromMonoStereo):
        Flush any denormals to zero before saving the result.  Change
        double gain to float gain to match existing float operations.
        * platform/audio/DenormalDisabler.h:
        (WebCore::DenormalDisabler::flushDenormalFloatToZero):
        New function to flush the given float to zero, if it is a denormal
        number.

2011-10-19  Raphael Kubo da Costa  <kubo@profusion.mobi>

        [EFL] Remove the empty paint() implementation in ScrollbarEfl.
        https://bugs.webkit.org/show_bug.cgi?id=70428

        Reviewed by Antonio Gomes.

        Remove the empty reimplementation of Scrollbar::paint(), as this would
        cause ScrollView::paintScrollbars() to paint nothing at all.

        If we have mock scrollbars enabled, this will paint them; otherwise,
        the code path will end up in WidgetEfl::paint(), which also does
        nothing, so the behavior should not change.

        No new tests, this is machinery needed to run the current ones.

        * platform/efl/ScrollbarEfl.cpp:
        (ScrollbarEfl::frameRectsChanged):
        * platform/efl/ScrollbarEfl.h:

2011-10-19  Raphael Kubo da Costa  <kubo@profusion.mobi>

        [EFL] Do not always consider a ScrollView will have an Evas/Evas_Object.
        https://bugs.webkit.org/show_bug.cgi?id=70426

        Reviewed by Antonio Gomes.

        After r95234 turned on a new code path for the port (we erroneously used
        ENABLE_AS_IMAGE instead of ENABLE_SVG_AS_IMAGE before), some tests, such
        as compositing/image/direct-svg-image.html or
        fast/writing-mode/block-level-images.html started writing stderr
        messages about the parent passed to ScrollbarEfl::setParent not having
        an Evas.

        It turns out that a FrameView can be created in places other than
        ewk_frame_view_create_for_view, in which case the view will not have an
        Evas or an Evas_Object. This is not an error condition, so we can just
        return earlier.

        No new tests, this was detected by existing ones.

        * platform/efl/ScrollbarEfl.cpp:
        (ScrollbarEfl::setParent):

2011-10-19  Julien Chaffraix  <jchaffraix@webkit.org>

        Multiple crashes in RenderTable during layout
        https://bugs.webkit.org/show_bug.cgi?id=70392

        Reviewed by Simon Fraser.

        Tests: fast/table/crash-anonymous-table-computeLogicalWidth.html
               fast/table/crash-anonymous-table-layout.html

        r97555 forgot to take into account anonymous tables during layout
        where RenderObject::node() is NULL.

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::computeLogicalWidth):
        (WebCore::RenderTable::layout):
        Added a check for node() before calling Node::hasTagName.

2011-10-19  Adam Bergkvist  <adam.bergkvist@ericsson.com>

        Update MediaStream to use WebCore platform interfaces
        https://bugs.webkit.org/show_bug.cgi?id=68464

        Reviewed by Adam Barth.

        This is one in a series of patches that update the MediaStream feature
        to use WebCore platform interfaces.

        Tests will be provided by http://webkit.org/b/56587

        * dom/LocalMediaStream.cpp:
        (WebCore::LocalMediaStream::create):
        (WebCore::LocalMediaStream::LocalMediaStream):
        (WebCore::LocalMediaStream::stop):
        (WebCore::LocalMediaStream::stopTimerFired):
        (WebCore::LocalMediaStream::~LocalMediaStream):
        (WebCore::LocalMediaStream::toLocalMediaStream):
        * dom/LocalMediaStream.h:
        * dom/LocalMediaStream.idl:
        * dom/MediaStream.cpp:
        (WebCore::MediaStream::create):
        (WebCore::MediaStream::MediaStream):
        (WebCore::MediaStream::~MediaStream):
        (WebCore::MediaStream::readyState):
        (WebCore::MediaStream::streamEnded):
        (WebCore::MediaStream::scriptExecutionContext):
        * dom/MediaStream.h:
        (WebCore::MediaStream::label):
        (WebCore::MediaStream::tracks):
        (WebCore::MediaStream::descriptor):
        * dom/MediaStreamTrack.cpp:
        (WebCore::MediaStreamTrack::create):
        (WebCore::MediaStreamTrack::MediaStreamTrack):
        (WebCore::MediaStreamTrack::kind):
        (WebCore::MediaStreamTrack::label):
        (WebCore::MediaStreamTrack::enabled):
        (WebCore::MediaStreamTrack::setEnabled):
        * dom/MediaStreamTrack.h:
        * dom/MediaStreamTrack.idl:
        * dom/MediaStreamTrackList.cpp:
        (WebCore::MediaStreamTrackList::create):
        (WebCore::MediaStreamTrackList::MediaStreamTrackList):
        (WebCore::MediaStreamTrackList::length):
        (WebCore::MediaStreamTrackList::item):
        * dom/MediaStreamTrackList.h:
        * p2p/PeerConnection.cpp:
        (WebCore::PeerConnection::addStream):
        (WebCore::PeerConnection::removeStream):
        (WebCore::PeerConnection::remoteStreamAdded):
        * page/MediaStreamClient.h:
        * page/MediaStreamController.cpp:
        (WebCore::MediaStreamController::unregisterFrameController):
        (WebCore::MediaStreamController::streamGenerated):
        * page/MediaStreamController.h:
        * page/MediaStreamFrameController.cpp:
        (WebCore::MediaStreamFrameController::enterDetachedState):
        (WebCore::MediaStreamFrameController::disconnectFrame):
        (WebCore::MediaStreamFrameController::streamGenerated):
        * page/MediaStreamFrameController.h:

2011-10-19  W. James MacLean  <wjmaclean@chromium.org>

        [chromium] Shorten animation time for ZoomAnimator.
        https://bugs.webkit.org/show_bug.cgi?id=70419

        Reviewed by Kenneth Russell.

        Shorten animation time for ZoomAnimator.

        Existing test coverage sufficient.

        * platform/ScrollAnimatorNone.cpp:
        (WebCore::ScrollAnimatorNone::zoom):

2011-10-19  Zhenyao Mo  <zmo@google.com>

        Implement WEBGL_debug_shaders and WEBGL_debug_renderer_info extensions
        https://bugs.webkit.org/show_bug.cgi?id=70077

        Reviewed by Kenneth Russell.

        * WebCore.gypi: added new extension class files.
        * WebCore.xcodeproj/project.pbxproj: ditto.
        * WebCore.pro: ditto.
        * CMakeLists.txt: ditto.
        * GNUmakefile.list.am: ditto.
        * bindings/js/JSWebGLRenderingContextCustom.cpp:
        (WebCore::toJS): Handles two new extensions.
        * bindings/v8/custom/V8WebGLRenderingContextCustom.cpp:
        (WebCore::toV8Object): Ditto.
        * html/canvas/WebGLDebugRendererInfo.cpp: Added.
        (WebCore::WebGLDebugRendererInfo::WebGLDebugRendererInfo):
        (WebCore::WebGLDebugRendererInfo::~WebGLDebugRendererInfo):
        (WebCore::WebGLDebugRendererInfo::getName):
        (WebCore::WebGLDebugRendererInfo::create):
        * html/canvas/WebGLDebugRendererInfo.h: Added.
        * html/canvas/WebGLDebugRendererInfo.idl: Added.
        * html/canvas/WebGLDebugShaders.cpp: Added.
        (WebCore::WebGLDebugShaders::WebGLDebugShaders):
        (WebCore::WebGLDebugShaders::~WebGLDebugShaders):
        (WebCore::WebGLDebugShaders::getName):
        (WebCore::WebGLDebugShaders::create):
        (WebCore::WebGLDebugShaders::getTranslatedShaderSource):
        * html/canvas/WebGLDebugShaders.h: Added.
        * html/canvas/WebGLDebugShaders.idl: Added.
        * html/canvas/WebGLExtension.h:
        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::allowPrivilegedExtensions): To be implemented - deciding whether the two extensions should be allowed or not.
        (WebCore::WebGLRenderingContext::getExtension): Handles two new extensions.
        (WebCore::WebGLRenderingContext::getParameter): Handles UNMASKED_VENDOR_WEBGL / UNMASKED_RENDERER_WEBGL
        (WebCore::WebGLRenderingContext::getSupportedExtensions): Handles two new extensions.
        * html/canvas/WebGLRenderingContext.h:
        * platform/graphics/Extensions3D.h: Ditto.
        * platform/graphics/GraphicsTypes3D.h: Add GC3Dchar.
        * platform/graphics/chromium/Extensions3DChromium.h: Handles two new extensions.
        * platform/graphics/opengl/Extensions3DOpenGL.cpp: Ditto.
        (WebCore::getTranslatedShaderSourceANGLE):
        * platform/graphics/opengl/Extensions3DOpenGL.h: Ditto.
        * platform/graphics/qt/Extensions3DQt.cpp: Ditto.
        (WebCore::Extensions3DQt::getTranslatedShaderSourceANGLE):
        * platform/graphics/qt/Extensions3DQt.h: Ditto.

2011-10-19  Geoffrey Garen  <ggaren@apple.com>

        Removed StringImplBase, fusing it into StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=70443

        Reviewed by Gavin Barraclough.

        * ForwardingHeaders/runtime/RopeImpl.h: Removed.
        * ForwardingHeaders/wtf/text/StringImplBase.h: Removed.

2011-10-19  Shinya Kawanaka  <shinyak@google.com>

        ArrayBuffer should have slice method.
        https://bugs.webkit.org/show_bug.cgi?id=66646

        Reviewed by Kenneth Russell.

        * html/canvas/ArrayBuffer.cpp:
        (WebCore::clampValue):
        (WebCore::ArrayBuffer::slice):
        (WebCore::ArrayBuffer::sliceImpl):
        (WebCore::ArrayBuffer::clampIndex):
        * html/canvas/ArrayBuffer.h: Added declaration.
        * html/canvas/ArrayBuffer.idl: Added interface.

2011-10-19  Mark Hahnenberg  <mhahnenberg@apple.com>

        Add getConstructData to the MethodTable
        https://bugs.webkit.org/show_bug.cgi?id=70163

        Reviewed by Geoffrey Garen.

        No new tests.

        Adding getConstructData to the MethodTable in order to be able to 
        remove all calls to getConstructDataVirtual soon.  Part of the process 
        of de-virtualizing JSCell.

        * WebCore.exp.in:

2011-10-19  Dan Bernstein  <mitz@apple.com>

        Incorrect pagination in flipped-blocks writing modes with border/padding before
        https://bugs.webkit.org/show_bug.cgi?id=70444

        Reviewed by Darin Adler.

        Test: fast/multicol/flipped-blocks-border-after.html

        * rendering/LayoutState.cpp:
        (WebCore::LayoutState::LayoutState): Account for flipped blocks when adjusting the page offset.

2011-10-19  Beth Dakin  <bdakin@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=70396
        Focus rings are too thin in HiDPI in WebKit2
        -and corresponding-
        <rdar://problem/10086876>

        Reviewed by Dan Bernstein.

        Rename wkSetPatternBaseCTM to wkSetBaseCTM
        * WebCore.exp.in:
        * platform/mac/WebCoreSystemInterface.h:
        * platform/mac/WebCoreSystemInterface.mm:

        New CG-only function calls into wkSetBaseCTM.
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::setBaseCTM):

        Call GraphicsContext::setBaseCTM() rather than calling into WebKitSystemInterface 
        directly.
        * platform/graphics/cg/ImageCG.cpp:
        (WebCore::Image::drawPattern):

2011-10-19  Anna Cavender  <annacc@chromium.org>

        Update WebVTTParser to require at least one space between timestamps and arrows, e.g.:
        00:04:01.000 --> 00:03:00.500 is OK
        00:04:01.000-->00:03:00.500 is not OK
        https://bugs.webkit.org/show_bug.cgi?id=70274

        Reviewed by Eric Carlson.

        Existing tests:
        media/track/track-webvtt-tc008-timings-no-hours.html
        (see media/track/captions-webvtt/tc008-timings-no-hour-errors.vtt #6)
        media/track/track-webvtt-tc009-timings-hour.html
        (see media/track/captions-webvtt/tc009-timings-hour-error.vtt #6) 

        * html/track/WebVTTParser.cpp:
        (WebCore::WebVTTParser::collectTimingsAndSettings): Check that the
            character before and after the '-->' is a space character

2011-10-19  Daniel Cheng  <dcheng@chromium.org>

        Don't always select images during an image drag.
        https://bugs.webkit.org/show_bug.cgi?id=62998

        Reviewed by Tony Chang.

        Only select an image being dragged if it is contenteditable.

        Test: fast/events/drag-selects-image.html

        * dom/Node.cpp:
        (WebCore::Node::isContentRichlyEditable):
        * dom/Node.h:
        * page/DragController.cpp:
        (WebCore::prepareClipboardForImageDrag):

2011-10-19  Andreas Kling  <kling@webkit.org>

        HTMLBodyElement: Simplify link/alink/vlink attribute parsing.
        https://bugs.webkit.org/show_bug.cgi?id=70429

        Reviewed by Antonio Gomes.

        Instead of carrying around a CSSMutableStyleDeclaration with the body element,
        just use CSSParser::parseColor() to parse the three link color attributes.

        * html/HTMLBodyElement.h:
        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::~HTMLBodyElement):

            Remove HTMLBodyElement::m_linkDecl and all the voodoo that went along with it.

        (WebCore::HTMLBodyElement::parseMappedAttribute):

            Use CSSParser directly to parse the color values for {link,alink,vlink}Attr.

2011-10-18  Oliver Hunt  <oliver@apple.com>

        Support CanvasPixelArray in the DFG
        https://bugs.webkit.org/show_bug.cgi?id=70384

        Reviewed by Filip Pizlo.

        Make CanvasPixelArray inherit from ByteArray's ClassInfo so
        can identify it more sensibly.

        * bindings/js/JSImageDataCustom.cpp:
        (WebCore::toJS):

2011-10-19  Chang Shu  <cshu@webkit.org>

        [Qt] Disable fullscreen api on Qt by default
        https://bugs.webkit.org/show_bug.cgi?id=70413

        Reviewed by Noam Rosenthal.

        As the WebKit side of implementation for fullscreen api feature has not been done yet,
        we'd better turn off the feature on the WebCore side by default.

        * features.pri:

2011-10-19  Dirk Schulze  <krit@webkit.org>

        Unreviewed, rolling out r97863.
        http://trac.webkit.org/changeset/97863
        https://bugs.webkit.org/show_bug.cgi?id=65769

        Rollout

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * platform/graphics/FloatRect.cpp:
        * platform/graphics/FloatRect.h:
        (WebCore::FloatRect::contains):
        * rendering/RenderObject.h:
        (WebCore::RenderObject::isSVGPath):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::write):
        * rendering/svg/RenderSVGAllInOne.cpp:
        * rendering/svg/RenderSVGModelObject.cpp:
        (WebCore::isGraphicsElement):
        * rendering/svg/RenderSVGPath.cpp:
        (WebCore::BoundingRectStrokeStyleApplier::BoundingRectStrokeStyleApplier):
        (WebCore::BoundingRectStrokeStyleApplier::strokeStyle):
        (WebCore::RenderSVGPath::RenderSVGPath):
        (WebCore::RenderSVGPath::fillContains):
        (WebCore::RenderSVGPath::strokeContains):
        (WebCore::RenderSVGPath::layout):
        (WebCore::RenderSVGPath::shouldStrokeZeroLengthSubpath):
        (WebCore::RenderSVGPath::zeroLengthSubpathRect):
        (WebCore::RenderSVGPath::setupSquareCapPath):
        (WebCore::RenderSVGPath::setupNonScalingStrokePath):
        (WebCore::RenderSVGPath::fillAndStrokePath):
        (WebCore::RenderSVGPath::paint):
        (WebCore::RenderSVGPath::addFocusRingRects):
        (WebCore::RenderSVGPath::nodeAtFloatPoint):
        (WebCore::RenderSVGPath::calculateMarkerBoundsIfNeeded):
        (WebCore::RenderSVGPath::updateCachedBoundaries):
        * rendering/svg/RenderSVGPath.h:
        (WebCore::RenderSVGPath::path):
        (WebCore::RenderSVGPath::setNeedsPathUpdate):
        (WebCore::RenderSVGPath::setNeedsBoundariesUpdate):
        (WebCore::RenderSVGPath::setNeedsTransformUpdate):
        (WebCore::RenderSVGPath::objectBoundingBox):
        (WebCore::RenderSVGPath::strokeBoundingBox):
        (WebCore::RenderSVGPath::repaintRectInLocalCoordinates):
        (WebCore::RenderSVGPath::localToParentTransform):
        (WebCore::RenderSVGPath::localTransform):
        (WebCore::toRenderSVGPath):
        * rendering/svg/RenderSVGRect.cpp: Removed.
        * rendering/svg/RenderSVGRect.h: Removed.
        * rendering/svg/RenderSVGResource.h:
        (WebCore::RenderSVGResource::postApplyResource):
        * rendering/svg/RenderSVGResourceClipper.cpp:
        (WebCore::RenderSVGResourceClipper::drawContentIntoMaskImage):
        (WebCore::RenderSVGResourceClipper::calculateClipContentRepaintRect):
        (WebCore::RenderSVGResourceClipper::hitTestClipContent):
        * rendering/svg/RenderSVGResourceContainer.cpp:
        (WebCore::RenderSVGResourceContainer::transformOnNonScalingStroke):
        * rendering/svg/RenderSVGResourceFilter.cpp:
        (WebCore::RenderSVGResourceFilter::postApplyResource):
        * rendering/svg/RenderSVGResourceFilter.h:
        * rendering/svg/RenderSVGResourceGradient.cpp:
        (WebCore::RenderSVGResourceGradient::applyResource):
        * rendering/svg/RenderSVGResourceGradient.h:
        * rendering/svg/RenderSVGResourcePattern.cpp:
        (WebCore::RenderSVGResourcePattern::postApplyResource):
        * rendering/svg/RenderSVGResourcePattern.h:
        * rendering/svg/RenderSVGResourceSolidColor.cpp:
        (WebCore::RenderSVGResourceSolidColor::postApplyResource):
        * rendering/svg/RenderSVGResourceSolidColor.h:
        * rendering/svg/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::paint):
        * rendering/svg/RenderSVGShape.cpp: Removed.
        * rendering/svg/RenderSVGShape.h: Removed.
        * rendering/svg/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::releasePaintingResource):
        * rendering/svg/SVGRenderSupport.cpp:
        (WebCore::SVGRenderSupport::prepareToRenderSVGContent):
        (WebCore::SVGRenderSupport::finishRenderSVGContent):
        (WebCore::SVGRenderSupport::layoutChildren):
        * rendering/svg/SVGRenderTreeAsText.cpp:
        (WebCore::writeStyle):
        (WebCore::operator<<):
        (WebCore::write):
        * rendering/svg/SVGRenderTreeAsText.h:
        * rendering/svg/SVGTextRunRenderingContext.cpp:
        (WebCore::SVGTextRunRenderingContext::drawSVGGlyphs):
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::svgAttributeChanged):
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::svgAttributeChanged):
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::svgAttributeChanged):
        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::svgAttributeChanged):
        (WebCore::SVGPathElement::pathSegListChanged):
        * svg/SVGPathElement.h:
        * svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::svgAttributeChanged):
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::svgAttributeChanged):
        * svg/SVGRectElement.h:

2011-10-19  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: worker inspector title should contain worker URL
        https://bugs.webkit.org/show_bug.cgi?id=70424

        Worker inspector title is now evaluated when the front-end starts.

        Reviewed by Pavel Feldman.

        * inspector/front-end/WorkerManager.js:
        (WebInspector.WorkerManager.loaded):
        (WebInspector.WorkerManager._calculateWorkerInspectorTitle):

2011-10-19  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Avoid unecessarily calling gtk_widget_size_allocate on plugin widgets
        https://bugs.webkit.org/show_bug.cgi?id=70190

        Reviewed by Xan Lopez.

        Instead of always calling gtk_widget_size_allocate on every single plugin
        widget during scrolling, only call it on widgets that are both in the view
        and that have moved.

        No new tests. It's difficult to test scrolling performance in an
        automated way.

        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::setNPWindowIfNeeded): Reverse the if statement detecting a
        clipped out plugin. It was incorrect.
        (WebCore::PluginView::updateWidgetAllocationAndClip): If the current allocation of
        the plugin widget has not changed or if the widget remains scrolled out, do not call
        gtk_widget_size_allocate.

2011-10-19  Renata Hodovan  <reni@webkit.org>

        Add new renderer for SVGRectElement.
        https://bugs.webkit.org/show_bug.cgi?id=65769

        Reviewed by Dirk Schulze.

        This patch introduces a new common base class called RenderSVGShape which
        replaces the RenderSVGPath. This new base class has the same purpose
        as the replaced class and has specialized descendants for common
        shapes (like Rectangles and Circles), which allows faster painting
        of these shapes when certain conditions are fulfilled. On some
        benchmark programs we have seen 5% speedup.

        The biggest motivation of this refactor is taking advantage
        of faster primitive drawing in the most common and frequent
        cases. However in some rare cases, like painting rounded
        rects, we need to fallback to the original code path, which
        is fully kept in the RenderSVGShape base class. Some other
        cases, like dashed strokes, can be painted but mouse pointer
        events cannot be handled by the descendant classes. A different
        fallback mechanism is used in such cases which redirects
        only the pointer event handling to the base class.

        Tests: svg/custom/pointer-events-on-rounded-rect.xhtml
               svg/custom/pointer-events-with-linecaps-and-miterlimits.xhtml

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * platform/graphics/FloatRect.cpp:
        (WebCore::FloatRect::contains):
        * platform/graphics/FloatRect.h:
        (WebCore::FloatRect::contains):
        * rendering/RenderObject.h:
        (WebCore::RenderObject::isSVGRect):
        (WebCore::RenderObject::isSVGShape):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::write):
        * rendering/svg/RenderSVGAllInOne.cpp:
        * rendering/svg/RenderSVGModelObject.cpp:
        (WebCore::isGraphicsElement):
        * rendering/svg/RenderSVGPath.cpp:
        (WebCore::RenderSVGPath::RenderSVGPath):
        (WebCore::RenderSVGPath::inflateWithMarkerBounds): Unite the markerBounds with strokeBoundingBox.
        * rendering/svg/RenderSVGPath.h:
        * rendering/svg/RenderSVGRect.cpp: Added.
        (WebCore::RenderSVGRect::RenderSVGRect):
        (WebCore::RenderSVGRect::~RenderSVGRect):
        (WebCore::RenderSVGRect::createShape):
        (WebCore::RenderSVGRect::objectBoundingBox):
        (WebCore::RenderSVGRect::strokeBoundingBox):
        (WebCore::RenderSVGRect::fillShape):
        (WebCore::RenderSVGRect::strokeShape):
        (WebCore::RenderSVGRect::shapeDependentStrokeContains):
        (WebCore::RenderSVGRect::shapeDependentFillContains):
        * rendering/svg/RenderSVGRect.h: Added.
        (WebCore::RenderSVGRect::isSVGRect):
        (WebCore::RenderSVGRect::renderName):
        (WebCore::RenderSVGRect::isEmpty):
        * rendering/svg/RenderSVGResource.h:
        (WebCore::RenderSVGResource::postApplyResource): A new shape argument was added to allow shape specific faster painting.
        * rendering/svg/RenderSVGResourceClipper.cpp:
        (WebCore::RenderSVGResourceClipper::drawContentIntoMaskImage):
        (WebCore::RenderSVGResourceClipper::calculateClipContentRepaintRect):
        (WebCore::RenderSVGResourceClipper::hitTestClipContent):
        * rendering/svg/RenderSVGResourceContainer.cpp:
        (WebCore::RenderSVGResourceContainer::transformOnNonScalingStroke):
        * rendering/svg/RenderSVGResourceFilter.cpp:
        (WebCore::RenderSVGResourceFilter::postApplyResource):
        * rendering/svg/RenderSVGResourceFilter.h:
        * rendering/svg/RenderSVGResourceGradient.cpp:
        (WebCore::RenderSVGResourceGradient::applyResource):
        * rendering/svg/RenderSVGResourceGradient.h:
        * rendering/svg/RenderSVGResourcePattern.cpp:
        (WebCore::RenderSVGResourcePattern::postApplyResource):
        * rendering/svg/RenderSVGResourcePattern.h:
        * rendering/svg/RenderSVGResourceSolidColor.cpp:
        (WebCore::RenderSVGResourceSolidColor::postApplyResource):
        * rendering/svg/RenderSVGResourceSolidColor.h:
        * rendering/svg/RenderSVGShape.cpp: Copied from Source/WebCore/rendering/svg/RenderSVGPath.cpp.
        (WebCore::RenderSVGShape::RenderSVGShape):
        (WebCore::RenderSVGShape::~RenderSVGShape):
        (WebCore::RenderSVGShape::createShape):
        (WebCore::RenderSVGShape::isEmpty):
        (WebCore::RenderSVGShape::fillShape):
        (WebCore::RenderSVGShape::objectBoundingBox):
        (WebCore::RenderSVGShape::strokeBoundingBox):
        (WebCore::RenderSVGShape::strokeShape):
        (WebCore::RenderSVGShape::shapeDependentStrokeContains):
        The purpose of this virtual function allows decendants to use their own fast checks.
        (WebCore::RenderSVGShape::shapeDependentFillContains):
        The purpose of this virtual function allows decendants to use their own fast checks.
        (WebCore::RenderSVGShape::fillContains):
        (WebCore::RenderSVGShape::strokeContains):
        (WebCore::RenderSVGShape::layout):
        (WebCore::RenderSVGShape::shouldStrokeZeroLengthSubpath):
        (WebCore::RenderSVGShape::zeroLengthSubpathRect):
        (WebCore::RenderSVGShape::setupSquareCapPath):
        (WebCore::RenderSVGShape::setupNonScalingStrokePath):
        (WebCore::RenderSVGShape::fillAndStrokePath):
        (WebCore::RenderSVGShape::paint):
        (WebCore::RenderSVGShape::addFocusRingRects):
        (WebCore::RenderSVGShape::nodeAtFloatPoint):
        (WebCore::RenderSVGShape::calculateMarkerBoundsIfNeeded):
        (WebCore::RenderSVGShape::updateCachedBoundaries):
        (WebCore::RenderSVGShape::strokeWidth):
        * rendering/svg/RenderSVGShape.h: Copied from Source/WebCore/rendering/svg/RenderSVGPath.h.
        (WebCore::BoundingRectStrokeStyleApplier::BoundingRectStrokeStyleApplier):
        (WebCore::BoundingRectStrokeStyleApplier::strokeStyle):
        (WebCore::RenderSVGShape::setNeedsShapeUpdate):
        (WebCore::RenderSVGShape::setNeedsBoundariesUpdate):
        (WebCore::RenderSVGShape::setNeedsTransformUpdate):
        (WebCore::RenderSVGShape::isPaintingFallback):
        (WebCore::RenderSVGShape::path):
        (WebCore::RenderSVGShape::setIsPaintingFallback):
        (WebCore::RenderSVGShape::setStrokeAndMarkerBoundingBox):
        (WebCore::RenderSVGShape::hasPath):
        (WebCore::RenderSVGShape::repaintRectInLocalCoordinates):
        (WebCore::RenderSVGShape::localToParentTransform):
        (WebCore::RenderSVGShape::localTransform):
        (WebCore::RenderSVGShape::isSVGShape):
        (WebCore::RenderSVGShape::renderName):
        (WebCore::RenderSVGShape::isRoundedRect):
        (WebCore::RenderSVGShape::inflateWithMarkerBounds):
        (WebCore::toRenderSVGShape):
        * rendering/svg/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::releasePaintingResource):
        * rendering/svg/SVGRenderSupport.cpp:
        (WebCore::SVGRenderSupport::finishRenderSVGContent):
        (WebCore::SVGRenderSupport::layoutChildren):
        * rendering/svg/SVGRenderTreeAsText.cpp:
        (WebCore::writeStyle):
        (WebCore::operator<<):
        (WebCore::write):
        * rendering/svg/SVGRenderTreeAsText.h:
        * rendering/svg/SVGTextRunRenderingContext.cpp:
        (WebCore::SVGTextRunRenderingContext::drawSVGGlyphs):
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::svgAttributeChanged):
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::svgAttributeChanged):
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::svgAttributeChanged):
        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::svgAttributeChanged):
        (WebCore::SVGPathElement::pathSegListChanged):
        (WebCore::SVGPathElement::createRenderer):
        * svg/SVGPathElement.h:
        * svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::svgAttributeChanged):
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::svgAttributeChanged):
        (WebCore::SVGRectElement::createRenderer):
        * svg/SVGRectElement.h:

2011-10-19  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Unreviewed. Fix missing </File> tag in Windows WebCore project file.

        * WebCore.vcproj/WebCore.vcproj:

2011-10-19  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: [Chromium] Add an ability to show the objects that were allocated between snapshot N-2 and snapshot N-1 and still alive in snapshot N.
        https://bugs.webkit.org/show_bug.cgi?id=61178

        This ability will help us to see only the leaked objects.
        Scenario:
        1) do an action on inspected page which leaks javascript data;
        2) make snapshot;
        3) repeat first two steps three or more times;
        4) select the last snapshot and select the filter 'Objects allocated between Snapshot 1 and Snapshot2' instead of 'All objects'.
        The view shows the object that were allocated between snapshot N-2 and snapshot N-1 and still alive in snapshot N

        Reviewed by Pavel Feldman.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/DetailedHeapshotGridNodes.js:
        (WebInspector.HeapSnapshotConstructorNode):
        (WebInspector.HeapSnapshotConstructorNode.prototype._createNodesProvider):
        * inspector/front-end/DetailedHeapshotView.js:
        (WebInspector.HeapSnapshotConstructorsDataGrid):
        (WebInspector.HeapSnapshotConstructorsDataGrid.prototype.setDataSource):
        (WebInspector.HeapSnapshotConstructorsDataGrid.prototype.populateChildren):
        (WebInspector.HeapSnapshotConstructorsDataGrid.prototype._filterSelectIndexChanged.firstSnapshotLoaded):
        (WebInspector.HeapSnapshotConstructorsDataGrid.prototype._filterSelectIndexChanged.secondSnapshotLoaded):
        (WebInspector.HeapSnapshotConstructorsDataGrid.prototype._filterSelectIndexChanged):
        (WebInspector.HeapSnapshotDiffDataGrid.prototype._baseProfileIndexChanged):
        (WebInspector.HeapSnapshotDiffDataGrid.prototype.populateChildren):
        (WebInspector.DetailedHeapshotView.profileCallback):
        (WebInspector.DetailedHeapshotView):
        (WebInspector.DetailedHeapshotView.prototype.get statusBarItems):
        (WebInspector.DetailedHeapshotView.prototype._changeBase):
        (WebInspector.DetailedHeapshotView.prototype._changeFilter):
        (WebInspector.DetailedHeapshotView.prototype._loadProfileByIndex):
        (WebInspector.DetailedHeapshotView.prototype._changeView):
        (WebInspector.DetailedHeapshotView.prototype._updateFilterOptions):
        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype.dispose):
        (WebInspector.HeapSnapshot.prototype.get maxNodeId):
        (WebInspector.HeapSnapshot.prototype.aggregates):
        (WebInspector.HeapSnapshot.prototype._buildAggregates):
        (WebInspector.HeapSnapshot.prototype._sortAggregateIndexes):
        (WebInspector.HeapSnapshot.prototype.createNodesProviderForClass):
        (WebInspector.HeapSnapshot.prototype.updateStaticData):
        * inspector/front-end/HeapSnapshotProxy.js:
        (WebInspector.HeapSnapshotWorker):
        (WebInspector.HeapSnapshotProxy.prototype.aggregates):
        (WebInspector.HeapSnapshotProxy.prototype.createNodesProviderForClass):
        (WebInspector.HeapSnapshotProxy.prototype.get maxNodeId):
        (WebInspector.HeapSnapshotProxy.prototype.startLoading):

2011-10-19  Alexander Pavlov  <apavlov@chromium.org>

        Strip trailing whitespace in the WebCore/css C++ code.
        https://bugs.webkit.org/show_bug.cgi?id=70410

        Reviewed by Dirk Schulze.

        Only affected file names retained below for brevity.
        Multiline boolean expression were fixed where necessary to avoid patch style violations.

        * css/CSSBorderImageSliceValue.cpp:
        * css/CSSBorderImageSliceValue.h:
        * css/CSSBorderImageValue.cpp:
        * css/CSSCanvasValue.cpp:
        * css/CSSCanvasValue.h:
        * css/CSSComputedStyleDeclaration.cpp:
        * css/CSSCursorImageValue.cpp:
        * css/CSSFontFace.cpp:
        * css/CSSFontFace.h:
        * css/CSSFontFaceSource.cpp:
        * css/CSSFontFaceSource.h:
        * css/CSSFontFaceSrcValue.cpp:
        * css/CSSFontFaceSrcValue.h:
        * css/CSSFontSelector.cpp:
        * css/CSSFontSelector.h:
        * css/CSSFunctionValue.cpp:
        * css/CSSFunctionValue.h:
        * css/CSSGradientValue.cpp:
        * css/CSSGradientValue.h:
        * css/CSSImageGeneratorValue.cpp:
        * css/CSSImageGeneratorValue.h:
        * css/CSSImageValue.cpp:
        * css/CSSImageValue.h:
        * css/CSSImportRule.cpp:
        * css/CSSInitialValue.cpp:
        * css/CSSInitialValue.h:
        * css/CSSMutableStyleDeclaration.cpp:
        * css/CSSMutableStyleDeclaration.h:
        * css/CSSParser.cpp:
        * css/CSSParser.h:
        * css/CSSParserValues.cpp:
        * css/CSSParserValues.h:
        * css/CSSPrimitiveValue.cpp:
        * css/CSSPrimitiveValue.h:
        * css/CSSPrimitiveValueCache.cpp:
        * css/CSSPrimitiveValueCache.h:
        * css/CSSPrimitiveValueMappings.h:
        * css/CSSProperty.cpp:
        * css/CSSProperty.h:
        * css/CSSPropertyLonghand.cpp:
        * css/CSSReflectValue.cpp:
        * css/CSSReflectValue.h:
        * css/CSSReflectionDirection.h:
        * css/CSSSegmentedFontFace.cpp:
        * css/CSSSegmentedFontFace.h:
        * css/CSSSelector.cpp:
        * css/CSSSelector.h:
        * css/CSSSelectorList.cpp:
        * css/CSSSelectorList.h:
        * css/CSSStyleApplyProperty.cpp:
        * css/CSSStyleDeclaration.h:
        * css/CSSStyleSelector.cpp:
        * css/CSSStyleSelector.h:
        * css/CSSStyleSheet.cpp:
        * css/CSSTimingFunctionValue.cpp:
        * css/CSSTimingFunctionValue.h:
        * css/CSSUnicodeRangeValue.cpp:
        * css/CSSUnicodeRangeValue.h:
        * css/CSSValueList.cpp:
        * css/CSSWrapShapes.cpp:
        * css/CSSWrapShapes.h:
        * css/FontValue.cpp:
        * css/MediaList.cpp:
        * css/MediaQuery.cpp:
        * css/MediaQuery.h:
        * css/MediaQueryEvaluator.h:
        * css/MediaQueryExp.cpp:
        * css/MediaQueryExp.h:
        * css/Pair.h:
        * css/SVGCSSComputedStyleDeclaration.cpp:
        * css/SVGCSSParser.cpp:
        * css/SVGCSSStyleSelector.cpp:
        * css/SelectorChecker.cpp:
        * css/SelectorChecker.h:
        * css/StyleBase.cpp:
        * css/StyleMedia.cpp:
        * css/StyleMedia.h:
        * css/StyleSheetList.cpp:
        * css/StyleSheetList.h:
        * css/WebKitCSSFilterValue.cpp:
        * css/WebKitCSSFilterValue.h:
        * css/WebKitCSSKeyframeRule.cpp:
        * css/WebKitCSSKeyframeRule.h:
        * css/WebKitCSSKeyframesRule.cpp:
        * css/WebKitCSSKeyframesRule.h:
        * css/WebKitCSSMatrix.cpp:
        * css/WebKitCSSMatrix.h:
        * css/WebKitCSSTransformValue.cpp:
        * css/WebKitCSSTransformValue.h:

2011-10-19  Dirk Schulze  <krit@webkit.org>

        Make FilterEffect::apply() independent of image data management
        https://bugs.webkit.org/show_bug.cgi?id=70350

        Reviewed by Zoltan Herczeg.
        
        FilterEffect::apply() needs to be independent from the image data management in FilterEffect.
        This allows implementing effective hardware accelerated alternatives, like OpenGL, CI or OpenCL
        based filters, to the software rendering. The software rendering code will be used as fallback
        and moves to platformApplySoftware().

        The patch does not change the behavior of SVG filters. Did not add new test cases.

        * platform/graphics/filters/FEBlend.cpp: Renamed apply() to platformApplyGeneric()
            and removed validity checks that are done by FilterEffect::apply(). This is a
            recurring pattern for all following effects. 
        (WebCore::FEBlend::platformApplySoftware):
        * platform/graphics/filters/FEBlend.h:
        * platform/graphics/filters/FEColorMatrix.cpp:
        (WebCore::FEColorMatrix::platformApplySoftware):
        * platform/graphics/filters/FEColorMatrix.h:
        * platform/graphics/filters/FEComponentTransfer.cpp:
        (WebCore::FEComponentTransfer::platformApplySoftware):
        * platform/graphics/filters/FEComponentTransfer.h:
        * platform/graphics/filters/FEComposite.cpp:
        (WebCore::FEComposite::platformApplySoftware):
        * platform/graphics/filters/FEComposite.h:
        * platform/graphics/filters/FEConvolveMatrix.cpp:
        (WebCore::FEConvolveMatrix::platformApplySoftware):
        * platform/graphics/filters/FEConvolveMatrix.h:
        * platform/graphics/filters/FEDisplacementMap.cpp:
        (WebCore::FEDisplacementMap::platformApplySoftware):
        * platform/graphics/filters/FEDisplacementMap.h:
        * platform/graphics/filters/FEDropShadow.cpp:
        (WebCore::FEDropShadow::platformApplySoftware):
        * platform/graphics/filters/FEDropShadow.h:
        * platform/graphics/filters/FEFlood.cpp:
        (WebCore::FEFlood::platformApplySoftware):
        * platform/graphics/filters/FEFlood.h:
        * platform/graphics/filters/FEGaussianBlur.cpp:
        (WebCore::FEGaussianBlur::platformApplySoftware):
        * platform/graphics/filters/FEGaussianBlur.h:
        * platform/graphics/filters/FELighting.cpp:
        (WebCore::FELighting::platformApplySoftware):
        * platform/graphics/filters/FELighting.h:
        * platform/graphics/filters/FEMerge.cpp:
        (WebCore::FEMerge::platformApplySoftware):
        * platform/graphics/filters/FEMerge.h:
        * platform/graphics/filters/FEMorphology.cpp:
        (WebCore::FEMorphology::platformApplySoftware):
        * platform/graphics/filters/FEMorphology.h:
        * platform/graphics/filters/FEOffset.cpp:
        (WebCore::FEOffset::platformApplySoftware):
        * platform/graphics/filters/FEOffset.h:
        * platform/graphics/filters/FETile.cpp:
        (WebCore::FETile::platformApplySoftware):
        * platform/graphics/filters/FETile.h:
        * platform/graphics/filters/FETurbulence.cpp:
        (WebCore::FETurbulence::platformApplySoftware):
        * platform/graphics/filters/FETurbulence.h:
        * platform/graphics/filters/FilterEffect.cpp: Added non-virtual apply() function. This will call the platform specific apply functions,
            which need to be virtual now.
        (WebCore::FilterEffect::hasResult): Added a comment for new implementations. This function needs to be updated for every new port.
        (WebCore::FilterEffect::apply):
        (WebCore::FilterEffect::createImageBufferResult): Removed determineAbsolutePaintRect() call. This is done in apply() now.
        (WebCore::FilterEffect::createUnmultipliedImageResult): Ditto.
        (WebCore::FilterEffect::createPremultipliedImageResult): Ditto.
        * platform/graphics/filters/FilterEffect.h:
        * platform/graphics/filters/SourceAlpha.cpp:
        (WebCore::SourceAlpha::platformApplySoftware):
        * platform/graphics/filters/SourceAlpha.h:
        * platform/graphics/filters/SourceGraphic.cpp:
        (WebCore::SourceGraphic::platformApplySoftware):
        * platform/graphics/filters/SourceGraphic.h:
        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::platformApplySoftware):
        * svg/graphics/filters/SVGFEImage.h:

2011-10-19  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Enable caseSensitive search / Regex support in advanced search.
        https://bugs.webkit.org/show_bug.cgi?id=70335

        Reviewed by Pavel Feldman.

        * inspector/ContentSearchUtils.cpp:
        (WebCore::ContentSearchUtils::createSearchRegex):
        (WebCore::ContentSearchUtils::searchInTextByLines):
        * inspector/ContentSearchUtils.h:
        * inspector/Inspector.json:
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::searchInContent):
        * inspector/InspectorDebuggerAgent.h:
        * inspector/InspectorPageAgent.cpp:
        (WebCore::InspectorPageAgent::searchInResource):
        * inspector/InspectorPageAgent.h:
        * inspector/front-end/AdvancedSearchController.js:
        (WebInspector.SearchView):
        (WebInspector.SearchView.prototype.get searchConfig):
        (WebInspector.FileBasedSearchResultsPane.prototype._createSearchRegex):
        (WebInspector.FileBasedSearchResultsPane.prototype.addSearchResult):
        (WebInspector.FileBasedSearchResultsPane.SearchResult):
        * inspector/front-end/ConsolePanel.js:
        (WebInspector.ConsolePanel.prototype.performSearch):
        * inspector/front-end/ContentProviders.js:
        (WebInspector.ScriptContentProvider.prototype.searchInContent):
        (WebInspector.ConcatenatedScriptsContentProvider.prototype.searchInContent.searchCallback):
        (WebInspector.ConcatenatedScriptsContentProvider.prototype.searchInContent):
        (WebInspector.ResourceContentProvider.prototype.searchInContent):
        (WebInspector.CompilerSourceMappingContentProvider.prototype.searchInContent):
        (WebInspector.StaticContentProvider.prototype.searchInContent):
        * inspector/front-end/ElementsTreeOutline.js:
        ():
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkLogView.prototype.performSearch):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.searchInContent):
        * inspector/front-end/Script.js:
        (WebInspector.Script.prototype.searchInContent):
        * inspector/front-end/ScriptsSearchScope.js:
        (WebInspector.ScriptsSearchScope.prototype.performSearch.searchCallbackWrapper):
        (WebInspector.ScriptsSearchScope.prototype.performSearch):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.createSearchRegex):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype.searchInContent):
        (WebInspector.ContentProvider.prototype.searchInContent):
        * inspector/front-end/inspector.css:
        (.search-view .search-panel input[type="search"].search-config-search):
        (.search-view .search-panel label.search-config-label):
        (.search-view .search-panel input[type="checkbox"].search-config-checkbox):
        * inspector/front-end/utilities.js:
        ():

2011-10-19  Andreas Kling  <kling@webkit.org>

        MediaList: Remove inheritance from StyleBase.
        https://bugs.webkit.org/show_bug.cgi?id=70203

        Reviewed by Darin Adler.

        * css/MediaList.h:
        (WebCore::MediaList::parentStyleSheet):
        (WebCore::MediaList::setParentStyleSheet):
        * css/MediaList.cpp:
        (WebCore::MediaList::MediaList):
        (WebCore::MediaList::notifyChanged):

            Change MediaList to no longer inherit from StyleBase. The parent()/setParent()
            mechanism was replaced by explicit parentStyleSheet()/setParentStyleSheet().

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::CSSImportRule):
        (WebCore::CSSImportRule::~CSSImportRule):
        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::CSSMediaRule):
        (WebCore::CSSMediaRule::~CSSMediaRule):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().
            CSSRules are never moved between stylesheets, so the parent style sheet pointer
            is valid for the MediaList's lifetime.

        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::~StyleSheet):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().

        (WebCore::StyleSheet::setMedia):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().
            Assert that the parent sheet is either null, or this, as MediaLists should never
            be reparented to other sheets.
            Assert that the StyleSheet is indeed a CSSStyleSheet.  XSLStyleSheet inherits from
            StyleSheet, but it shouldn't be using the MediaList.

        * bindings/js/JSDOMBinding.h:
        (WebCore::root):

            Add MediaList* specific overload for root() since it can't fall back
            to root(StyleBase*) anymore.

        * WebCore.xcodeproj/project.pbxproj:

            Add some PrivateHeaders to accomodate the JSDOMBinding.h changes.

        * css/CSSMediaRule.h:

            Remove unnecessary forward-declaration of MediaList.

2011-10-19  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Console messages for XHR logging should show call stack if available.
        https://bugs.webkit.org/show_bug.cgi?id=70324

        Reviewed by Pavel Feldman.

        * inspector/front-end/ConsoleMessage.js:
        (WebInspector.ConsoleMessageImpl.prototype._formatMessage):

2011-10-13  Pavel Podivilov  <podivilov@chromium.org>

        Web Inspector: move JS specific popover handling to JavaScriptSourceFrame.
        https://bugs.webkit.org/show_bug.cgi?id=70033

        Reviewed by Pavel Feldman.

        * inspector/front-end/DebuggerPresentationModel.js:
        (WebInspector.DebuggerPresentationModel.prototype.uiSourceCodes):
        (WebInspector.DebuggerPresentationModel.prototype.get paused):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame):
        (WebInspector.JavaScriptSourceFrame.prototype.shouldShowPopover):
        (WebInspector.JavaScriptSourceFrame.prototype.onShowPopover.showObjectPopover):
        (WebInspector.JavaScriptSourceFrame.prototype.onShowPopover):
        (WebInspector.JavaScriptSourceFrame.prototype.onHidePopover):
        (WebInspector.JavaScriptSourceFrame.prototype._highlightExpression):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._createSourceFrame):
        (WebInspector.SourceFrameDelegateForScriptsPanel):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame):
        (WebInspector.SourceFrame.prototype.willHide):
        (WebInspector.SourceFrame.prototype._initializeTextViewer):
        (WebInspector.SourceFrame.prototype._getPopoverAnchor):
        (WebInspector.SourceFrame.prototype.get readOnly):
        (WebInspector.SourceFrame.prototype._setReadOnly):
        (WebInspector.SourceFrame.prototype.contentChanged):
        (WebInspector.SourceFrame.prototype.shouldShowPopover):
        (WebInspector.SourceFrame.prototype.onShowPopover):
        (WebInspector.SourceFrame.prototype.onHidePopover):

2011-10-19  Tomasz Morawski  <t.morawski@samsung.com>

        [EFL][WK2] Added missing files to build WebKit2 EFL
        https://bugs.webkit.org/show_bug.cgi?id=70312

        Reviewed by Ryosuke Niwa.

        Added missing files to WebCore/CMakeListEfl.txt script:
        - platform/network/soup/CredentialStorageSoup.cpp
        - platform/network/soup/ProxyServerSoup.cpp
        Fixes few linking time errors.

        * CMakeListsEfl.txt:

2011-10-19  Kentaro Hara  <haraken@chromium.org>

        Rename AllowAllocation to ConstructorMode
        https://bugs.webkit.org/show_bug.cgi?id=70397

        Reviewed by Adam Barth.

        The name 'AllowAllocation' is confusing (See discussion here: bug 70015).
        This patch renames 'AllowAllocation' to 'ConstructorMode' to clarify that
        this class is for distinguishing the following two situations:
         1. A programmer allocates an object via "new X"; X is a function with a C++ constructCallback.
         2. C++ allocates an object via the function template and tries to wrap the object with a JS flavor.

        Tests: fast/events/constructors/*

        * bindings/scripts/CodeGeneratorV8.pm: Renamed AllowAllocation to ConstructorMode.
        (GenerateConstructorCallback):
        * bindings/scripts/test/V8/V8TestInterface.cpp: Updated a run-binding-tests result.
        (WebCore::V8TestInterface::constructorCallback):
        * bindings/v8/V8Binding.cpp: Renamed AllowAllocation to ConstructorMode.
        (WebCore::V8BindingPerIsolateData::V8BindingPerIsolateData):
        * bindings/v8/V8Binding.h: Ditto.
        (WebCore::ConstructorMode::ConstructorMode):
        (WebCore::ConstructorMode::~ConstructorMode):
        (WebCore::ConstructorMode::current):
        (WebCore::SafeAllocation::newInstance):
        * bindings/v8/V8Proxy.cpp: Ditto.
        (WebCore::V8Proxy::checkNewLegal):
        * bindings/v8/custom/V8EventConstructors.cpp: Ditto.
        (WebCore::constructV8Event):

2011-10-19  Tomasz Morawski  <t.morawski@samsung.com>

        [EFL] Added missing dummy platformDescription function
        https://bugs.webkit.org/show_bug.cgi?id=70310

        Reviewed by Ryosuke Niwa.

        Added dummy platformDescription function needed to compile WK2.

        * platform/efl/ContextMenuEfl.cpp:
        (WebCore::ContextMenu::platformDescription):

2011-10-18  Kentaro Hara  <haraken@chromium.org>

        Generate a SharedWorker constructor of V8 using [Constructor] IDL
        https://bugs.webkit.org/show_bug.cgi?id=67879

        Reviewed by Hajime Morita.

        Spec: http://dev.w3.org/html5/workers/#shared-workers-and-the-sharedworker-interface
        This patch changed SharedWorker::create(..., context, ec) to
        SharedWorker::create(context, ..., ec), since a parameter specified by [CallWith]
        should come at the beginning (c.f. bug 69799).

        Test: ui_tests:WorkerTest.FLAKY_SharedWorkerFastConstructor
              ui_tests:WorkerTest.FLAKY_SharedWorkerFastName

        * WebCore.gypi: Removed bindings/v8/custom/V8SharedWorkerCustom.cpp
        * WebCore.pro: Ditto.
        * bindings/js/JSSharedWorkerCustom.cpp: Moved ScriptExecutionContext parameter to the beginning.
        (WebCore::JSSharedWorkerConstructor::constructJSSharedWorker):
        * bindings/v8/custom/V8SharedWorkerCustom.cpp: Removed.
        * workers/SharedWorker.cpp: Moved ScriptExecutionContext parameter to the beginning.
        (WebCore::SharedWorker::create): Ditto.
        * workers/SharedWorker.h: Ditto.
        * workers/SharedWorker.idl: Added [Constructor] IDL.

2011-10-18  Johnny Ding  <jnd@chromium.org>

        Implement NSProcessInfo::systemUptime on Mac Leopard.
        https://bugs.webkit.org/show_bug.cgi?id=66577

        Reviewed by Tony Chang.

        * WebCore.gyp/WebCore.gyp:
        * platform/chromium/ScrollAnimatorChromiumMac.mm:
        (-[NSProcessInfo systemUptime]):

2011-10-18  Sam Weinig  <sam@webkit.org>

        Try to jostle the windows build back to life.

        * rendering/HitTestResult.h:

2011-10-18  Anders Carlsson  <andersca@apple.com>

        Assertion failure when going back in page with navigated subframes
        https://bugs.webkit.org/show_bug.cgi?id=70389
        <rdar://problem/8988444>

        Reviewed by Darin Adler.

        Test: fast/history/history-back-twice-with-subframes-assert.html

        If a single navigation ends up loading multiple frame, the first committed frame will
        end up calling recursiveUpdateForCommit on the main frame which will null out the provisional item
        for all frames on the page. This means that it can null out the provisional item for any frames
        that are still yet to be committed which causes the aforementioned assertion failure.

        Fix this by only nulling out the provisional history item (and saving/restoring the scroll position and
        some other things) for frames that already contain the URL that the item requested. If a frame is being loaded,
        it will null out its provisional history item when it's committed.

        * loader/HistoryController.cpp:
        (WebCore::HistoryController::recursiveUpdateForCommit):

2011-10-18  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97765.
        http://trac.webkit.org/changeset/97765
        https://bugs.webkit.org/show_bug.cgi?id=70388

        "broke webkit_unit_tests, http/tests/xmlhttprequest
        /xmlhttprequest-test-send-flag.html on linux debug" (Requested
        by dpranke on #webkit).

        * WebCore.gypi:
        * loader/DocumentThreadableLoader.cpp:
        (WebCore::DocumentThreadableLoader::create):
        (WebCore::DocumentThreadableLoader::~DocumentThreadableLoader):
        (WebCore::DocumentThreadableLoader::cancel):
        (WebCore::DocumentThreadableLoader::setDefersLoading):
        (WebCore::DocumentThreadableLoader::willSendRequest):
        (WebCore::DocumentThreadableLoader::didSendData):
        (WebCore::DocumentThreadableLoader::didReceiveResponse):
        (WebCore::DocumentThreadableLoader::didReceiveData):
        (WebCore::DocumentThreadableLoader::didReceiveCachedMetadata):
        (WebCore::DocumentThreadableLoader::didFinishLoading):
        (WebCore::DocumentThreadableLoader::didFail):
        (WebCore::DocumentThreadableLoader::preflightSuccess):
        (WebCore::DocumentThreadableLoader::loadRequest):
        * loader/DocumentThreadableLoader.h:
        * loader/cache/CachedRawResource.cpp:
        (WebCore::CachedRawResource::CachedRawResource):
        (WebCore::CachedRawResource::data):
        * loader/cache/CachedRawResource.h:
        * loader/cache/CachedResource.cpp:
        (WebCore::CachedResource::CachedResource):
        * loader/cache/CachedResource.h:
        (WebCore::CachedResource::setRequestedFromNetworkingLayer):
        * loader/cache/CachedResourceClient.h:
        * loader/cache/CachedResourceRequest.cpp:
        (WebCore::CachedResourceRequest::~CachedResourceRequest):
        (WebCore::CachedResourceRequest::willSendRequest):
        (WebCore::CachedResourceRequest::didFinishLoading):
        (WebCore::CachedResourceRequest::didReceiveResponse):
        (WebCore::CachedResourceRequest::didReceiveData):
        * loader/cache/CachedResourceRequest.h:
        * loader/chromium/CachedRawResourceChromium.cpp: Removed.
        * loader/chromium/CachedResourceRequestChromium.cpp: Removed.
        * loader/chromium/DocumentThreadableLoaderChromium.cpp:
        (WebCore::DocumentThreadableLoader::didDownloadData):
        * loader/icon/IconLoader.h:
        * platform/network/BlobResourceHandle.cpp:
        (WebCore::BlobResourceHandle::notifyResponse):

2011-10-18  Mark Hahnenberg  <mhahnenberg@apple.com>

        Rename static put to putByIndex
        https://bugs.webkit.org/show_bug.cgi?id=70281

        Reviewed by Geoffrey Garen.

        No new tests.

        Renaming versions of deleteProperty that use an unsigned as the property
        name to "deletePropertyByIndex" in preparation for adding them to the 
        MethodTable, which requires unique names for each method.

        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):
        (GenerateImplementation):
        * bridge/runtime_array.cpp:
        (JSC::RuntimeArray::putVirtual):
        (JSC::RuntimeArray::putByIndex):
        * bridge/runtime_array.h:

2011-10-18  Sam Weinig  <sam@webkit.org>

        Fix the build.

        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::absolutePDFURL):
        Fix typo.

2011-10-18  Alexis Menard  <alexis.menard@openbossa.org>

        Unreviewed warning fix after https://bugs.webkit.org/show_bug.cgi?id=70269

        * WebCore.pro:

2011-10-18  Alexey Proskuryakov  <ap@apple.com>

        Expose PDF information in hit test result
        https://bugs.webkit.org/show_bug.cgi?id=70353

        Reviewed by Sam Weinig.

        * WebCore.exp.in:
        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::absolutePDFURL):
        * rendering/HitTestResult.h:
        Added HitTestResult::absolutePDFURL(). It will contain a URL when over a PDF object or embed;
        not sure if we want this for PDFImageDocuments.

2011-10-18  Adrienne Walker  <enne@google.com>

        [chromium] Preserve offscreen tiles instead of immediately recycling them
        https://bugs.webkit.org/show_bug.cgi?id=70352

        Reviewed by James Robinson.

        Tested by existing layout tests.

        Prior to having a TextureManager class, tiled layers recycled their
        textures internally to avoid reallocation. Unfortunately, it recycled
        these tiles as soon as they went offscreen, even if they were still
        valid. Instead, keep tiles around forever, letting the TextureManager
        decide (via LRU) when to reclaim the underlying textures. This will
        improve scrolling performance due to not needing to repaint tiles.

        This change does lead to more texture reallocation for any textures
        that get reclaimed, but the command buffer implementation already
        pools and reuses texture ids, so it should not introduce additional
        flush syncs. If there's any performance penalty, it'll be at the
        driver level, but I'd prefer to measure that there's a problem before
        prematurely optimizing and adding complexity to the TextureManager.

        * platform/graphics/chromium/TiledLayerChromium.cpp:
        (WebCore::TiledLayerChromium::cleanupResources):
        (WebCore::TiledLayerChromium::createTile):
        (WebCore::TiledLayerChromium::prepareToUpdate):
        * platform/graphics/chromium/TiledLayerChromium.h:

2011-10-18  Adam Klein  <adamk@chromium.org>

        [MutationObservers] Implement WebKitMutationObserver.observe for characterData changes
        https://bugs.webkit.org/show_bug.cgi?id=68957

        Reviewed by Ryosuke Niwa.

        Test: fast/mutation/observe-characterdata.html

        * dom/CharacterData.cpp:
        (WebCore::CharacterData::dispatchModifiedEvent):

2011-10-18  Scott Byer  <scottbyer@chromium.org>

        Scroll animator tracing
        https://bugs.webkit.org/show_bug.cgi?id=70280

        Reviewed by James Robinson.

        No functional difference, no test needed.

        * platform/ScrollAnimatorNone.cpp:
        (WebCore::ScrollAnimatorNone::scroll):
        (WebCore::ScrollAnimatorNone::animationTimerFired):

2011-10-18  James Robinson  <jamesr@chromium.org>

        [chromium] Remove USE(THREADED_COMPOSITING) from the tree, this is controlled by a runtime setting
        https://bugs.webkit.org/show_bug.cgi?id=70356

        Reviewed by Kenneth Russell.

        * platform/graphics/chromium/cc/CCLayerTreeHost.h:

2011-10-18  Ojan Vafai  <ojan@chromium.org>

        cleanup some FIXMEs in RenderFlexibleBox
        https://bugs.webkit.org/show_bug.cgi?id=70374

        Reviewed by Darin Adler.

        No new tests. Existing tests cover all changes.

        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::layoutBlock):
        (WebCore::RenderFlexibleBox::flowAwareBorderAndPaddingLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareMarginLogicalHeightForChild):
        * rendering/RenderFlexibleBox.h:
        Removed the FIXME to implement computePreferredLogicalWidths. It doesn't
        seem to be necessary, at least not with the current test cases.

2011-10-18  Joseph Pecoraro  <joepeck@webkit.org>

        Web Inspector: Some localizedStrings.js Updates
        https://bugs.webkit.org/show_bug.cgi?id=70365

        Reviewed by Darin Adler.

        Fixed syntax issue, added missing strings, and removed a duplicate.

        * English.lproj/localizedStrings.js:

2011-10-18  Tony Chang  <tony@chromium.org>

        fix unused-but-set-variable warnings in WebCore
        https://bugs.webkit.org/show_bug.cgi?id=70344

        Reviewed by Adam Barth.

        This is a new compiler warning in gcc 4.6.

        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore::V8DOMWrapper::isWrapperOfType):
        * platform/graphics/chromium/ComplexTextControllerLinux.cpp:
        (WebCore::ComplexTextController::normalizeSpacesAndMirrorChars):

2011-10-18  Dan Bernstein  <mitz@apple.com>

        Certain column-rule styles render incorrectly in vertical writing modes
        https://bugs.webkit.org/show_bug.cgi?id=70362

        Reviewed by Darin Adler.

        Test: fast/multicol/vertical-rl/rule-style.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintColumnRules): Use the correct border sides for vertical writing modes.

2011-10-18  Anna Cavender  <annacc@chromium.org>

        Fix broken binding tests by changing G_MAXUSHORT to G_MAXUINT in WebKitDOMTestObj.cpp.
        https://bugs.webkit.org/show_bug.cgi?id=70267

        Reviewed by Daniel Bates.

        Tests: fixing WebKitDOMTestObj.cpp

        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (webkit_dom_test_obj_class_init): Change G_MAXUSHORT to G_MAXUINT

2011-10-18  Julien Chaffraix  <jchaffraix@webkit.org>

        Crash in RenderDeprecatedFlexibleBox::layoutHorizontalBox
        https://bugs.webkit.org/show_bug.cgi?id=70183

        Reviewed by David Hyatt.

        Test: fast/flexbox/layoutHorizontal-crash.html

        The deferred scroll information update logic was not updated when an object was destroy'ed.

        The fix is very simple. As the deferred logic was only used with deprecated flexbox, it is a
        pretty uncommon cases so let's optimize the new code for the common case.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::willBeDestroyed):

2011-10-18  Adam Klein  <adamk@chromium.org>

        [MutationObservers] Clean up MutationObserver code in Node
        https://bugs.webkit.org/show_bug.cgi?id=70349

        Reviewed by Ryosuke Niwa.

        Three small cleanups.

        No new tests, no behavior change.

        * dom/Node.cpp:
        (WebCore::Node::clearRareData): Use indices instead of iterator in for loop; fix typo.
        (WebCore::Node::registerMutationObserver): Inline single call to Node::ensureMutationObserverEntries.
        * dom/Node.h: Make mutationObserverEntries private.

2011-10-18  James Robinson  <jamesr@chromium.org>

        [chromium] Fix shutdown race when posting main thread task to CCThreadProxy and enable tests
        https://bugs.webkit.org/show_bug.cgi?id=70161

        Reviewed by David Levin.

        Adds a weak pointer mechanism to cancel main thread tasks posted to CCThreadProxy instances from the compositor
        thread. Previously there was a race condition where main thread tasks could run even after the CCThreadProxy was
        destroyed.

        This race does not exist in the other direction because when tearing down a CCThreadProxy we first post a quit
        task to the compositor thread and then suspend execution of the main thread until all compositor tasks for the
        CCThreadProxy have been drained.

        Covered by the now-enabled CCLayerTreeHostTest* unit tests.

        * WebCore.gypi:
        * platform/graphics/chromium/cc/CCScopedMainThreadProxy.h: Added.
        (WebCore::CCScopedMainThreadProxy::create):
        (WebCore::CCScopedMainThreadProxy::postTask):
        (WebCore::CCScopedMainThreadProxy::shutdown):
        (WebCore::CCScopedMainThreadProxy::CCScopedMainThreadProxy):
        (WebCore::CCScopedMainThreadProxy::runTaskIfNotShutdown):
        * platform/graphics/chromium/cc/CCThreadProxy.cpp:
        (WebCore::CCThreadProxy::CCThreadProxy):
        (WebCore::CCThreadProxy::~CCThreadProxy):
        (WebCore::CCThreadProxy::createBeginFrameAndCommitTaskOnCCThread):
        * platform/graphics/chromium/cc/CCThreadProxy.h:

2011-10-13  Ojan Vafai  <ojan@chromium.org>

        implement flex-flow:column
        https://bugs.webkit.org/show_bug.cgi?id=70082

        Reviewed by David Hyatt.

        There's still a bug with a FIXME where we don't compute the right
        size for the container of the flexbox in the presence of
        orthogonal flows. That's the cause of all the failing cases
        in the tests.

        Tests: css3/flexbox/flex-flow-border.html
               css3/flexbox/flex-flow-margins.html
               css3/flexbox/flex-flow-orientations.html
               css3/flexbox/flex-flow-overflow.html
               css3/flexbox/flex-flow-padding.html
               css3/flexbox/flex-flow.html

        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::layoutBlock):
        (WebCore::RenderFlexibleBox::hasOrthogonalFlow):
        (WebCore::RenderFlexibleBox::isColumnFlow):
        (WebCore::RenderFlexibleBox::isHorizontalFlow):
        (WebCore::RenderFlexibleBox::isLeftToRightFlow):
        Use isHorizontalFlow and isLeftToRightFlow so that methods like
        flowAwareBorderStart look exactly like borderStart with
        isHorizontalWritingMode and isLeftToRightDirection replaced.

        (WebCore::RenderFlexibleBox::setFlowAwareLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareLogicalHeightForChild):
        (WebCore::RenderFlexibleBox::flowAwareLogicalWidthForChild):
        (WebCore::RenderFlexibleBox::flowAwareLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareLogicalWidth):
        (WebCore::RenderFlexibleBox::flowAwareContentLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareContentLogicalWidth):
        (WebCore::RenderFlexibleBox::transformedWritingMode):
        Transform the writing-mode based of the flex-flow and direction
        values. That methods like flowAwareBorderBefore look exactly like
        borderBefore, except it switches over a different value.

        (WebCore::RenderFlexibleBox::flowAwareBorderStart):
        (WebCore::RenderFlexibleBox::flowAwareBorderBefore):
        (WebCore::RenderFlexibleBox::flowAwareBorderAfter):
        (WebCore::RenderFlexibleBox::flowAwarePaddingStart):
        (WebCore::RenderFlexibleBox::flowAwarePaddingBefore):
        (WebCore::RenderFlexibleBox::flowAwarePaddingAfter):
        (WebCore::RenderFlexibleBox::flowAwareMarginStartForChild):
        (WebCore::RenderFlexibleBox::flowAwareMarginEndForChild):
        (WebCore::RenderFlexibleBox::flowAwareMarginBeforeForChild):
        (WebCore::RenderFlexibleBox::flowAwareMarginAfterForChild):
        (WebCore::RenderFlexibleBox::setFlowAwareMarginStartForChild):
        (WebCore::RenderFlexibleBox::setFlowAwareMarginEndForChild):
        (WebCore::RenderFlexibleBox::layoutAndPlaceChildrenInlineDirection):
        (WebCore::RenderFlexibleBox::alignChildrenBlockDirection):
        * rendering/RenderFlexibleBox.h:

2011-10-18  Shawn Singh  <shawnsingh@chromium.org>

        [chromium] Tracking update rects in LayerChromium and CCLayerImpl.
        https://bugs.webkit.org/show_bug.cgi?id=69441

        Reviewed by James Robinson.

        This patch does not do much on its own, but is just part 1 of a
        string of other patches which will use these rects for
        visualization and scissoring.  The appropriate testing will be
        associated with those patches.

        * platform/graphics/chromium/Canvas2DLayerChromium.cpp:
        (WebCore::Canvas2DLayerChromium::updateCompositorResources):
        * platform/graphics/chromium/LayerChromium.cpp:
        (WebCore::LayerChromium::pushPropertiesTo):
        * platform/graphics/chromium/LayerChromium.h:
        * platform/graphics/chromium/TiledLayerChromium.cpp:
        (WebCore::TiledLayerChromium::cleanupResources):
        (WebCore::TiledLayerChromium::updateCompositorResources):
        (WebCore::TiledLayerChromium::pushPropertiesTo):
        (WebCore::TiledLayerChromium::prepareToUpdate):
        * platform/graphics/chromium/TiledLayerChromium.h:
        * platform/graphics/chromium/VideoLayerChromium.cpp:
        (WebCore::VideoLayerChromium::updateCompositorResources):
        * platform/graphics/chromium/WebGLLayerChromium.cpp:
        (WebCore::WebGLLayerChromium::updateCompositorResources):
        * platform/graphics/chromium/cc/CCLayerImpl.h:
        (WebCore::CCLayerImpl::updateRect):
        (WebCore::CCLayerImpl::setUpdateRect):

2011-10-18  Anna Cavender  <annacc@chromium.org>

        Change CodeGeneratorGObject.pm to use g_value_get_uint() instead of g_value_get_ushort()
        for IDL attributes of type unsigned short.
        https://bugs.webkit.org/show_bug.cgi?id=70267

        Reviewed by Xan Lopez.

        Tests: small change to WebKitDOMTestObj.cpp

        * bindings/scripts/CodeGeneratorGObject.pm:
        (GetGValueTypeName): convert unsigned short to uint instead of ushort
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (webkit_dom_test_obj_set_property): expect g_value_get_uint instead of g_value_get_ushort
        (webkit_dom_test_obj_class_init): expect G_MAXUSHORT instead of G_MAXUINT16

2011-10-18  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: ScriptsPanel's should use similar logic to decide whether it could show an anchor location and actually showing it.
        https://bugs.webkit.org/show_bug.cgi?id=70322

        Reviewed by Pavel Feldman.

        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.canShowAnchorLocation):
        (WebInspector.ScriptsPanel.prototype._showSourceLine):

2011-10-18  Eric Carlson  <eric.carlson@apple.com>

        Use the new cached cue loader
        https://bugs.webkit.org/show_bug.cgi?id=70269

        Reviewed by Antti Koivisto.

        No new tests, no functionality changed.

        * CMakeLists.txt: Remove CueParser.cpp/h and CueParserPrivate.h.
        * GNUmakefile.list.am: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::loadTextTracks):
        (WebCore::HTMLMediaElement::textTrackReadyStateChanged): New, not implemented yet.
        (WebCore::HTMLMediaElement::textTrackModeChanged): Ditto.
        (WebCore::HTMLMediaElement::textTrackCreated): Ditto.
        (WebCore::HTMLMediaElement::textTrackAddCues): Ditto.
        (WebCore::HTMLMediaElement::textTrackRemoveCues): Ditto.
        (WebCore::HTMLMediaElement::textTrackAddCue): Ditto.
        (WebCore::HTMLMediaElement::textTrackRemoveCue): Ditto.
        * html/HTMLMediaElement.h:

        * html/HTMLTrackElement.cpp:
        (WebCore::HTMLTrackElement::load): Update for interface change
        (WebCore::HTMLTrackElement::textTrackLoadingCompleted): New, dispatch 'load' or 'error' event.
        * html/HTMLTrackElement.h:

        * html/LoadableTextTrack.cpp:
        (WebCore::LoadableTextTrack::LoadableTextTrack): Add TextTrackClient and TextTrackLoadingClient
            parameters.
        (WebCore::LoadableTextTrack::load): Make url parameter KURL instead of String. Create the 
            cue loader, trigger the load.
        (WebCore::LoadableTextTrack::newCuesAvailable): New callback from the loader. Not implemented yet.
        (WebCore::LoadableTextTrack::cueLoadingStarted): Ditto.
        (WebCore::LoadableTextTrack::cueLoadingCompleted): Ditto.
        * html/LoadableTextTrack.h:

        * html/MutableTextTrack.cpp:
        (WebCore::MutableTextTrack::MutableTextTrack): Add TextTrackClient parameter.
        * html/MutableTextTrack.h:
        (WebCore::MutableTextTrack::create):

        * html/TextTrack.cpp:
        (WebCore::TextTrack::TextTrack): Add TextTrackClient parameter.
        (WebCore::TextTrack::~TextTrack): Tell the client to remove all cues, forget the client.
        (WebCore::TextTrack::setReadyState): Tell client about ready state change.
        (WebCore::TextTrack::setMode): Tell client about mode change.
        * html/TextTrack.h:
        (WebCore::TextTrackClient::textTrackAddCues): New client interface.
        (WebCore::TextTrackClient::textTrackRemoveCues): Ditto.
        (WebCore::TextTrackClient::textTrackAddCue): Ditto.
        (WebCore::TextTrackClient::textTrackRemoveCue): Ditto.
        (WebCore::TextTrack::create):
        (WebCore::TextTrack::trackType): New.
        (WebCore::TextTrack::client): Ditto.
        (WebCore::TextTrack::setClient): Ditto.

        * html/track/CueParser.cpp: Removed.
        * html/track/CueParser.h: Removed.
        * html/track/CueParserPrivate.h: Removed.

        * html/track/WebVTTParser.cpp:
        (WebCore::WebVTTParser::fileIdentifierMaximumLength): New, return length of WebVTT file
            magic number.
        (WebCore::WebVTTParser::hasRequiredFileIdentifier): Update to use constants instead of hard
            coded lengths.
        (WebCore::WebVTTParser::WebVTTParser): Initialize "m_client" in the initilization list
            instead of setting it in the constructor.
        (WebCore::WebVTTParser::getNewCues): Renamed from fetchParsedCues.
        * html/track/WebVTTParser.h:
        (WebCore::WebVTTParser::create): Take a WebVTTParserClient* instead of a CueParserPrivateClient*.

        * loader/CueLoader.cpp:
        (WebCore::CueLoader::CueLoader):
        (WebCore::CueLoader::~CueLoader): Remove client.
        (WebCore::CueLoader::cueLoadTimerFired): Tell client about new clues and/or that the load
            has finished.
        (WebCore::CueLoader::processNewCueData): Process newly loaded data.
        (WebCore::CueLoader::didReceiveData): Ditto.
        (WebCore::CueLoader::notifyFinished): Do final processing as necessary, prime the timer
            to call client.
        (WebCore::CueLoader::load): Create resource loader, initiate loading.
        (WebCore::CueLoader::newCuesParsed): Prime timer to tell client about newly parsed cues.
        (WebCore::CueLoader::getNewCues): Get new cues from parser.
        * loader/CueLoader.h:
        (WebCore::CueLoader::create):

2011-10-18  Adam Barth  <abarth@webkit.org>

        Always enable ENABLE(XPATH)
        https://bugs.webkit.org/show_bug.cgi?id=70217

        Reviewed by Eric Seidel.

        As discussed on webkit-dev, we're reducing the complexity of WebKit by
        removing unneeded configuration options.  ENABLE(XPATH) is enabled on
        every port, so we are removing the ability to disable the feature.

        * CMakeLists.txt:
        * Configurations/FeatureDefines.xcconfig:
        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * UseJSC.cmake:
        * WebCore.pro:
        * bindings/js/JSCustomXPathNSResolver.cpp:
        * bindings/js/JSCustomXPathNSResolver.h:
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::setDOMException):
        * bindings/js/JSExceptionBase.cpp:
        (WebCore::toExceptionBase):
        * bindings/js/JSXPathResultCustom.cpp:
        * bindings/objc/DOMCustomXPathNSResolver.h:
        * bindings/objc/DOMCustomXPathNSResolver.mm:
        * bindings/objc/DOMInternal.h:
        * bindings/objc/DOMUtility.mm:
        (JSC::createDOMWrapper):
        * bindings/objc/DOMXPath.mm:
        (kit):
        * bindings/objc/PublicDOMInterfaces.h:
        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore::V8DOMWrapper::getXPathNSResolver):
        * bindings/v8/V8DOMWrapper.h:
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::setDOMException):
        * bindings/v8/V8Proxy.h:
        * bindings/v8/custom/V8CustomXPathNSResolver.cpp:
        * bindings/v8/custom/V8CustomXPathNSResolver.h:
        * bindings/v8/custom/V8DocumentCustom.cpp:
        (WebCore::V8Document::evaluateCallback):
        * dom/Document.cpp:
        * dom/Document.h:
        * dom/Document.idl:
        * dom/ExceptionCode.cpp:
        (WebCore::getExceptionCodeDescription):
        * dom/ExceptionCode.h:
        * features.pri:
        * inspector/InspectorDOMAgent.cpp:
        * page/DOMWindow.idl:
        * xml/NativeXPathNSResolver.cpp:
        * xml/NativeXPathNSResolver.h:
        * xml/XPathEvaluator.cpp:
        * xml/XPathEvaluator.h:
        * xml/XPathEvaluator.idl:
        * xml/XPathException.h:
        * xml/XPathException.idl:
        * xml/XPathExpression.cpp:
        * xml/XPathExpression.h:
        * xml/XPathExpression.idl:
        * xml/XPathExpressionNode.cpp:
        * xml/XPathExpressionNode.h:
        * xml/XPathFunctions.cpp:
        * xml/XPathFunctions.h:
        * xml/XPathGrammar.y:
        * xml/XPathNSResolver.cpp:
        * xml/XPathNSResolver.h:
        * xml/XPathNSResolver.idl:
        * xml/XPathNodeSet.cpp:
        * xml/XPathNodeSet.h:
        * xml/XPathParser.cpp:
        * xml/XPathParser.h:
        * xml/XPathPath.cpp:
        * xml/XPathPath.h:
        * xml/XPathPredicate.cpp:
        * xml/XPathPredicate.h:
        * xml/XPathResult.cpp:
        * xml/XPathResult.h:
        * xml/XPathResult.idl:
        * xml/XPathStep.cpp:
        * xml/XPathStep.h:
        * xml/XPathUtil.cpp:
        * xml/XPathUtil.h:
        * xml/XPathValue.cpp:
        * xml/XPathValue.h:
        * xml/XPathVariableReference.cpp:
        * xml/XPathVariableReference.h:

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Staged commit, part 6.

        Reviewed by Darin Adler.

        Test: platform/mac/accessibility/html5-input-number.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::addImageMapChildren):
        (WebCore::AccessibilityRenderObject::addTextFieldChildren):
        (WebCore::AccessibilityRenderObject::addChildren):
        * accessibility/AccessibilityRenderObject.h:

2011-10-18  Nate Chapin  <japhet@chromium.org>

        Make DocumentThreadableLoader a CachedResourceClient.
        This will allow us to cache ThreadableLoaderClients as
        appropriate in a later patch.
        https://bugs.webkit.org/show_bug.cgi?id=61225

        Reviewed by Antti Koivisto.

        No new tests, no functionality change intended.

        * WebCore.gypi:
        * loader/DocumentThreadableLoader.cpp:
        (WebCore::DocumentThreadableLoader::notifyFinished): CachedResourceClients don't send separate callbacks
            for didFail() and didFinishLoading(), so we need to differentiate here.
        (WebCore::DocumentThreadableLoader::loadRequest): Call CachedResourceLoader::requestRawResource()
            instead of ResourceLoadScheduler::scheduleSubresourceLoad().
        * loader/DocumentThreadableLoader.h:
        * loader/cache/CachedRawResource.cpp:
        (WebCore::CachedRawResource::data): Handle the complexity of some ThreadableLoaderClients setting
            DoNotBufferData in ResoureLoaderOptions. If the DataBufferingPolicy is BufferData, then the
            'data' input parameter will contain all data received so far, and we need to determine the
            incremental data to forward to the clients. If the policy is DoNotBufferData, 'data' is just
            the incremental data.
        * loader/cache/CachedRawResource.h:
        * loader/cache/CachedResource.cpp:
        * loader/cache/CachedResource.h:
        (WebCore::CachedResource::preloadResult):
        (WebCore::CachedResource::didSendData):
        (WebCore::CachedResource::didDownloadData):
        (WebCore::CachedResource::setLoadFinishTime):
        (WebCore::CachedResource::loadFinishTime):
        * loader/cache/CachedResourceClient.h: Add several new callbacks needed by DocumentThreadableLoader.
        * loader/cache/CachedResourceRequest.cpp:
        (WebCore::CachedResourceRequest::didReceiveResponse): CachedResource::setResponse() can now cancel
            the request, so protect appropriately.
        * loader/cache/CachedResourceRequest.h:
        * loader/chromium/CachedRawResourceChromium.cpp: Added (plumb didDownloadData() to DocumentThreadableLoader).
        * loader/chromium/CachedResourceRequestChromium.cpp: Added (plumb didDownloadData() to DocumentThreadableLoader).
        * loader/chromium/DocumentThreadableLoaderChromium.cpp:
        * platform/network/BlobResourceHandle.cpp:
        (WebCore::BlobResourceHandle::notifyResponse): Protect before setting response, since it might kill us.

2011-10-18  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97752.
        http://trac.webkit.org/changeset/97752
        https://bugs.webkit.org/show_bug.cgi?id=70332

        Caused assertion failures in MediaList::setParentStyleSheet()
        on the apple bots. (Requested by kling on #webkit).

        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSDOMBinding.h:
        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::CSSImportRule):
        (WebCore::CSSImportRule::~CSSImportRule):
        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::CSSMediaRule):
        (WebCore::CSSMediaRule::~CSSMediaRule):
        * css/CSSMediaRule.h:
        * css/MediaList.cpp:
        (WebCore::MediaList::MediaList):
        (WebCore::MediaList::notifyChanged):
        * css/MediaList.h:
        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::~StyleSheet):
        (WebCore::StyleSheet::setMedia):

2011-10-18  Anna Cavender  <annacc@chromium.org>

        Change TextTrack to use the word DISABLED instead of OFF for mode
        https://bugs.webkit.org/show_bug.cgi?id=70268

        Reviewed by Daniel Bates.

        No new tests. No new functionality.

        * html/TextTrack.cpp:
        (WebCore::TextTrack::setMode): use Disabled instead of Off
        * html/TextTrack.h: update Mode enum to use Disabled instead of Off

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Staged commit, part 5.

        Reviewed by Darin Adler.

        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::getOrCreate):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::boundingBoxRect):

2011-10-18  Antti Koivisto  <antti@apple.com>

        Move default stylesheet loading to a separate function
        https://bugs.webkit.org/show_bug.cgi?id=70331

        Reviewed by Andreas Kling.
        
        - Move default stylesheet loading out from CSSStyleSelector::styleForElement()
        - Rename e -> element
        - Remove pointless reffing of the placeholder style.

        * css/CSSStyleSelector.cpp:
        (WebCore::ensureDefaultStyleSheetsForElement):
        (WebCore::isAtShadowBoundary):
        (WebCore::CSSStyleSelector::styleForElement):

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Staged commit part 4.

        Reviewed by Darin Adler.

        * accessibility/AccessibilityMockObject.h:
        (WebCore::AccessibilityMockObject::isMockObject):
        (WebCore::AccessibilityMockObject::detachFromParent):
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::elementAccessibilityHitTest):
        * accessibility/mac/WebAccessibilityObjectWrapper.mm:
        (-[WebAccessibilityObjectWrapper accessibilityActionNames]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeNames]):
        (-[WebAccessibilityObjectWrapper subrole]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeValue:]):

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Staged commit part 3. Committing the new spin button classes.

        Reviewed by Darin Adler.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * accessibility/AccessibilitySpinButton.cpp: Added.
        (WebCore::AccessibilitySpinButton::create):
        (WebCore::AccessibilitySpinButton::AccessibilitySpinButton):
        (WebCore::AccessibilitySpinButton::~AccessibilitySpinButton):
        (WebCore::AccessibilitySpinButton::incrementButton):
        (WebCore::AccessibilitySpinButton::decrementButton):
        (WebCore::AccessibilitySpinButton::elementRect):
        (WebCore::AccessibilitySpinButton::addChildren):
        (WebCore::AccessibilitySpinButton::step):
        (WebCore::AccessibilitySpinButtonPart::AccessibilitySpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::create):
        (WebCore::AccessibilitySpinButtonPart::elementRect):
        (WebCore::AccessibilitySpinButtonPart::press):
        * accessibility/AccessibilitySpinButton.h: Added.
        (WebCore::AccessibilitySpinButton::setSpinButtonElement):
        (WebCore::AccessibilitySpinButton::roleValue):
        (WebCore::AccessibilitySpinButton::accessibilityIsIgnored):
        (WebCore::AccessibilitySpinButton::isSpinButton):
        (WebCore::AccessibilitySpinButtonPart::~AccessibilitySpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::isIncrementor):
        (WebCore::AccessibilitySpinButtonPart::setIsIncrementor):
        (WebCore::AccessibilitySpinButtonPart::roleValue):
        (WebCore::AccessibilitySpinButtonPart::isSpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::accessibilityIsIgnored):
        (WebCore::toAccessibilitySpinButton):
        (WebCore::toAccessibilitySpinButtonPart):

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Phase 2 of the staged commit.

        Reviewed by Darin Adler.

        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::boundingBoxForQuads):
        * accessibility/AccessibilityObject.h:
        (WebCore::AccessibilityObject::isSpinButton):
        (WebCore::AccessibilityObject::isSpinButtonPart):
        (WebCore::AccessibilityObject::isMockObject):

2011-10-18  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Expose the spin button object to the AX hierarchy. Since there is no distinct
        render object that backs this object, a mock object needs to be created for the entire
        spin button and the actual increment and decrement buttons inside.

        This will be a staged commit since the first time around Windows layout tests started crashing for an undeterminable reason.

        Reviewed by Darin Adler.

        * html/shadow/TextControlInnerElements.cpp:
        (WebCore::SpinButtonElement::step):
        (WebCore::SpinButtonElement::repeatingTimerFired):
        * html/shadow/TextControlInnerElements.h:

2011-10-18  Andreas Kling  <kling@webkit.org>

        MediaList: Remove inheritance from StyleBase.
        https://bugs.webkit.org/show_bug.cgi?id=70203

        Reviewed by Darin Adler.

        * css/MediaList.h:
        (WebCore::MediaList::parentStyleSheet):
        (WebCore::MediaList::setParentStyleSheet):
        * css/MediaList.cpp:
        (WebCore::MediaList::MediaList):
        (WebCore::MediaList::notifyChanged):

            Change MediaList to no longer inherit from StyleBase. The parent()/setParent()
            mechanism was replaced by explicit parentStyleSheet()/setParentStyleSheet().

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::CSSImportRule):
        (WebCore::CSSImportRule::~CSSImportRule):
        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::CSSMediaRule):
        (WebCore::CSSMediaRule::~CSSMediaRule):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().
            CSSRules are never moved between stylesheets, so the parent style sheet pointer
            is valid for the MediaList's lifetime.

        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::~StyleSheet):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().

        (WebCore::StyleSheet::setMedia):

            Change StyleBase::setParent() calls to MediaList::setParentStyleSheet().
            Assert that the parent sheet is either null, or this, as MediaLists should never
            be reparented to other sheets.
            Assert that the StyleSheet is indeed a CSSStyleSheet.  XSLStyleSheet inherits from
            StyleSheet, but it shouldn't be using the MediaList.

        * bindings/js/JSDOMBinding.h:
        (WebCore::root):

            Add MediaList* specific overload for root() since it can't fall back
            to root(StyleBase*) anymore.

        * WebCore.xcodeproj/project.pbxproj:

            Add some PrivateHeaders to accomodate the JSDOMBinding.h changes.

        * css/CSSMediaRule.h:

            Remove unnecessary forward-declaration of MediaList.

2011-10-18  Andreas Kling  <kling@webkit.org>

        XSLStyleSheet only needs to manage XSLImportRule children.
        https://bugs.webkit.org/show_bug.cgi?id=70326

        Reviewed by Antti Koivisto.

        * css/StyleBase.h:
        * xml/XSLImportRule.h:
        * css/CSSRule.h:
        (WebCore::CSSRule::isImportRule):

            Move StyleBase::isImportRule() down to CSSRule. Since XSLImportRule no longer
            implements it, it's now specific to CSSImportRule.

        * xml/XSLStyleSheet.h:

            Change m_children to be a vector of XSLImportRules. Also remove length(),
            item() and append() since they were only used internally to modify m_children.

        * xml/XSLStyleSheetQt.cpp:
        (WebCore::XSLStyleSheet::~XSLStyleSheet):
        * xml/XSLStyleSheetLibxslt.cpp:
        (WebCore::XSLStyleSheet::~XSLStyleSheet):
        (WebCore::XSLStyleSheet::isLoading):
        (WebCore::XSLStyleSheet::clearDocuments):
        (WebCore::XSLStyleSheet::loadChildSheet):
        (WebCore::XSLStyleSheet::locateStylesheetSubResource):

            Remove now-unnecessary isImportRule() checks and tidy up the code a bit.

2011-10-18  Zan Dobersek  <zandobersek@gmail.com>

        [Gtk] Support for client-based geolocation
        https://bugs.webkit.org/show_bug.cgi?id=64970

        Reviewed by Martin Robinson.

        Add feature defines for client-based geolocation when geolocation is enabled,
        since this is the providing method that is now used by default. Remove
        service-based providing method completely as it is not needed anymore.

        * GNUmakefile.am: Add feature defines for client-based geolocation.
        * GNUmakefile.list.am: Remove GeolocationServiceGtk.* files from compilation.
        * platform/gtk/GeolocationServiceGtk.cpp: Removed.
        * platform/gtk/GeolocationServiceGtk.h: Removed.

2011-10-18  Antti Koivisto  <antti@apple.com>

        REGRESSION(r97248): :visited as descendant selector broken
        https://bugs.webkit.org/show_bug.cgi?id=70122

        Reviewed by Nikolas Zimmerman.
        
        Make ":visited foo" and similar selectors work correctly again. They can affect 
        the visited style of an element inside a visited link.

        Test: fast/selectors/visited-descendant.html

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyDeclarations): 
        
            Apply visited style to children of visited links too.
            
        * css/SelectorChecker.cpp:
        (WebCore::SelectorChecker::checkSelector): 
        
            Don't disable visited matching until we run into first ancestor link or use combinator other than child/descendant.

        (WebCore::SelectorChecker::determineLinkMatchType):
        
            Look into child/descendant component selectors too to determine the link match type.

2011-10-18  Andreas Kling  <kling@webkit.org>

        Move CSSRule specific virtuals from StyleBase down into CSSRule.
        https://bugs.webkit.org/show_bug.cgi?id=70240

        Reviewed by Darin Adler.

        Move all the isFooRule() virtuals except isImportRule() to CSSRule
        since they only make sense for its subclasses. isRule() remains in
        StyleBase since we still need it for the parent chain traversal.
        isImportRule() remains because XSLImportRule implements it.

        Also moved insertedIntoParent() and removed its usage in
        XSLStyleSheet since it is only reimplemented by CSSImportRule.

        * css/CSSRule.h:
        (WebCore::CSSRule::isCharsetRule):
        (WebCore::CSSRule::isFontFaceRule):
        (WebCore::CSSRule::isKeyframeRule):
        (WebCore::CSSRule::isKeyframesRule):
        (WebCore::CSSRule::isMediaRule):
        (WebCore::CSSRule::isPageRule):
        (WebCore::CSSRule::isStyleRule):
        (WebCore::CSSRule::isRegionStyleRule):
        (WebCore::CSSRule::insertedIntoParent):
        * css/StyleBase.h:
        (WebCore::StyleBase::isImportRule):
        (WebCore::StyleBase::isCSSStyleSheet):
        * xml/XSLStyleSheet.h:
        (WebCore::XSLStyleSheet::append):

2011-10-18  Sachin Puranik  <jcqt43@motorola.com>

        Option.value should trim extra internal html spaces
        https://bugs.webkit.org/show_bug.cgi?id=69455

        Reviewed by Kent Tamura.

        Currently option.value does not trim the internal white space as suggested by spec. This patch implements the same.

        Test: fast/forms/option-value-trim-html-spaces.html

        * dom/OptionElement.cpp: Removed a function as this implementation is moved to the HTMLOptionElement.cpp file.
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::value): Implementation of .value function which will now trim the html white spaces.

2011-10-18  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSS Regions]Parse @-webkit-region rule
        https://bugs.webkit.org/show_bug.cgi?id=70021

        Reviewed by David Hyatt.

        Test: fast/regions/parsing-region-style-rule.html

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/objc/DOMCSS.mm:
        (kitClass):
        * bindings/v8/custom/V8CSSRuleCustom.cpp:
        (WebCore::toV8):
        * css/CSSGrammar.y:
        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::cssText):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::setReusableRegionSelectorVector):
        (WebCore::CSSParser::createRegionStylingRule):
        * css/CSSParser.h:
        (WebCore::CSSParser::reusableRegionSelectorVector):
        * css/CSSRegionStyleRule.cpp: Added.
        (WebCore::CSSRegionStyleRule::CSSRegionStyleRule):
        (WebCore::CSSRegionStyleRule::~CSSRegionStyleRule):
        (WebCore::CSSRegionStyleRule::cssText):
        * css/CSSRegionStyleRule.h: Added.
        * css/CSSRule.h:
        * css/CSSRule.idl:
        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::item):
        (WebCore::CSSRuleList::rulesText):
        * css/CSSRuleList.h:
        * css/CSSSelectorList.cpp:
        (WebCore::CSSSelectorList::selectorsText):
        * css/CSSSelectorList.h:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::addRegionStyleRule):
        (WebCore::RuleSet::addRulesFromSheet):
        * css/CSSStyleSelector.h:
        * css/StyleBase.h:
        (WebCore::StyleBase::isRegionStyleRule):
        * css/tokenizer.flex:

2011-10-11  Pavel Podivilov  <podivilov@chromium.org>

        Web Inspector: support displaying multiple sources per single script in ScriptsPanel.
        https://bugs.webkit.org/show_bug.cgi?id=69847

        Reviewed by Pavel Feldman.

        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._removeSourceFrame):
        (WebInspector.ScriptsPanel.prototype._uiSourceCodeReplaced):

2011-10-18  Nikolas Zimmermann  <nzimmermann@rim.com>

        Prepare SVGImage intrinsic size negotiation: Add intrinsic size & ratio calculation functionality to Image
        https://bugs.webkit.org/show_bug.cgi?id=70314

        Reviewed by Antti Koivisto.

        Add a "void computeIntrinsicDimension(Length& intrinsicWidth, Lengt& intrinsicHeight, FloatSize& intrinsicRatio)" helper method
        to Image/GeneratedImage/SVGImage and make it accessible through StyleImage.

        For a regular Image the intrinsicWidth/Height contains just a Length(size().width(), Fixed). In contrary SVGImages pass on the
        style()->width()/height() values from the render style of the RenderSVGRoot renderer. These information are needed to implement
        the size negotiation between embedded SVG images and the embedder.

        No new tests, as this new functionality is not yet used.

        * loader/cache/CachedImage.cpp:
        (WebCore::CachedImage::computeIntrinsicDimensions):
        * loader/cache/CachedImage.h:
        * platform/graphics/GeneratedImage.cpp:
        (WebCore::GeneratedImage::computeIntrinsicDimensions):
        * platform/graphics/GeneratedImage.h:
        * platform/graphics/Image.cpp:
        (WebCore::Image::computeIntrinsicDimensions):
        * platform/graphics/Image.h:
        * platform/graphics/cg/PDFDocumentImage.cpp:
        (WebCore::PDFDocumentImage::computeIntrinsicDimensions):
        * platform/graphics/cg/PDFDocumentImage.h:
        * rendering/style/StyleCachedImage.cpp:
        (WebCore::StyleCachedImage::computeIntrinsicDimensions):
        * rendering/style/StyleCachedImage.h:
        * rendering/style/StyleGeneratedImage.cpp:
        (WebCore::StyleGeneratedImage::computeIntrinsicDimensions):
        * rendering/style/StyleGeneratedImage.h:
        * rendering/style/StyleImage.h:
        * rendering/style/StylePendingImage.h:
        (WebCore::StylePendingImage::computeIntrinsicDimensions):
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::computeIntrinsicDimensions):
        * svg/graphics/SVGImage.h:

2011-10-17  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: [Chromium] Different dimensions are reported for elements onscreen and in the Metrics pane
        https://bugs.webkit.org/show_bug.cgi?id=70242

        Reviewed by Pavel Feldman.

        * inspector/DOMNodeHighlighter.cpp:

2011-10-18  Kentaro Hara  <haraken@chromium.org>

        Unreviewed, rolling out r97697.
        http://trac.webkit.org/changeset/97697
        https://bugs.webkit.org/show_bug.cgi?id=68978

        some tests are broken

        * bindings/js/JSMessageEventCustom.cpp:
        (WebCore::JSMessageEvent::data):
        * bindings/v8/custom/V8MessageEventCustom.cpp:
        (WebCore::V8MessageEvent::dataAccessorGetter):
        (WebCore::V8MessageEvent::portsAccessorGetter):
        (WebCore::V8MessageEvent::initMessageEventCallback):
        * dom/MessageEvent.cpp:
        (WebCore::MessageEventInit::MessageEventInit):
        (WebCore::MessageEvent::MessageEvent):
        (WebCore::MessageEvent::isMessageEvent):
        * dom/MessageEvent.h:
        (WebCore::MessageEvent::create):
        (WebCore::MessageEvent::dataAsSerializedScriptValue):
        (WebCore::MessageEvent::dataAsString):
        (WebCore::MessageEvent::dataAsBlob):
        (WebCore::MessageEvent::dataAsArrayBuffer):
        * dom/MessageEvent.idl:

2011-10-17  Antti Koivisto  <antti@apple.com>

        r97638 caused 3 printing crashes
        https://bugs.webkit.org/show_bug.cgi?id=70284

        Reviewed by Kent Tamura.

        Null check element.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyDeclarations):

2011-10-17  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97669.
        http://trac.webkit.org/changeset/97669
        https://bugs.webkit.org/show_bug.cgi?id=70305

        Broke accessibility tests on Windows (Requested by rniwa on
        #webkit).

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::getOrCreate):
        * accessibility/AccessibilityMockObject.h:
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::elementAccessibilityHitTest):
        * accessibility/AccessibilityObject.h:
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::boundingBoxRect):
        (WebCore::AccessibilityRenderObject::clearChildren):
        (WebCore::AccessibilityRenderObject::updateChildrenIfNecessary):
        (WebCore::AccessibilityRenderObject::addChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/AccessibilitySpinButton.cpp: Removed.
        * accessibility/AccessibilitySpinButton.h: Removed.
        * accessibility/mac/WebAccessibilityObjectWrapper.mm:
        (-[WebAccessibilityObjectWrapper accessibilityActionNames]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeNames]):
        (-[WebAccessibilityObjectWrapper subrole]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeValue:]):
        * html/shadow/TextControlInnerElements.cpp:
        (WebCore::SpinButtonElement::repeatingTimerFired):
        * html/shadow/TextControlInnerElements.h:

2011-10-17  Kent Tamura  <tkent@chromium.org>

        Remove OptionGroupElement
        https://bugs.webkit.org/show_bug.cgi?id=70220

        Reviewed by Darin Adler.

        No new tests, just a refactoring.

        * CMakeLists.txt: Remove OptionGroupElement.cpp and/or OptionGroupElement.h.
        * GNUMakefile.am.list: ditto.
        * WebCore.gypi: ditto.
        * WebCore.pro: ditto.
        * WebCore.vcproj/WebCore.vcproj: ditto.
        * WebCore.xcodeproj/project.pbxproj: ditto.
        * dom/DOMAllInOne.cpp: ditto.
        * dom/OptionElement.cpp:
        (WebCore::OptionElement::collectOptionTextRespectingGroupLabel):
        Use hasTagName(optgroupTag) and static_cast<> instead of toOptionGroupElement().
        * dom/OptionGroupElement.cpp: Removed.
        * dom/OptionGroupElement.h: Removed.
        * html/HTMLOptGroupElement.cpp:
        (WebCore::isHTMLOptGroupElement): Added.
        * html/HTMLOptGroupElement.h:
         - Don't inherit OptionGroupElement.
         - Make groupLabelText() non-virtual.
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::recalcListItems):
        Use Use hasTagName(optgroupTag) instead of isOptionGroupElement().
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::updateFromElement):
        Use hasTagName(optgroupTag) and static_cast<> instead of toOptionGroupElement().
        (WebCore::RenderListBox::paintItemForeground):
        Use hasTagName(optgroupTag) instead of isOptionGroupElement().
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::itemText):
        Use hasTagName(optgroupTag) and static_cast<> instead of toOptionGroupElement().
        (WebCore::RenderMenuList::itemIsEnabled):
        Use Use hasTagName(optgroupTag) instead of isOptionGroupElement().
        (WebCore::RenderMenuList::itemIsLabel): ditto.

2011-10-17  Huang Dongsung  <luxtella@company100.net>

        [TexMap][QT] TexMapGL renders a strange one-pixel border of BitmapTexture.
        https://bugs.webkit.org/show_bug.cgi?id=70293

        TextureMapperGL renders the strange border in
        http://www.webkit.org/blog-files/leaves/index.html
        Bug occurs because BitmapTexture is larger than the content due to rounding to
        NPOT, and its pixel data is never initialized.

        Reviewed by Noam Rosenthal.

        * platform/graphics/opengl/TextureMapperGL.cpp:
        (WebCore::texImage2DResourceSafe):
        (WebCore::BitmapTextureGL::reset):

2011-10-17  Jochen Eisinger  <jochen@chromium.org>

        Make NavigationAction wrap a ResourceRequest instead of a KURL.
        https://bugs.webkit.org/show_bug.cgi?id=68803

        With this, FrameLoaderClient::dispatchCreatePage knows about the
        request that will be used for the initial navigaion of the to be
        created page.

        Reviewed by Nate Chapin.

        Test: platform/chromium/fast/loader/create-view-target-blank.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadURL):
        (WebCore::FrameLoader::load):
        (WebCore::FrameLoader::loadWithDocumentLoader):
        (WebCore::FrameLoader::reload):
        (WebCore::FrameLoader::loadPostRequest):
        (WebCore::FrameLoader::continueLoadAfterNewWindowPolicy):
        (WebCore::FrameLoader::loadDifferentDocumentItem):
        (WebCore::createWindow):
        * loader/NavigationAction.cpp:
        (WebCore::NavigationAction::NavigationAction):
        * loader/NavigationAction.h:
        (WebCore::NavigationAction::isEmpty):
        (WebCore::NavigationAction::url):
        (WebCore::NavigationAction::resourceRequest):
        * loader/PolicyChecker.cpp:
        (WebCore::PolicyChecker::checkNavigationPolicy):
        * page/ContextMenuController.cpp:
        (WebCore::openNewWindow):
        * WebCore.exp: updated

2011-10-17  Tom Sepez  <tsepez@chromium.org>

        XSSAuditor bypass with remote script ending in ? character
        https://bugs.webkit.org/show_bug.cgi?id=70255

        Reviewed by Daniel Bates.

        Fix XSSAuditor bypass where unterminated src="" attribute could pick up
        text from page causing failed XSS detection.  Constrain match to domain
        portions of src attribute only.

        Test: http/tests/security/xssAuditor/script-tag-with-source-unterminated.html

        * html/parser/XSSAuditor.cpp:
        (WebCore::XSSAuditor::filterScriptToken):
        (WebCore::XSSAuditor::filterObjectToken):
        (WebCore::XSSAuditor::filterParamToken):
        (WebCore::XSSAuditor::filterEmbedToken):
        (WebCore::XSSAuditor::filterAppletToken):
        (WebCore::XSSAuditor::filterIframeToken):
        (WebCore::XSSAuditor::eraseAttributeIfInjected):
        (WebCore::XSSAuditor::decodedSnippetForAttribute):
        * html/parser/XSSAuditor.h:

2011-10-17  Adam Klein  <adamk@chromium.org>

        Parse MutationObserverOptions directly into a bitfield
        https://bugs.webkit.org/show_bug.cgi?id=70287

        Reviewed by Ryosuke Niwa.

        Replaces the MutationObserverOptions class with a typedef,
        used to pass a bitfield composed of enums defined in
        WebKitMutationObserver.h.

        No new tests because no behavior should change.

        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSDictionary.h: Removed now-unused method.
        * bindings/js/JSWebKitMutationObserverCustom.cpp:
        (WebCore::JSWebKitMutationObserver::observe):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp:
        (WebCore::V8WebKitMutationObserver::observeCallback):
        * dom/MutationObserverOptions.h: Removed.
        * dom/Node.cpp:
        (WebCore::Node::registerMutationObserver):
        * dom/Node.h:
        * dom/NodeRareData.h:
        (WebCore::MutationObserverEntry::MutationObserverEntry):
        (WebCore::MutationObserverEntry::matches):
        * dom/WebKitMutationObserver.cpp:
        (WebCore::WebKitMutationObserver::observe):
        * dom/WebKitMutationObserver.h:

2011-10-17  Luke Macpherson   <macpherson@chromium.org>

        Add compile-time asserts for RenderStyle::(Non)InheritedFlags size.
        https://bugs.webkit.org/show_bug.cgi?id=69803

        Reviewed by Darin Adler.

        No new tests.

        Adds COMPILE_ASSERTs for the size of RenderStyle::InheritedFlags and
        RenderStyle::NonInheritedFlags to ensure that they are not accidentally
        grown in future changes.
        Change types of unsigned bitfields to unsigned char to ensure that the
        above assertions remain true when building on windows.

        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle):
        Adds assertions to ensure struct sizes do not change.
        * rendering/style/RenderStyle.h:
        Changes unsigned to unsigned char as outlined above.

2011-10-17  Ojan Vafai  <ojan@chromium.org>

        Unreviewed, rolling out r97662.
        http://trac.webkit.org/changeset/97662
        https://bugs.webkit.org/show_bug.cgi?id=68497

        Was not the cause of the test failures.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::sizesToIntrinsicLogicalWidth):

2011-10-17  Ryosuke Niwa  <rniwa@webkit.org>

        Rename deregister* to unregister*
        https://bugs.webkit.org/show_bug.cgi?id=70272

        Reviewed by Darin Adler.

        Renamed deregisterHandler to unregisterHandler.

        * inspector/front-end/ExtensionAPI.js:
        (injectedExtensionAPI.ExtensionServerClient.prototype.unregisterHandler):
        * inspector/front-end/ExtensionServer.js:
        (WebInspector.ExtensionServer.prototype._onSetOpenResourceHandler):
        * inspector/front-end/HandlerRegistry.js:
        (get WebInspector.HandlerRegistry.prototype.unregisterHandler):

2011-10-17  Huang Dongsung  <luxtella@company100.net>

        [TexMap][QT] The BGRA32PremultimpliedBuffer should not inherit the RefCounted class.
        https://bugs.webkit.org/show_bug.cgi?id=70098

        The BitmapTexture has a BGRA32PremultimpliedBuffer object using OwnPtr, not RefPtr.
        It causes following assertion fail, RefCountedBase::m_deletionHasBegun.
        It is better that the BGRA32PremultimpliedBuffer does not inherit the RefCounted
        because the BitmapTexture only has and uses a BGRA32PremultimpliedBuffer object.

        Reviewed by Noam Rosenthal.

        * platform/graphics/opengl/TextureMapperGL.h:

2011-10-17  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Search in resource crashes when there is no resource with given url.
        https://bugs.webkit.org/show_bug.cgi?id=69767

        Reviewed by Pavel Feldman.

        Test: http/tests/inspector/search/search-in-non-existing-resource.html

        * inspector/InspectorPageAgent.cpp:
        (WebCore::InspectorPageAgent::searchInResource):

2011-10-17  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSS Regions]Change content:-webkit-from-flow to -webkit-flow-from
        https://bugs.webkit.org/show_bug.cgi?id=70104

        Reviewed by David Hyatt.

        1. -webkit-flow-from is now a property instead of being an addition to content property.
        2. -webkit-flow-from takes an identifier instead of string.

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::parseContent):
        (WebCore::CSSParser::parseRegionThread):
        * css/CSSParser.h:
        * css/CSSPrimitiveValue.cpp:
        (WebCore::isValidCSSUnitTypeForDoubleConversion):
        (WebCore::CSSPrimitiveValue::cleanup):
        (WebCore::CSSPrimitiveValue::getStringValue):
        (WebCore::CSSPrimitiveValue::cssText):
        * css/CSSPrimitiveValue.h:
        * css/CSSPropertyNames.in:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):

2011-10-17  Kentaro Hara  <haraken@chromium.org>

        MessageEvent.data can be stored as ScriptValue.
        https://bugs.webkit.org/show_bug.cgi?id=68978

        Reviewed by Hajime Morita.

        Currently, the following test cases fail or crash:

        - shouldBe("new MessageEvent('eventType', { data: test_object }).data", "test_object") -> FAIL
        - new MessageEvent('eventType', { data: document }).data -> CRASH

        This is because MessageEvent.data is implemented just as SerializedScriptValue
        and it cannot keep ScriptValue passed by JavaScript. This patch makes the following changes:

        - If MessageEvent is constructed with ScriptValue, it is stored as ScriptValue internally.
        When MessageEvent.data is called, the ScriptValue is returned.
        - If MessageEvent is constructed with SerializedScriptValue, it is stored as
        SerializedScriptValue internally (since we cannot deserialize it into ScriptValue
        at this point because of lack of ExecState). When MessageEvent.data is called,
        the SerializedScriptValue is deserialized into the corresponding ScriptValue,
        and the ScriptValue is returned.

        This patch does not make a fix for ObjC bindings code, since we need to first fix
        the bug 28774, as commented in dom/MessageEvent.h and dom/MessageEvent.cpp.

        Test: fast/events/constructors/message-event-constructor.html

        * bindings/js/JSMessageEventCustom.cpp:
        (WebCore::JSMessageEvent::data): Custom getter for MessageEvent.data. Supported ScriptValue.
        (WebCore::JSMessageEvent::initMessageEvent): Changed SerializedScriptValue to ScriptValue.
        * bindings/v8/custom/V8MessageEventCustom.cpp:
        (WebCore::V8MessageEvent::dataAccessorGetter): Custom getter for MessageEvent.data. Supported ScriptValue.
        (WebCore::V8MessageEvent::portsAccessorGetter): Removed extra spaces.
        (WebCore::V8MessageEvent::initMessageEventCallback): Changed SerializedScriptValue to ScriptValue.
        * dom/MessageEvent.cpp:
        (WebCore::MessageEvent::MessageEvent): Supported ScriptValue.
        (WebCore::MessageEvent::initMessageEvent): Supported ScriptValue.
        (WebCore::MessageEvent::isMessageEvent): Removed extra spaces.
        * dom/MessageEvent.h: Added DataType::DataTypeScriptValue.
        (WebCore::MessageEvent::create): Supported ScriptValue.
        (WebCore::MessageEvent::dataAsScriptValue): Getter for data. Insert ASSERT() to guarantee that this accessor is not called for unintended type of data.
        (WebCore::MessageEvent::dataAsSerializedScriptValue): Ditto.
        (WebCore::MessageEvent::dataAsString): Ditto.
        (WebCore::MessageEvent::dataAsBlob): Ditto.
        (WebCore::MessageEvent::dataAsArrayBuffer): Ditto.
        * dom/MessageEvent.idl: Changed SerializedScriptValue to DOMObject (i.e. ScriptValue). This patch does not touch an ObjC part.

2011-10-17  Shinya Kawanaka  <shinyak@google.com>

        Unified spell-checking and legacy spell checking should be easy to switch
        https://bugs.webkit.org/show_bug.cgi?id=69242

        Reviewed by Hajime Morita.

        WebCore has two different code paths for spell-checking:
                  1) checkTextOfParagraph() for Snow Leopard or later
                  2) checkSpellingOfString() for checkGrammarOfString() for other platforms.

        This patch introduces a flag to change code paths dynamically.
        This patch also includes build fix for QT, GTK, and Windows platforms.

        No new tests because this patch does not change a behavior.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::hasMisspelling):
          Changed static if-USE(UNIFIED_TEXT_CHECKING) statement to dynamic
          condition branch to achieve easy code path change.
        * accessibility/mac/WebAccessibilityObjectWrapper.mm: ditto.
        (AXAttributeStringSetSpelling):
        * editing/EditingAllInOne.cpp:
        * editing/Editor.cpp:
        (WebCore::Editor::advanceToNextMisspelling): ditto.
        (WebCore::Editor::guessesForMisspelledOrUngrammaticalSelection): ditto.
        (WebCore::Editor::markMisspellingsAfterTypingToWord): ditto.
        (WebCore::Editor::markAllMisspellingsAndBadGrammarInRanges): ditto.
        (WebCore::Editor::changeBackToReplacedString): ditto.
        (WebCore::Editor::markMisspellingsAndBadGrammar): ditto.
        (WebCore::Editor::unifiedTextCheckerEnabled):
          Utility method to check using unified text checking or not.
        * editing/Editor.h:
        * editing/TextCheckingHelper.cpp:
        (WebCore::TextCheckingHelper::findFirstMisspellingOrBadGrammar):
          Same as WebCore::AccessibilityObject::hasMisspelling.
        (WebCore::TextCheckingHelper::guessesForMisspelledOrUngrammaticalRange): ditto.
        (WebCore::TextCheckingHelper::unifiedTextCheckerEnabled):
          Utility method to check using unified text checking or not.
        (WebCore::unifiedTextCheckerEnabled): ditto.
        * editing/TextCheckingHelper.h:
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
          Includes a flag to change the code path.
        * page/Settings.h:
        (WebCore::Settings::setUnifiedTextCheckerEnabled):
          Sets a flag to change the code path.
        (WebCore::Settings::unifiedTextCheckerEnabled):
          A flag to change the code path.

2011-10-17  Julien Chaffraix  <jchaffraix@webkit.org>

        Unreviewed build fix after 97691.

        * html/HTMLTableCellElement.h:
        (WebCore::toHTMLTableCellElement): Avoid declaring the same function twice.

2011-10-12  Ojan Vafai  <ojan@chromium.org>

        Unreviewed, rolling out r97661.
        http://trac.webkit.org/changeset/97661

        Confirmed this patch was not the cause of the test failures.

        display:inline-block elements don't correctly handle orthogonal writing-modes 
        https://bugs.webkit.org/show_bug.cgi?id=69957 
        
        Reading min/maxPreferredLogicalWidth from a child uses the child's writing-mode. 
        Instead, we need to grab the result based on the parent's writing-mode. 
        In the case of orthogonal writing-modes, we need the child's logical height. 
    
        Tests: fast/writing-mode/borders-expected.html 
               fast/writing-mode/borders.html 
        
        * rendering/RenderBlock.cpp: 
        (WebCore::RenderBlock::computeBlockPreferredLogicalWidths): 

2011-10-17  James Robinson  <jamesr@chromium.org>

        Unreviewed, rolling out r97690.
        http://trac.webkit.org/changeset/97690
        https://bugs.webkit.org/show_bug.cgi?id=70161

        Hits assertion in CCLayerTreeHostTests

        * WebCore.gypi:
        * platform/graphics/chromium/cc/CCMainThread.h:
        * platform/graphics/chromium/cc/CCMainThreadTask.h:
        (WebCore::createMainThreadTask):
        * platform/graphics/chromium/cc/CCScopedMainThreadProxy.h: Removed.
        * platform/graphics/chromium/cc/CCThreadProxy.cpp:
        (WebCore::CCThreadProxySchedulerClient::scheduleBeginFrameAndCommit):
        (WebCore::CCThreadProxy::CCThreadProxy):
        (WebCore::CCThreadProxy::stop):
        * platform/graphics/chromium/cc/CCThreadProxy.h:

2011-10-17  Julien Chaffraix  <jchaffraix@webkit.org>

        Remove colSpan / rowSpan caching from RenderTableCell
        https://bugs.webkit.org/show_bug.cgi?id=69569

        Reviewed by Darin Adler.

        Memory optimization, no change in behavior expected.

        This change removes m_colSpan & m_rowSpan from RenderTableCell (inspired by
        kling's memory shaving effort).

        This makes us save 8 bytes per RenderTableCell on my machine (x86-64). No slowdown
        on PageCycler Alexa-US.

        This change refactored the way we handle updates from the DOM side to simplify
        the code using the following: colspan / rowspan updates always go through
        parseMappedAttribute where we already check for the renderer type. Thus removed the
        generic updateFromElement and replaced it with colSpanOrRowSpanChanged. This removes
        a virtual dispatch.

        As there is no way to know if an attribute has changed in the parseMappedAttribute code,
        we now unconditionally call colSpanOrRowSpanChanged. Looking at Chromium's page data,
        colSpan and rowSpan are never changed outside the HTML markup thus such a change should
        have a limited impact.

        * html/HTMLTableCellElement.cpp:
        (WebCore::HTMLTableCellElement::parseMappedAttribute): Updated after updateFromElement
        removal.

        * html/HTMLTableCellElement.h:
        (WebCore::toHTMLTableCellElement): Added the usual conversion functions.

        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::RenderTableCell): Added a boolean to know if we have
        the right type of associated DOM node to avoid the cost of checking that every
        time.

        (WebCore::RenderTableCell::colSpan):
        (WebCore::RenderTableCell::rowSpan):
        Forwarded the calls to our object if we have the right type (normal case).

        (WebCore::RenderTableCell::colSpanOrRowSpanChanged): Handles the
        updateFromElement calls but in a more streamlined way.

        * rendering/RenderTableCell.h:

2011-10-17  James Robinson  <jamesr@chromium.org>

        [chromium] Fix shutdown race when posting main thread task to CCThreadProxy and enable tests
        https://bugs.webkit.org/show_bug.cgi?id=70161

        Reviewed by David Levin.

        Adds a weak pointer mechanism to cancel main thread tasks posted to CCThreadProxy instances from the compositor
        thread. Previously there was a race condition where main thread tasks could run even after the CCThreadProxy was
        destroyed.

        This race does not exist in the other direction because when tearing down a CCThreadProxy we first post a quit
        task to the compositor thread and then suspend execution of the main thread until all compositor tasks for the
        CCThreadProxy have been drained.

        Covered by the now-enabled CCLayerTreeHostTest* unit tests.

        * WebCore.gypi:
        * platform/graphics/chromium/cc/CCScopedMainThreadProxy.h: Added.
        (WebCore::CCScopedMainThreadProxy::create):
        (WebCore::CCScopedMainThreadProxy::postTask):
        (WebCore::CCScopedMainThreadProxy::shutdown):
        (WebCore::CCScopedMainThreadProxy::CCScopedMainThreadProxy):
        (WebCore::CCScopedMainThreadProxy::runTaskIfNotShutdown):
        * platform/graphics/chromium/cc/CCThreadProxy.cpp:
        (WebCore::CCThreadProxy::CCThreadProxy):
        (WebCore::CCThreadProxy::~CCThreadProxy):
        (WebCore::CCThreadProxy::createBeginFrameAndCommitTaskOnCCThread):
        * platform/graphics/chromium/cc/CCThreadProxy.h:

2011-10-17  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97641.
        http://trac.webkit.org/changeset/97641
        https://bugs.webkit.org/show_bug.cgi?id=70288

        "This change may have broken mouse/hit-test coordinate tests."
        (Requested by jeffm7 on #webkit).

        * platform/Widget.cpp:
        (WebCore::Widget::convertFromContainingWindow):
        (WebCore::Widget::convertToContainingWindow):

2011-10-17  Andreas Kling  <kling@webkit.org>

        CSSParser: Remove unused variable 'propertyComponents'
        https://bugs.webkit.org/show_bug.cgi?id=70230

        Reviewed by Darin Adler.

        (WebCore::CSSParser::markPropertyEnd):

2011-10-17  Shawn Singh  <shawnsingh@chromium.org>

        [chromium] Update comments about transform hierarchy in CCLayerTreeHostCommon
        https://bugs.webkit.org/show_bug.cgi?id=69765

        Reviewed by James Robinson.

        Only comments changed, no tests needed.

        * platform/graphics/chromium/cc/CCLayerTreeHostCommon.cpp:
        (WebCore::calculateDrawTransformsAndVisibilityInternal):

2011-10-17  Dan Bernstein  <mitz@apple.com>

        Remove unnecessary calls to columnRectAt()
        https://bugs.webkit.org/show_bug.cgi?id=70283

        Reviewed by Darin Adler.

        These call sites only needed one of the column dimensions, which are independent of the column
        index, and can be retrieved directly from the ColumnInfo.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintColumnRules):
        (WebCore::RenderBlock::hitTestColumns):

2011-10-17  Andreas Kling  <kling@webkit.org>

        Protect against incorrect Element::fast*Attribute() usage.
        https://bugs.webkit.org/show_bug.cgi?id=67612

        Reviewed by Darin Adler.

        Add debug-only checks in Element's fastHasAttribute() and fastGetAttribute() to verify
        that we aren't looking up the "style" attribute or any of the SVG animatable attributes.

        No new tests, erroneous behavior is covered by assertions.

        * WebCore.exp.in: Export Element::fastAttributeLookupAllowed() for debug builds
        since it's used by the inline fast*Attribute() calls.
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::canShareStyleWithElement): Use getAttribute() for class.
        * css/SelectorChecker.cpp:
        (WebCore::linkAttribute): Use getAttribute() for xlink:href.
        * dom/Element.cpp:
        (WebCore::Element::getAttribute): Manually inline fastGetAttribute() in ideal case.
        (WebCore::Element::fastAttributeLookupAllowed): Checks if an attribute can be used
        with the fast lookup functions.
        * dom/Element.h:
        (WebCore::Element::fastHasAttribute): Add assertion.
        (WebCore::Element::fastGetAttribute): Ditto.
        * editing/ApplyStyleCommand.cpp:
        (WebCore::hasNoAttributeOrOnlyStyleAttribute): Use getAttribute() for class.
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::isInlineNodeWithStyle): Ditto.
        * html/ClassList.cpp:
        (WebCore::ClassList::ClassList): Ditto.
        (WebCore::ClassList::addInternal): Ditto.
        (WebCore::ClassList::removeInternal): Ditto.
        (WebCore::ClassList::toString): Ditto.
        * svg/SVGAltGlyphElement.cpp:
        (WebCore::SVGAltGlyphElement::hasValidGlyphElements): Use getAttribute() for xlink:href.
        * svg/SVGAnimateMotionElement.cpp:
        (WebCore::SVGAnimateMotionElement::rotateMode): Use getAttribute() for rotate.
        * svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::animationMode): Use getAttribute() for values.
        * svg/SVGElement.cpp:
        (WebCore::SVGElement::isAnimatableAttribute): Added, returns true if the given
        QualifiedName represents an animatable attribute.
        * svg/SVGElement.h:
        * svg/SVGFontFaceUriElement.cpp:
        (WebCore::SVGFontFaceUriElement::srcValue): Use getAttribute() for xlink:href.
        (WebCore::SVGFontFaceUriElement::loadFont): Ditto.
        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::xlinkHref): Ditto.
        * svg/SVGGlyphRefElement.cpp:
        (WebCore::SVGGlyphRefElement::hasValidGlyphElement): Ditto.
        * svg/SVGStyleElement.cpp:
        (WebCore::SVGStyleElement::type): Use getAttribute() for type.

2011-10-17  Chris Fleizach  <cfleizach@apple.com>

        AX: buttons of number type <input> controls are not fully accessible
        https://bugs.webkit.org/show_bug.cgi?id=70241

        Expose the spin button object to the AX hierarchy. Since there is no distinct
        render object that backs this object, a mock object needs to be created for the entire
        spin button and the actual increment and decrement buttons inside.

        Reviewed by Darin Adler.

        Test: platform/mac/accessibility/html5-input-number.html

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::getOrCreate):
        * accessibility/AccessibilityMockObject.cpp:
        (WebCore::AccessibilityMockObject::AccessibilityMockObject):
        * accessibility/AccessibilityMockObject.h:
        (WebCore::AccessibilityMockObject::isMockObject):
        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::boundingBoxForQuads):
        (WebCore::AccessibilityObject::elementAccessibilityHitTest):
        * accessibility/AccessibilityObject.h:
        (WebCore::AccessibilityObject::isSpinButton):
        (WebCore::AccessibilityObject::isSpinButtonPart):
        (WebCore::AccessibilityObject::isMockObject):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::boundingBoxRect):
        (WebCore::AccessibilityRenderObject::addImageMapChildren):
        (WebCore::AccessibilityRenderObject::addTextFieldChildren):
        (WebCore::AccessibilityRenderObject::addChildren):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/AccessibilitySpinButton.cpp: Added.
        (WebCore::AccessibilitySpinButton::create):
        (WebCore::AccessibilitySpinButton::AccessibilitySpinButton):
        (WebCore::AccessibilitySpinButton::~AccessibilitySpinButton):
        (WebCore::AccessibilitySpinButton::incrementButton):
        (WebCore::AccessibilitySpinButton::decrementButton):
        (WebCore::AccessibilitySpinButton::elementRect):
        (WebCore::AccessibilitySpinButton::addChildren):
        (WebCore::AccessibilitySpinButton::step):
        (WebCore::AccessibilitySpinButtonPart::AccessibilitySpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::create):
        (WebCore::AccessibilitySpinButtonPart::elementRect):
        (WebCore::AccessibilitySpinButtonPart::press):
        * accessibility/AccessibilitySpinButton.h: Added.
        (WebCore::AccessibilitySpinButton::setSpinButtonElement):
        (WebCore::AccessibilitySpinButton::roleValue):
        (WebCore::AccessibilitySpinButton::accessibilityIsIgnored):
        (WebCore::AccessibilitySpinButton::isSpinButton):
        (WebCore::AccessibilitySpinButtonPart::~AccessibilitySpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::isIncrementor):
        (WebCore::AccessibilitySpinButtonPart::setIsIncrementor):
        (WebCore::AccessibilitySpinButtonPart::roleValue):
        (WebCore::AccessibilitySpinButtonPart::isSpinButtonPart):
        (WebCore::AccessibilitySpinButtonPart::accessibilityIsIgnored):
        (WebCore::toAccessibilitySpinButton):
        (WebCore::toAccessibilitySpinButtonPart):
        * accessibility/mac/WebAccessibilityObjectWrapper.mm:
        (-[WebAccessibilityObjectWrapper accessibilityActionNames]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeNames]):
        (-[WebAccessibilityObjectWrapper subrole]):
        (-[WebAccessibilityObjectWrapper accessibilityAttributeValue:]):
        * html/shadow/TextControlInnerElements.cpp:
        (WebCore::SpinButtonElement::step):
        (WebCore::SpinButtonElement::repeatingTimerFired):
        * html/shadow/TextControlInnerElements.h:

2011-10-17  Dmitry Titov  <dimich@chromium.org>

        Re-landing: window.webkitNotifications uses deallocated NotificationPresenter after live Iframe transfer.
        https://bugs.webkit.org/show_bug.cgi?id=70147

        Reviewed by David Levin.

        I only found a way to test this manually, since Chromium TestShell uses static instance
        of NotificationPresenter instead of per-page one so the issue does not reproduce.
        Adding manual test that works in full build of Chromium.

        * manual-tests/iframe_notifications/iframe-reparenting-close-window-child.html: Added.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window-iframe.html: Added.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window.html: Added.
        * notifications/NotificationCenter.cpp:
        (WebCore::NotificationCenter::disconnectFrame):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::resetNotifications):
        * page/DOMWindow.h:
        * page/Frame.cpp:
        (WebCore::Frame::transferChildFrameToNewDocument): reset webkitNotifications object.

2011-10-17  Arno Renevier  <arno@renevier.net>

        quote "attributes" keyword in CodeGeneratorGObject.pm
        https://bugs.webkit.org/show_bug.cgi?id=64348

        Reviewed by Darin Adler.

        No change of functionality. No new tests.

        * bindings/scripts/CodeGeneratorGObject.pm:

2011-10-17  Ojan Vafai  <ojan@chromium.org>

        Unreviewed, rolling out r97654.
        http://trac.webkit.org/changeset/97654
        https://bugs.webkit.org/show_bug.cgi?id=68497

        Caused a number of Chromium failures.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::sizesToIntrinsicLogicalWidth):

2011-10-17  Ojan Vafai  <ojan@chromium.org>

        Unreviewed, rolling out r97653.
        http://trac.webkit.org/changeset/97653
        https://bugs.webkit.org/show_bug.cgi?id=69957

        Caused a number of Chromium failures.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::computeBlockPreferredLogicalWidths):

2011-10-17  Rafael Weinstein  <rafaelw@chromium.org>

        [MutationObservers] Implement WebKitMutationObserver.observe for attributes
        https://bugs.webkit.org/show_bug.cgi?id=68956

        Reviewed by Ryosuke Niwa.

        Test: fast/mutation/observe-attributes.html

        This adds an initial implementation for registering mutation observers on nodes,
        delivering mutation records at the end of the outer-most script invokation and
        observing mutations to element attributes.

        Note that the outer-most script invokation only works in V8.

        Note also that support for observing changes to the style attribute when updated
        via the style property is not implemented here.

        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::didLeaveScriptContext):
        * dom/Element.cpp:
        (WebCore::enqueueAttributesMutationRecord):
        (WebCore::Element::setAttribute):
        * dom/MutationRecord.cpp:
        (WebCore::MutationRecord::createAttributes):
        * dom/MutationRecord.h:
        * dom/MutationRecord.idl:
        * dom/Node.cpp:
        (WebCore::Node::clearRareData):
        (WebCore::Node::mutationObserverData):
        (WebCore::Node::ensureMutationObserverData):
        (WebCore::Node::registeredMutationObserversOfType):
        (WebCore::Node::registerMutationObserver):
        (WebCore::Node::deregisterMutationObserver):
        * dom/Node.h:
        * dom/NodeRareData.h:
        (WebCore::MutationObserverRegistration::MutationObserverRegistration):
        (WebCore::MutationObserverRegistration::operator==):
        (WebCore::MutationObserverData::MutationObserverData):
        (WebCore::MutationObserverData::~MutationObserverData):
        (WebCore::NodeRareData::mutationObserverData):
        (WebCore::NodeRareData::ensureMutationObserverData):
        * dom/WebKitMutationObserver.cpp:
        (WebCore::WebKitMutationObserver::observe):
        (WebCore::WebKitMutationObserver::disconnect):
        (WebCore::WebKitMutationObserver::wasDeregistered):
        (WebCore::activeMutationObservers):
        (WebCore::WebKitMutationObserver::enqueueMutationRecord):
        (WebCore::WebKitMutationObserver::deliverAllMutations):
        (WebCore::WebKitMutationObserver::deliver):
        * dom/WebKitMutationObserver.h:

2011-10-17  Andreas Kling  <kling@webkit.org>

        HTMLKeygenElement: Don't cache keytype and challenge attributes.
        https://bugs.webkit.org/show_bug.cgi?id=68365

        Reviewed by Darin Adler.

        * html/HTMLKeygenElement.cpp:
        (WebCore::HTMLKeygenElement::parseMappedAttribute):
        (WebCore::HTMLKeygenElement::appendFormData):
        * html/HTMLKeygenElement.h:

2011-09-22  Ojan Vafai  <ojan@chromium.org>

        incorrect height with height:auto and writing-mode:vertical-rl
        https://bugs.webkit.org/show_bug.cgi?id=68497

        Reviewed by David Hyatt.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::sizesToIntrinsicLogicalWidth):

2011-10-12  Ojan Vafai  <ojan@chromium.org>

        display:inline-block elements don't correctly handle orthogonal writing-modes
        https://bugs.webkit.org/show_bug.cgi?id=69957

        Reviewed by David Hyatt.

        Reading min/maxPreferredLogicalWidth from a child uses the child's writing-mode.
        Instead, we need to grab the result based on the parent's writing-mode.
        In the case of orthogonal writing-modes, we need the child's logical height.

        Tests: fast/writing-mode/borders-expected.html
               fast/writing-mode/borders.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::computeBlockPreferredLogicalWidths):

2011-10-17  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97643.
        http://trac.webkit.org/changeset/97643
        https://bugs.webkit.org/show_bug.cgi?id=70270

        Broke iframe reparenting tests (Requested by dimich on
        #webkit).

        * manual-tests/iframe_notifications/iframe-reparenting-close-window-child.html: Removed.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window-iframe.html: Removed.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window.html: Removed.
        * notifications/NotificationCenter.cpp:
        (WebCore::NotificationCenter::disconnectFrame):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::webkitNotifications):
        * page/DOMWindow.h:
        * page/Frame.cpp:
        (WebCore::Frame::transferChildFrameToNewDocument):

2011-10-17  Dmitry Titov  <dimich@chromium.org>

        window.webkitNotifications uses deallocated NotificationPresenter after live Iframe transfer.
        https://bugs.webkit.org/show_bug.cgi?id=70147

        Reviewed by David Levin.

        I only found a way to test this manually, since Chromium TestShell uses static instance
        of NotificationPresenter instead of per-page one so the issue does not reproduce.
        Adding manual test that works in full build of Chromium.

        * manual-tests/iframe_notifications/iframe-reparenting-close-window-child.html: Added.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window-iframe.html: Added.
        * manual-tests/iframe_notifications/iframe-reparenting-close-window.html: Added.
        * notifications/NotificationCenter.cpp:
        (WebCore::NotificationCenter::disconnectFrame):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::resetNotifications):
        * page/DOMWindow.h:
        * page/Frame.cpp:
        (WebCore::Frame::transferChildFrameToNewDocument): reset webkitNotifications object.

2011-10-17  Jeff Miller  <jeffm@apple.com>

        Widget window coordinate functions should use root view coordinate functions
        https://bugs.webkit.org/show_bug.cgi?id=70152

        Reviewed by Darin Adler.

        No new tests, no changes to functionality.

        * platform/Widget.cpp:
        (WebCore::Widget::convertFromContainingWindow): Use convertFromRootView().
        (WebCore::Widget::convertToContainingWindow): Use convertToRootView().

2011-10-14  Chris Marrin  <cmarrin@apple.com>

        Throttle rate of requestAnimationFrame when page is not visible
        https://bugs.webkit.org/show_bug.cgi?id=67873

        Reviewed by Anders Carlsson.

        Add logic to suspend and resume scripted animations when page is hidden,
        minimized or the tab is not visible. The hide/minimize notification comes
        in from WebKit/WebKit2 to a new set of functions.

        * WebCore.exp.in:
        * page/Page.cpp:
        (WebCore::Page::didMoveOnscreen):
        (WebCore::Page::willMoveOffscreen):
        (WebCore::Page::suspendScriptedAnimations):
        (WebCore::Page::resumeScriptedAnimations):
        * page/Page.h:

2011-10-17  Antti Koivisto  <antti@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=69966
        Eliminate separate RenderStyle for visited link style

        Reviewed by Dave Hyatt and Nikolas Zimmermann.

        There are only a few properties that can apply to visited links and they can
        be part of the regular style. Many things will get simpler when the separate 
        RenderStyle for visited links is eliminated.
        
        - Add valid visited link properties as separate fields to RenderStyle. The  
          visitedLinkColor goes to inherited, everything else goes to rare data structures.
        - Make RenderStyle::visitedDependentColor() get the visited style from the new fields.
        - As VISITED_LINK pseudo style doesn't exists anymore, remove all code dealing with it.
        - Make CSSStyleSelector and ApplyPropertyColor apply the visited link style to the
          newly added fields instead of a separate RenderStyle.
        - Same thing with SVGRenderStyle, SVGCSSStyleSelector.
        - Fixup the SVG visited link style code to use the new fields.

        This is ~15% progression in styleForElement performance over the HTML5 spec load.

        * css/CSSStyleApplyProperty.cpp:
        (WebCore::ApplyPropertyColor::ApplyPropertyColor):
        (WebCore::ApplyPropertyColor::applyInheritValue):
        (WebCore::ApplyPropertyColor::applyInitialValue):
        (WebCore::ApplyPropertyColor::applyValue):
        (WebCore::ApplyPropertyColor::applyColorValue):
        (WebCore::CSSStyleApplyProperty::CSSStyleApplyProperty):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::CSSStyleSelector):
        (WebCore::CSSStyleSelector::styleForElement):
        (WebCore::CSSStyleSelector::pseudoStyleForElement):
        (WebCore::CSSStyleSelector::updateFont):
        (WebCore::CSSStyleSelector::applyDeclaration):
        (WebCore::CSSStyleSelector::applyDeclarations):
        (WebCore::CSSStyleSelector::applyProperty):
        (WebCore::CSSStyleSelector::getColorFromPrimitiveValue):
        * css/CSSStyleSelector.h:
        (WebCore::CSSStyleSelector::applyPropertyToRegularStyle):
        (WebCore::CSSStyleSelector::applyPropertyToVisitedLinkStyle):
        * css/SVGCSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applySVGProperty):
        * dom/Element.cpp:
        (WebCore::Element::pseudoStyleCacheIsInvalid):
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::getCachedPseudoStyle):
        (WebCore::RenderStyle::colorIncludingFallback):
        (WebCore::RenderStyle::visitedDependentColor):
        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::setVisitedLinkColor):
        (WebCore::InheritedFlags::setVisitedLinkBackgroundColor):
        (WebCore::InheritedFlags::setVisitedLinkBorderLeftColor):
        (WebCore::InheritedFlags::setVisitedLinkBorderRightColor):
        (WebCore::InheritedFlags::setVisitedLinkBorderBottomColor):
        (WebCore::InheritedFlags::setVisitedLinkBorderTopColor):
        (WebCore::InheritedFlags::setVisitedLinkOutlineColor):
        (WebCore::InheritedFlags::setVisitedLinkColumnRuleColor):
        (WebCore::InheritedFlags::setVisitedLinkTextEmphasisColor):
        (WebCore::InheritedFlags::setVisitedLinkTextFillColor):
        (WebCore::InheritedFlags::setVisitedLinkTextStrokeColor):
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/SVGRenderStyle.h:
        (WebCore::SVGRenderStyle::setVisitedLinkFillPaint):
        (WebCore::SVGRenderStyle::setVisitedLinkStrokePaint):
        (WebCore::SVGRenderStyle::visitedLinkFillPaintType):
        (WebCore::SVGRenderStyle::visitedLinkFillPaintColor):
        (WebCore::SVGRenderStyle::visitedLinkStrokePaintType):
        (WebCore::SVGRenderStyle::visitedLinkStrokePaintColor):
        * rendering/style/SVGRenderStyleDefs.cpp:
        (WebCore::StyleFillData::StyleFillData):
        (WebCore::StyleFillData::operator==):
        (WebCore::StyleStrokeData::StyleStrokeData):
        (WebCore::StyleStrokeData::operator==):
        * rendering/style/SVGRenderStyleDefs.h:
        * rendering/style/StyleInheritedData.cpp:
        (WebCore::StyleInheritedData::StyleInheritedData):
        (WebCore::StyleInheritedData::operator==):
        * rendering/style/StyleInheritedData.h:
        * rendering/style/StyleMultiColData.cpp:
        (WebCore::StyleMultiColData::StyleMultiColData):
        (WebCore::StyleMultiColData::operator==):
        * rendering/style/StyleMultiColData.h:
        * rendering/style/StyleRareInheritedData.cpp:
        (WebCore::StyleRareInheritedData::StyleRareInheritedData):
        (WebCore::StyleRareInheritedData::operator==):
        * rendering/style/StyleRareInheritedData.h:
        * rendering/style/StyleRareNonInheritedData.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        * rendering/style/StyleRareNonInheritedData.h:
        * rendering/svg/RenderSVGResource.cpp:
        (WebCore::requestPaintingResource):

2011-10-17  Eric Carlson  <eric.carlson@apple.com>

        Cues should be loaded by the cached resource loader
        https://bugs.webkit.org/show_bug.cgi?id=70134

        Reviewed by Darin Adler.

        No new tests, changes covered by existing tests.

        * CMakeLists.txt: Add CachedCues.cpp/h.
        * GNUmakefile.list.am: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.

        * loader/cache/CachedCues.cpp: Added.
        (WebCore::CachedCues::CachedCues):
        (WebCore::CachedCues::~CachedCues):
        (WebCore::CachedCues::data): Called when new data has been loaded, pass it to all registered
            clients.
        * loader/cache/CachedCues.h: Added.

        * loader/cache/CachedResource.cpp:
        (WebCore::defaultPriorityForResourceType): Cues have low loader priority.
        * loader/cache/CachedResource.h:

        * loader/cache/CachedResourceClient.h:
        (WebCore::CachedResourceClient::didReceiveData): New client interface.

        * loader/cache/CachedResourceLoader.cpp:
        (WebCore::createResource): Create and return a new cue loader.
        (WebCore::CachedResourceLoader::requestCues):
        (WebCore::CachedResourceLoader::checkInsecureContent): Cues aren't mentioned in the CPS spec
            yet, but they only work with a media element so use the mdia policy.
        (WebCore::CachedResourceLoader::canRequest): Allow cues to be loaded from any origin like media.
        * loader/cache/CachedResourceLoader.h:

        * loader/cache/CachedResourceRequest.cpp:
        (WebCore::cachedResourceTypeToTargetType):
        * platform/network/chromium/ResourceRequest.h:

2011-10-17  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/10293929> REGRESSION (r97525): iChat transcript has horizontal scroll bar when the conversation includes a wide image
        https://bugs.webkit.org/show_bug.cgi?id=70204

        Reviewed by Darin Adler.

        Reverted r97525, which was supposed to fix <http://webkit.org/b/29447>.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::computeReplacedLogicalWidthUsing):
        (WebCore::RenderBox::computeReplacedLogicalHeightUsing):
        * rendering/RenderBox.h:

2011-10-17  Ada Chan  <adachan@apple.com>

        Export KURL::baseAsString() so it can be called in WebProcessProxy::assumeReadAccessToBaseURL() in WebKit2.
        https://bugs.webkit.org/show_bug.cgi?id=70168

        Reviewed by Alexey Proskuryakov.

        No new tests. There is no change in functionality.

        * WebCore.exp.in: Export KURL::baseAsString().

2011-10-17  Ryosuke Niwa  <rniwa@webkit.org>

        Touch Internals.cpp to make 64-bit GTK+ build happy.

        * testing/Internals.cpp:

2011-10-17  Chris Fleizach  <cfleizach@apple.com>

        AX: children() method should be consolidated in AccessibilityObject
        https://bugs.webkit.org/show_bug.cgi?id=70243

        Code cleanup, no new tests.

        Reviewed by Darin Adler.

        * accessibility/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::children):
        * accessibility/AccessibilityObject.h:
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::updateChildrenIfNecessary):
        * accessibility/AccessibilityRenderObject.h:
        * accessibility/AccessibilityScrollView.cpp:
        (WebCore::AccessibilityScrollView::updateChildrenIfNecessary):
        (WebCore::AccessibilityScrollView::updateScrollbars):
        (WebCore::AccessibilityScrollView::addChildren):
        * accessibility/AccessibilityScrollView.h:
        * accessibility/AccessibilitySlider.cpp:
        * accessibility/AccessibilitySlider.h:
        * accessibility/AccessibilityTableColumn.cpp:
        * accessibility/AccessibilityTableColumn.h:
        * accessibility/AccessibilityTableHeaderContainer.cpp:
        * accessibility/AccessibilityTableHeaderContainer.h:

2011-10-17  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Search matches highlighting in text does not work correctly.
        https://bugs.webkit.org/show_bug.cgi?id=70244

        Reviewed by Pavel Feldman.

        Test: inspector/utilities-highlight-results.html

        * inspector/front-end/utilities.js:
        ():

2011-10-17  Chris Fleizach  <cfleizach@apple.com>

        AX: webkit won't always send live region notifications
        https://bugs.webkit.org/show_bug.cgi?id=70030

        Webkit purposefully does not send live region notifications if some AT client has not accessed the AX tree in between 
        the last live region update (ostensibly to improve performance).
        However, this is problematic if a screen reader misses one notification... it has no idea what happened and the only 
        recourse is to rescan the page for changes. The correct thing to do is to always send notifications.

        Reviewed by Darin Adler.

        Test: platform/mac/accessibility/aria-liveregions-notifications-always-sent.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::childrenChanged):

2011-10-12  Pavel Podivilov  <podivilov@chromium.org>

        Web Inspector: fix handling of source mapping entries with no mapping.
        https://bugs.webkit.org/show_bug.cgi?id=69941

        Reviewed by Pavel Feldman.

        * inspector/front-end/CompilerSourceMapping.js:
        (WebInspector.ClosureCompilerSourceMapping.prototype._parseMappings):

2011-10-17  Mikhail Naganov  <mnaganov@chromium.org>

        Web Inspector: [Chromium] Add an ability to look up and explore an object from a heap profile.
        https://bugs.webkit.org/show_bug.cgi?id=61179

        This is exteremely helpful when dealing with DOM wrappers, as
        their properties are mostly implemented with getters and thus not
        stored in heap snapshots.

        Reviewed by Pavel Feldman.

        * English.lproj/localizedStrings.js:
        * bindings/js/ScriptProfiler.cpp:
        (WebCore::ScriptProfiler::objectByHeapObjectId):
        * bindings/js/ScriptProfiler.h:
        * bindings/v8/ScriptProfiler.cpp:
        (WebCore::ScriptProfiler::objectByHeapObjectId):
        * bindings/v8/ScriptProfiler.h:
        * inspector/Inspector.json:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::create):
        (WebCore::InspectorProfilerAgent::InspectorProfilerAgent):
        (WebCore::InspectorProfilerAgent::getObjectByHeapObjectId):
        * inspector/InspectorProfilerAgent.h:
        * inspector/front-end/DetailedHeapshotGridNodes.js:
        (WebInspector.HeapSnapshotGridNode.prototype.hasHoverMessage.false.queryObjectContent):
        (WebInspector.HeapSnapshotGenericObjectNode):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.get data):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.queryObjectContent.else.formatResult):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.queryObjectContent):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.shortenWindowURL):
        * inspector/front-end/DetailedHeapshotView.js:
        (WebInspector.DetailedHeapshotView.prototype._showObjectPopover):
        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get canBeQueried):
        (WebInspector.HeapSnapshotNode.prototype.get flags):
        (WebInspector.HeapSnapshotNode.prototype.get isDOMWindow):
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype.dispose):
        (WebInspector.HeapSnapshot.prototype._flagsOfNode):
        (WebInspector.HeapSnapshot.prototype._calculateFlags):
        (WebInspector.HeapSnapshot.prototype.updateStaticData):
        (WebInspector.HeapSnapshotNodesProvider.prototype._serialize):
        * inspector/front-end/HeapSnapshotProxy.js:
        (WebInspector.HeapSnapshotProxy.prototype.get nodeFlags):
        * inspector/front-end/RemoteObject.js:
        (WebInspector.RemoteObject.fromError):
        * inspector/front-end/heapProfiler.css:
        (.detailed-heapshot-view tr:not(.selected) td.object-column span.highlight):

2011-10-17  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: Editing CSS selector doesn't fire onResourceContentCommitted
        https://bugs.webkit.org/show_bug.cgi?id=70018

        Reviewed by Yury Semikhatsky.

        Test: inspector/styles/commit-selector.html

        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype.setRuleSelector.callback):
        (WebInspector.CSSStyleModel.prototype.setRuleSelector):

2011-10-17  Andreas Kling  <kling@webkit.org>

        CSS/XSLStyleSheet: Remove insert() and remove().
        https://bugs.webkit.org/show_bug.cgi?id=70226

        Reviewed by Antti Koivisto.

        Remove insert() and remove() from XSLStyleSheet. CSSStyleSheet retains remove()
        since it's used by InspectorStyleSheet as well as SVGFontFaceElement.

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::remove):

            Remove range check. This method is internal to WebKit and the call sites
            already take care of it.

        (WebCore::CSSStyleSheet::insertRule):
        (WebCore::CSSStyleSheet::deleteRule):
        * css/CSSStyleSheet.h:
        * xml/XSLStyleSheet.h:

2011-10-17  Rosen Dash  <rosen.dash@motorola.com>

        when CSS pseudo selectors are applied (:before and :after) the *-of-line keyboard navigation does not work
        https://bugs.webkit.org/show_bug.cgi?id=10123

        Reviewed by Ryosuke Niwa.

        This patch addresses folllowing two issues:
        1. When CSS pseudo elements are before or after is used with content attribute containing single character
           at the start/end of text and we try to move cursor by right navigation key, the page freezes falling
           into an infinite loop.
        2. When these elements try to insert some text between a text line, navigation by right/left arrow key is prohibited.

        Tests: editing/selection/css-pseudo-element-hang.html
               editing/selection/css-pseudo-element.html

        * editing/VisiblePosition.cpp:
        (WebCore::VisiblePosition::leftVisuallyDistinctCandidate):
        (WebCore::VisiblePosition::rightVisuallyDistinctCandidate):

2011-10-15  Antti Koivisto  <antti@apple.com>

        Test :visited pseudo class
        https://bugs.webkit.org/show_bug.cgi?id=70219

        Reviewed by Andreas Kling.
        
        Currently DRT doesn't support :visited. All tests where it should match have wrong checked in results.
        
        - Make <a href=""> to match :visited in DRT. It already does on browsers. A number of existing tests 
          for :visited use it already, the rest can be modified to use it.
        - Make render tree dumps correctly dump the visited state dependent color.

        * css/SelectorChecker.cpp:
        (WebCore::SelectorChecker::determineLinkStateSlowCase):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::RenderTreeAsText::writeRenderObject):

2011-10-17  Satish Sampath  <satish@chromium.org>

        Avoid leaking document when leaving google.com due to geolocation
        permission request.
        https://bugs.webkit.org/show_bug.cgi?id=58027

        Reviewed by Kenneth Rohde Christiansen.

        * page/Geolocation.cpp:
        (WebCore::Geolocation::Watchers::find): added
        (WebCore::Geolocation::reset): cleared all pending notifiers.
        (WebCore::Geolocation::clearWatch): removed from pending notifier set.
        * page/Geolocation.h:
        (WebCore::Geolocation::Watchers::find): added

2011-10-17  Andrei Lavreniyuk  <andy.lavr@gmail.com>

        Fix clang WebKitGTK+ build.

        Reviewed by Martin Robinson.

        * plugins/gtk/PluginViewGtk.cpp:

2011-10-16  Adam Barth  <abarth@webkit.org>

        Always disable ENABLE(ON_FIRST_TEXTAREA_FOCUS_SELECT_ALL) and delete associated code
        https://bugs.webkit.org/show_bug.cgi?id=70216

        Reviewed by Eric Seidel.

        No port enables this feature.  It was added for the previous Android
        port (and should have been an editing behavior in any case).

        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::updateFocusAppearance):

2011-10-16  Ryosuke Niwa  <rniwa@webkit.org>

        Expose rangeFromLocationAndLength and locationAndLengthFromRange via internals object
        https://bugs.webkit.org/show_bug.cgi?id=68330

        Reviewed by Hajime Morita.

        Add rangeFromLocationAndLength, locationFromRange, and lengthFromRange to window.internals.

        Test: editing/text-iterator/range-to-from-location-and-length.html

        * WebCore.exp.in:
        * testing/Internals.cpp:
        (WebCore::Internals::scrollElementToRect):
        (WebCore::Internals::rangeFromLocationAndLength):
        (WebCore::Internals::locationFromRange):
        (WebCore::Internals::lengthFromRange):
        * testing/Internals.h:
        * testing/Internals.idl:

2011-10-16  Kentaro Hara  <haraken@chromium.org>

        Generate MessageChannel constructor by [Constructor] IDL
        https://bugs.webkit.org/show_bug.cgi?id=70214

        Reviewed by Adam Barth.

        This patch generates an MessageChannel constructor for JSC by [Constructor] IDL,
        but V8 is still using a custom constructor since the V8 constructor requires special logic.

        Tests: fast/dom/global-constructors.html
               fast/events/message-port.html
               fast/events/message-port-no-wrapper.html
               fast/dom/Window/window-postmessage-args.html

        * bindings/js/JSMessageChannelCustom.cpp: Removed the MessageChannel constructor.
        * dom/MessageChannel.idl: Generates the MessageChannel constructor for JSC.

2011-10-16  Ryosuke Niwa  <rniwa@webkit.org>

        [Mac] fontForSelection and styleForSelectionStart should be moved to EditorMac
        https://bugs.webkit.org/show_bug.cgi?id=70114

        Reviewed by Hajime Morita.

        Moved fontForSelection and styleForSelectionStart from Editor to EditorMac
        and made styleForSelectionStart static local.

        * editing/Editor.cpp:
        * editing/Editor.h:
        * editing/mac/EditorMac.mm:
        (WebCore::styleForSelectionStart):
        (WebCore::Editor::fontForSelection):
        (WebCore::Editor::fontAttributesForSelectionStart):

2011-10-16  Kentaro Hara  <haraken@chromium.org>

        Generate EventSource constructor for JSC by [Constructor] IDL
        https://bugs.webkit.org/show_bug.cgi?id=70212

        Reviewed by Adam Barth.

        Removed JSEventSourceCustom.cpp.

        Tests: fast/dom/global-constructors.html
               fast/eventsource/eventsource-constructor.html
               fast/eventsource/eventsource-attribute-listeners.html

        * GNUmakefile.list.am: Removed JSEventSourceCustom.cpp.
        * UseJSC.cmake: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.pro: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * bindings/js/JSBindingsAllInOne.cpp: Ditto.
        * bindings/js/JSEventSourceCustom.cpp: Removed this file.
        * page/EventSource.idl: Removed 'JSCustomConstructor' IDL.

2011-10-16  David Barr  <davidbarr@chromium.org>

        Inline CSSPrimitiveValue::isQuirkValue() as non-virtual function
        https://bugs.webkit.org/show_bug.cgi?id=64865

        Reviewed by Darin Adler.

        Based on profiling and patch from:
        Tamas Czene <Czene.Tamas@stud.u-szeged.hu>

        This is expected to produce a small performance progression.
        Additional memory overhead is avoided by using spare bits.
        CSSQuirkPrimitiveValue is removed as it becomes just a factory.

        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.order:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValidPrimitive):
        * css/CSSParserValues.cpp:
        (WebCore::CSSParserValue::createCSSValue):
        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        * css/CSSPrimitiveValue.h:
        (WebCore::CSSPrimitiveValue::createAllowingMarginQuirk):
        Moved from CSSQuirkPrimitiveValue::create.
        (WebCore::CSSPrimitiveValue::isQuirkValue):
        * css/CSSQuirkPrimitiveValue.h: Removed.
        * css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):

2011-10-16  Kentaro Hara  <haraken@chromium.org>

        Generate XMLHttpRequest constructor for JSC by [Constructor] IDL
        https://bugs.webkit.org/show_bug.cgi?id=70208

        Reviewed by Adam Barth.

        This patch generates an XMLHttpRequest constructor for JSC by [Constructor] IDL,
        but V8 is still using a custom constructor since the V8 constructor requires a special logic.

        Tests: fast/dom/global-constructors.html
               fast/dom/XMLHttpRequest-constants.html
               fast/dom/xmlhttprequest-constructor-in-detached-document.html
               http/tests/security/cookies/xmlhttprequest.html

        * bindings/js/JSXMLHttpRequestCustom.cpp: Removed an XMLHttpRequest custom constructor.
        * bindings/scripts/CodeGeneratorV8.pm: Currently, CodeGeneratorV8.pm generates constructor code whenever [Constructor] is specified, even if [V8CustomConstructor] is specified. This is wrong. This patch fixes the condition where the constructor code is generated.
        * bindings/scripts/test/V8/V8TestObj.cpp: Updated a run-binding-tests result.
        * xml/XMLHttpRequest.h: Added a necessary header.
        * xml/XMLHttpRequest.idl: V8 is still using a custom constructor.

2011-10-16  Kentaro Hara  <haraken@chromium.org>

        Generate XSLTProcessor constructor for JSC by [Constructor] IDL.
        https://bugs.webkit.org/show_bug.cgi?id=70206

        Reviewed by Adam Barth.

        Tests: fast/xsl/xslt-processor.html
               fast/xsl/default-html.html
               fast/dom/global-constructors.html

        * bindings/js/JSXSLTProcessorCustom.cpp: Removed a custom constructor.
        * xml/XSLTProcessor.idl: Removed 'JSCustomConstructor'.

2011-10-16  Kentaro Hara  <haraken@chromium.org>

        Support [Constructor] IDL for JSC.
        https://bugs.webkit.org/show_bug.cgi?id=70101

        Reviewed by Adam Barth.

        The spec for [Constructor] IDL is here: http://www.w3.org/TR/WebIDL/#Constructor
        This patch introduced [Constructor] IDL for JSC. This patch also added
        [ConstructorRaisesException] for JSC. If [ConstructorRaisesException] is specified,
        a placeholder for ExceptionCode is passed to XXX::create(), like XXX::create(..., ec).

        Notes:
        - We do not yet support constructor overloading.
        - We do not yet support [Optional] without CallWithDefaultValue for constructor arguments.

        Tests: Source/WebCore/bindings/scripts/test/TestInterface.idl
               Source/WebCore/bindings/scripts/test/TestObj.idl

        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader): Generates constructor declaration code to a header file, if a given DOM object has constructor.
        (GenerateImplementation): Uses GenerateArgumentsCountCheck() and GenerateParametersCheck().
        (GenerateArgumentsCountCheck): Splits out of GenerateImplementation() for reuse.
        (GenerateParametersCheck): Splits out of GenerateImplementation() for reuse.
        (GenerateConstructorDefinition): Generates constructor definition code.
        * bindings/scripts/test/JS/JSTestInterface.cpp: Updated the run-binding-tests results.
        (WebCore::JSTestInterfaceConstructor::constructJSTestInterface):
        * bindings/scripts/test/JS/JSTestInterface.h: Ditto.
        (WebCore::JSTestInterfaceConstructor::create):
        (WebCore::JSTestInterfaceConstructor::createStructure):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp: Ditto.
        (WebCore::jsTestMediaQueryListListenerPrototypeFunctionMethod):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.h: Ditto.
        (WebCore::JSTestMediaQueryListListenerConstructor::create):
        (WebCore::JSTestMediaQueryListListenerConstructor::createStructure):
        * bindings/scripts/test/JS/JSTestObj.cpp: Ditto.
        (WebCore::jsTestObjPrototypeFunctionVoidMethod):
        (WebCore::jsTestObjPrototypeFunctionVoidMethodWithArgs):
        (WebCore::jsTestObjPrototypeFunctionIntMethod):
        (WebCore::jsTestObjPrototypeFunctionIntMethodWithArgs):
        (WebCore::jsTestObjPrototypeFunctionObjMethod):
        (WebCore::jsTestObjPrototypeFunctionObjMethodWithArgs):
        (WebCore::jsTestObjPrototypeFunctionMethodThatRequiresAllArgs):
        (WebCore::jsTestObjPrototypeFunctionMethodThatRequiresAllArgsAndThrows):
        (WebCore::jsTestObjPrototypeFunctionSerializedValue):
        (WebCore::jsTestObjPrototypeFunctionIdbKey):
        (WebCore::jsTestObjPrototypeFunctionOptionsObject):
        (WebCore::jsTestObjPrototypeFunctionMethodWithException):
        (WebCore::jsTestObjPrototypeFunctionCustomArgsAndException):
        (WebCore::jsTestObjPrototypeFunctionAddEventListener):
        (WebCore::jsTestObjPrototypeFunctionRemoveEventListener):
        (WebCore::jsTestObjPrototypeFunctionWithDynamicFrame):
        (WebCore::jsTestObjPrototypeFunctionWithDynamicFrameAndArg):
        (WebCore::jsTestObjPrototypeFunctionWithDynamicFrameAndOptionalArg):
        (WebCore::jsTestObjPrototypeFunctionWithDynamicFrameAndUserGesture):
        (WebCore::jsTestObjPrototypeFunctionWithDynamicFrameAndUserGestureASAD):
        (WebCore::jsTestObjPrototypeFunctionWithScriptStateVoid):
        (WebCore::jsTestObjPrototypeFunctionWithScriptStateObj):
        (WebCore::jsTestObjPrototypeFunctionWithScriptStateVoidException):
        (WebCore::jsTestObjPrototypeFunctionWithScriptStateObjException):
        (WebCore::jsTestObjPrototypeFunctionWithScriptExecutionContext):
        (WebCore::jsTestObjPrototypeFunctionMethodWithOptionalArg):
        (WebCore::jsTestObjPrototypeFunctionMethodWithNonOptionalArgAndOptionalArg):
        (WebCore::jsTestObjPrototypeFunctionMethodWithNonOptionalArgAndTwoOptionalArgs):
        (WebCore::jsTestObjPrototypeFunctionMethodWithCallbackArg):
        (WebCore::jsTestObjPrototypeFunctionMethodWithNonCallbackArgAndCallbackArg):
        (WebCore::jsTestObjPrototypeFunctionMethodWithCallbackAndOptionalArg):
        (WebCore::jsTestObjPrototypeFunctionConditionalMethod1):
        (WebCore::jsTestObjPrototypeFunctionConditionalMethod2):
        (WebCore::jsTestObjPrototypeFunctionConditionalMethod3):
        (WebCore::jsTestObjPrototypeFunctionOverloadedMethod1):
        (WebCore::jsTestObjPrototypeFunctionOverloadedMethod2):
        (WebCore::jsTestObjPrototypeFunctionOverloadedMethod3):
        (WebCore::jsTestObjPrototypeFunctionOverloadedMethod4):
        (WebCore::jsTestObjPrototypeFunctionOverloadedMethod5):
        (WebCore::jsTestObjPrototypeFunctionClassMethod):
        (WebCore::jsTestObjPrototypeFunctionClassMethodWithOptional):
        * bindings/scripts/test/JS/JSTestObj.h: Ditto.
        (WebCore::JSTestObjConstructor::create):
        (WebCore::JSTestObjConstructor::createStructure):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp: Ditto.
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h: Ditto.
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::create):
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::createStructure):

2011-10-16  Dmitry Lomov  <dslomov@google.com>

        https://bugs.webkit.org/show_bug.cgi?id=70186
        Pass MessagePortArray to JSC's SerializedScriptValue::serialize/deserialize.

        Reviewed by Oliver Hunt.

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::handlePostMessage):
        (WebCore::JSDOMWindow::postMessage):
        (WebCore::JSDOMWindow::webkitPostMessage):
        * bindings/js/JSDictionary.cpp:
        (WebCore::JSDictionary::convertValue):
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::JSHistory::pushState):
        (WebCore::JSHistory::replaceState):
        * bindings/js/JSMessageEventCustom.cpp:
        (WebCore::JSMessageEvent::data):
        (WebCore::handleInitMessageEvent):
        (WebCore::JSMessageEvent::initMessageEvent):
        (WebCore::JSMessageEvent::webkitInitMessageEvent):
        * bindings/js/JSMessagePortCustom.h:
        (WebCore::handlePostMessage):
        * bindings/js/JSPopStateEventCustom.cpp:
        (WebCore::JSPopStateEvent::state):
        * bindings/js/ScriptValue.cpp:
        (WebCore::ScriptValue::serialize):
        (WebCore::ScriptValue::deserialize):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValue::create):
        (WebCore::SerializedScriptValue::deserialize):
        * bindings/js/SerializedScriptValue.h:

2011-10-16  Dan Bernstein  <mitz@apple.com>

        REGRESSION (r96620): Float-avoiding block positioned incorrectly in right-to-left block
        https://bugs.webkit.org/show_bug.cgi?id=70197

        Reviewed by Dave Kilzer.

        Test: fast/block/float/avoidance-rtl.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::computeStartPositionDeltaForChildAvoidingFloats): Changed
        logicalLeftOffsetForContent() to startOffsetForContent() to get the right value in the
        right-to-left case.

2011-10-16  Adam Barth  <abarth@webkit.org>

        Always enable ENABLE(DOM_STORAGE)
        https://bugs.webkit.org/show_bug.cgi?id=70189

        Reviewed by Eric Seidel.

        As discussed on webkit-dev, we are reducing the complexity of WebKit by
        removing unnecessary configuration options.  DOMStorage is not a core
        part of the web platform.  It should always be enabled.

        * CMakeLists.txt:
        * Configurations/FeatureDefines.xcconfig:
        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * UseJSC.cmake:
        * WebCore.exp.in:
        * WebCore.pro:
        * bindings/js/JSEventCustom.cpp:
        * bindings/js/JSInjectedScriptHostCustom.cpp:
        * bindings/js/JSStorageCustom.cpp:
        * bindings/v8/custom/V8EventCustom.cpp:
        (WebCore::toV8):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::V8InjectedScriptHost::storageIdCallback):
        * bindings/v8/custom/V8StorageCustom.cpp:
        * dom/Document.cpp:
        (WebCore::Document::createEvent):
        * dom/Event.cpp:
        (WebCore::Event::isStorageEvent):
        * dom/Event.h:
        * dom/Node.cpp:
        * features.pri:
        * inspector/InjectedScriptHost.cpp:
        (WebCore::InjectedScriptHost::InjectedScriptHost):
        (WebCore::InjectedScriptHost::disconnect):
        (WebCore::InjectedScriptHost::storageIdImpl):
        * inspector/InjectedScriptHost.h:
        (WebCore::InjectedScriptHost::init):
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::connectFrontend):
        (WebCore::InspectorController::disconnectFrontend):
        (WebCore::InspectorController::restoreInspectorStateFromCookie):
        * inspector/InspectorController.h:
        * inspector/InspectorDOMStorageAgent.cpp:
        * inspector/InspectorDOMStorageResource.cpp:
        * inspector/InspectorDOMStorageResource.h:
        * inspector/InspectorInstrumentation.cpp:
        (WebCore::InspectorInstrumentation::didCommitLoadImpl):
        (WebCore::InspectorInstrumentation::didUseDOMStorageImpl):
        * inspector/InspectorInstrumentation.h:
        (WebCore::InspectorInstrumentation::didUseDOMStorage):
        * inspector/InstrumentingAgents.h:
        (WebCore::InstrumentingAgents::InstrumentingAgents):
        * inspector/WorkerInspectorController.cpp:
        (WebCore::WorkerInspectorController::WorkerInspectorController):
        (WebCore::WorkerInspectorController::connectFrontend):
        * inspector/generate-inspector-idl:
        * page/Chrome.cpp:
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::~DOMWindow):
        (WebCore::DOMWindow::clear):
        (WebCore::DOMWindow::localStorage):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:
        * page/Navigator.cpp:
        (WebCore::Navigator::getStorageUpdates):
        * page/Navigator.h:
        * page/Navigator.idl:
        * page/Page.cpp:
        * page/Page.h:
        * page/PageGroup.cpp:
        (WebCore::PageGroup::closeLocalStorage):
        * page/PageGroup.h:
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        (WebCore::Settings::setSessionStorageQuota):
        * page/Settings.h:
        (WebCore::Settings::sessionStorageQuota):
        * storage/LocalStorageTask.cpp:
        * storage/LocalStorageTask.h:
        * storage/LocalStorageThread.cpp:
        * storage/LocalStorageThread.h:
        * storage/Storage.cpp:
        * storage/Storage.h:
        * storage/Storage.idl:
        * storage/StorageArea.h:
        * storage/StorageAreaImpl.cpp:
        * storage/StorageAreaImpl.h:
        * storage/StorageAreaSync.cpp:
        (WebCore::StorageAreaSync::scheduleSync):
        * storage/StorageAreaSync.h:
        * storage/StorageEvent.cpp:
        * storage/StorageEvent.h:
        * storage/StorageEvent.idl:
        * storage/StorageEventDispatcher.cpp:
        * storage/StorageEventDispatcher.h:
        * storage/StorageMap.cpp:
        * storage/StorageMap.h:
        * storage/StorageNamespace.cpp:
        * storage/StorageNamespace.h:
        * storage/StorageNamespaceImpl.cpp:
        * storage/StorageNamespaceImpl.h:
        * storage/StorageSyncManager.cpp:
        (WebCore::StorageSyncManager::scheduleDeleteEmptyDatabase):
        * storage/StorageSyncManager.h:
        * storage/StorageTracker.cpp:
        * storage/StorageTracker.h:

2011-10-15  Adam Barth  <abarth@webkit.org>

        Rename ENABLE(SKIA_TEXT) to USE(SKIA_TEXT)
        https://bugs.webkit.org/show_bug.cgi?id=70191

        Reviewed by Daniel Bates.

        SKIA_TEXT is not a WebKit feature.  It's a macro that determines
        whether we use a feature of the underly library (Skia).

        * platform/graphics/chromium/FontChromiumWin.cpp:
        (WebCore::Font::drawComplexText):
        * platform/graphics/chromium/UniscribeHelper.cpp:
        (WebCore::UniscribeHelper::draw):
        * platform/graphics/skia/PlatformContextSkia.cpp:
        (WebCore::PlatformContextSkia::isNativeFontRenderingAllowed):
        * platform/graphics/skia/PlatformContextSkia.h:
        * platform/graphics/skia/SkiaFontWin.cpp:
        * platform/graphics/skia/SkiaFontWin.h:

2011-10-15  Eric Carlson  <eric.carlson@apple.com>

        Make VIDEO_TRACK compile with warnings as errors enabled
        https://bugs.webkit.org/show_bug.cgi?id=70188

        Reviewed by Filip Pizlo.

        No new tests, no functionality changed.

        * html/TextTrackCueList.h: Fix an include.
        * html/track/CueParser.cpp:
        (WebCore::CueParser::supportsType): Remove unused param.
        * html/track/CueParser.h:
        (WebCore::CueParserClient::~CueParserClient): Add virtual destructor.
        * html/track/CueParserPrivate.h:
        (WebCore::CueParserPrivateClient::~CueParserPrivateClient): Ditto.
        * loader/CueLoader.h:
        (WebCore::CueLoaderClient::~CueLoaderClient): Ditto.
        (WebCore::CueLoader::~CueLoader): Ditto.

2011-10-15  Adam Barth  <abarth@webkit.org>

        Rename ENABLE(TILED_BACKING_STORE) to USE(TILED_BACKING_STORE)
        https://bugs.webkit.org/show_bug.cgi?id=70194

        Reviewed by Daniel Bates.

        TILED_BACKING_STORE isn't a web platform feature.  It's an
        implementation strategy for WebKit that's used by some ports
        and not by others.

        * features.pri:
        * loader/EmptyClients.h:
        * page/Chrome.cpp:
        * page/Chrome.h:
        * page/ChromeClient.h:
        * page/Frame.cpp:
        (WebCore::Frame::Frame):
        (WebCore::Frame::setView):
        * page/Frame.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::repaintContentRectangle):
        (WebCore::FrameView::doDeferredRepaints):
        * page/Settings.cpp:
        (WebCore::Settings::setTiledBackingStoreEnabled):
        * platform/HostWindow.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::setScrollPosition):
        * platform/graphics/Tile.h:
        * platform/graphics/TiledBackingStore.cpp:
        * platform/graphics/TiledBackingStore.h:
        * platform/graphics/TiledBackingStoreBackend.h:
        * platform/graphics/TiledBackingStoreClient.h:
        * platform/graphics/qt/GraphicsLayerQt.cpp:
        (WebCore::GraphicsLayerQtImpl::GraphicsLayerQtImpl):
        (WebCore::GraphicsLayerQtImpl::~GraphicsLayerQtImpl):
        (WebCore::GraphicsLayerQtImpl::recache):
        (WebCore::GraphicsLayerQtImpl::paint):
        * platform/graphics/qt/TileQt.cpp:
        * platform/graphics/qt/TileQt.h:
        * platform/graphics/texmap/TextureMapperNode.cpp:
        (WebCore::TextureMapperNode::computeTiles):
        (WebCore::TextureMapperNode::renderContent):
        (WebCore::TextureMapperNode::paintSelf):
        (WebCore::TextureMapperNode::syncCompositingStateSelf):
        * platform/graphics/texmap/TextureMapperNode.h:
        (WebCore::TextureMapperNode::State::State):

2011-10-15  Adam Barth  <abarth@webkit.org>

        Remove the last remnant of WBXML
        https://bugs.webkit.org/show_bug.cgi?id=70187

        Reviewed by Daniel Bates.

        The bulk of the WBXML code was removed in 2009, but we missed one block.

        * platform/wince/MIMETypeRegistryWinCE.cpp:
        (WebCore::initMIMETypeEntensionMap):

2011-10-15  Darin Adler  <darin@apple.com>

        REGRESSION(r97533): fast/forms/select-script-onchange.html failed after
        https://bugs.webkit.org/show_bug.cgi?id=70173

        Reviewed by Ryosuke Niwa.

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::setValue): Removed unneeded boolean argument
        [true for deselect].
        (WebCore::HTMLSelectElement::menuListDefaultEventHandler): Added explicit
        boolean arguments for all calls to setSelectedIndex to restore pre-r97533
        behavior.
        (WebCore::HTMLSelectElement::typeAheadFind): Ditto.
        (WebCore::HTMLSelectElement::accessKeySetSelectedIndex): Ditto.

        * html/HTMLSelectElement.h:
        Removed default of true for userDrivenChange. Each caller should pass it
        explicitly. Longer term we should use an enum instead of a boolean or find
        some other way of avoiding the argument.
        (WebCore::HTMLSelectElement::setSelectedIndex):
        Pass false for userDrivenChange as the old code did pre-r97533.

2011-10-15  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        [Qt] [Symbian] Remove support for the Symbian platform for the QtWebKit port
        https://bugs.webkit.org/show_bug.cgi?id=69920

        Reviewed by Kenneth Rohde Christiansen.

        No new tests as there is no new functionality.

        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * bindings/v8/V8GCController.cpp:
        (WebCore::V8GCController::checkMemoryUsage):
        * config.h:
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::operator int):
        * features.pri:
        * page/NavigatorBase.cpp:
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContextPlatformPrivate::GraphicsContextPlatformPrivate):
        * platform/network/qt/ResourceRequestQt.cpp:
        (WebCore::initializeMaximumHTTPConnectionCountPerHost):
        * platform/text/qt/TextCodecQt.cpp:
        (WebCore::TextCodecQt::decode):
        * plugins/PluginDatabase.cpp:
        * plugins/PluginPackage.cpp:
        (WebCore::PluginPackage::unload):
        * plugins/PluginPackage.h:
        (WebCore::PluginPackage::version):
        * plugins/PluginView.cpp:
        (WebCore::PluginView::setFrameRect):
        * plugins/PluginView.h:
        * plugins/npapi.h:
        * plugins/symbian: Removed.
        * plugins/symbian/PluginContainerSymbian.cpp: Removed.
        * plugins/symbian/PluginContainerSymbian.h: Removed.
        * plugins/symbian/PluginDatabaseSymbian.cpp: Removed.
        * plugins/symbian/PluginPackageSymbian.cpp: Removed.
        * plugins/symbian/PluginViewSymbian.cpp: Removed.
        * plugins/symbian/npinterface.h: Removed.

2011-10-08  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: height-width-table-001.htm
        https://bugs.webkit.org/show_bug.cgi?id=69709

        Reviewed by Simon Fraser.

        CSS 2.1 expects CSS table elements to treat fixed height/width as
        excluding table borders, but HTML table elements to treat fixed height/width as
        including them.
        
        See http://lists.w3.org/Archives/Public/www-style/2011Jan/0178.html
            http://lists.w3.org/Archives/Public/public-css-testsuite/2011Oct/0005.html
            
        It looks like some clarification is pending in the specs, but the new behaviour
        lets WebKit pass the following tests in the suite CSS and also match FF:
          height-width-table-001.htm
          height-width-inline-table-001.htm
          abspos-containing-block-initial-004d.htm

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::computeLogicalWidth):
        (WebCore::RenderTable::layout):

2011-10-15  Darin Adler  <darin@apple.com>

        Make toHTMLElement fail to compile if you try to use it on an HTMLElement*
        https://bugs.webkit.org/show_bug.cgi?id=70164

        Reviewed by Adam Barth.

        Refactoring covered by existing tests.

        * bindings/js/JSHTMLFrameSetElementCustom.cpp:
        (WebCore::JSHTMLFrameSetElement::nameGetter): Removed unneeded casts and
        some unneeded local variables as well. Changed the name of the local variable
        for the HTMLFrameElement to frameElement to avoid confusion with the Frame.
        * dom/Document.cpp:
        (WebCore::Document::openSearchDescriptionURL): Removed unneeded HTMLElement
        check; we can call hasTagName directly on a Node and that takes care of
        checking both that it's an HTMLElement and checking the tag name.
        * dom/MicroDataItemList.cpp:
        (WebCore::MicroDataItemList::nodeMatches): Use toHTMLElement instead of
        a cast. Also changed hasAttribute calls to fastHasAttribute and getAttribute
        calls to fastGetAttribute since these are neither style attributes nor SVG
        animatables.
        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::applyInlineStyleToPushDown): Use toHTMLElement.
        (WebCore::ApplyStyleCommand::addInlineStyleIfNeeded): Ditto.
        * editing/DeleteButtonController.cpp:
        (WebCore::DeleteButtonController::show): Removed unneeded toHTMLElement call.
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::setOuterHTML): Use toHTMLElement.
        * html/HTMLElement.h: Added toHTMLElement overload to catch calls when the
        pointer is already HTMLElement* or a pointer to a class derived from it.
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::recalcListItems): Use toHTMLElement.
        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::innerTextElement): Use toHTMLElement.

2011-10-15  Antoine Labour  <piman@chromium.org>

        Add WebAcceleratedContentLayer backed by a texture to support accelerated content hosting
        https://bugs.webkit.org/show_bug.cgi?id=70084

        Reviewed by James Robinson.

        Covered by existing compositing/ tests

        * platform/graphics/chromium/LayerChromium.h:
        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::pluginLayerProgramFlip):
        (WebCore::LayerRendererChromium::cleanupSharedObjects):
        * platform/graphics/chromium/LayerRendererChromium.h:
        * platform/graphics/chromium/PluginLayerChromium.cpp:
        (WebCore::PluginLayerChromium::PluginLayerChromium):
        (WebCore::PluginLayerChromium::setTextureId):
        (WebCore::PluginLayerChromium::setFlipped):
        (WebCore::PluginLayerChromium::pushPropertiesTo):
        * platform/graphics/chromium/PluginLayerChromium.h:
        (WebCore::PluginLayerChromium::flipped):
        * platform/graphics/chromium/cc/CCPluginLayerImpl.cpp:
        (WebCore::CCPluginLayerImpl::CCPluginLayerImpl):
        (WebCore::CCPluginLayerImpl::draw):
        * platform/graphics/chromium/cc/CCPluginLayerImpl.h:
        (WebCore::CCPluginLayerImpl::setFlipped):

2011-10-15  Michael Nordman  <michaeln@google.com>

        [Chromium] Some WebSQLDatabase in worker bug fixes.
        https://bugs.webkit.org/show_bug.cgi?id=70071

        - Test for a NULL webView WebWorkerClientImpl.
        - Avoid altering Database instance lifetimes during WorkerThread::stop().

        Existing tests coverage applies.

        Reviewed by David Levin.

        * storage/chromium/DatabaseTrackerChromium.cpp:
        (WebCore::DatabaseTracker::interruptAllDatabasesForContext):

2011-10-14  Adam Barth  <abarth@webkit.org>

        Update expected results.

        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjInternal::serializedValueCallback):

2011-10-14  Ryosuke Niwa  <rniwa@webkit.org>

        GTK build fix after r97533.

        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::notifyChildrenSelectionChange):
        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (optionFromSelection):
        (webkit_accessible_selection_get_selection_count):

2011-10-14  David Kilzer  <ddkilzer@apple.com>

        <http://webkit.org/b/70158> Fix clang compiler warnings

        Reviewed by Darin Adler.

        * dom/ViewportArguments.cpp:
        (WebCore::computeViewportAttributes): Use std::max<float>()
        instead of std::max().

2011-10-14  Mark Hahnenberg  <mhahnenberg@apple.com>

        Rename getOwnPropertySlot to getOwnPropertySlotVirtual
        https://bugs.webkit.org/show_bug.cgi?id=69810

        Reviewed by Geoffrey Garen.

        No new tests.

        Renamed the virtual version of getOwnPropertySlot to getOwnPropertySlotVirtual
        in preparation for when we add the static getOwnPropertySlot to the MethodTable 
        in ClassInfo.

        Also added a few static getOwnPropertySlot functions where they had been overlooked 
        before (especially in CodeGeneratorJS.pm).

        * WebCore.exp.in:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::getOwnPropertySlotVirtual):
        (WebCore::JSDOMWindow::getOwnPropertySlot):
        (WebCore::DialogHandler::returnValue):
        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::getOwnPropertySlotVirtual):
        (WebCore::JSDOMWindowShell::getOwnPropertySlot):
        * bindings/js/JSDOMWindowShell.h:
        * bindings/js/JSWorkerContextCustom.cpp:
        (WebCore::JSWorkerContext::getOwnPropertySlotDelegate):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::CloneSerializer::getSparseIndex):
        (WebCore::CloneSerializer::getProperty):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateGetOwnPropertySlotBody):
        (GenerateHeader):
        (GenerateImplementation):
        (GenerateConstructorDeclaration):
        (GenerateConstructorDefinition):
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterfaceConstructor::getOwnPropertySlotVirtual):
        (WebCore::JSTestInterfaceConstructor::getOwnPropertySlot):
        (WebCore::JSTestInterface::getOwnPropertySlotVirtual):
        (WebCore::JSTestInterface::getOwnPropertySlot):
        * bindings/scripts/test/JS/JSTestInterface.h:
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.cpp:
        (WebCore::JSTestMediaQueryListListenerConstructor::getOwnPropertySlotVirtual):
        (WebCore::JSTestMediaQueryListListenerConstructor::getOwnPropertySlot):
        (WebCore::JSTestMediaQueryListListenerPrototype::getOwnPropertySlotVirtual):
        (WebCore::JSTestMediaQueryListListenerPrototype::getOwnPropertySlot):
        (WebCore::JSTestMediaQueryListListener::getOwnPropertySlotVirtual):
        (WebCore::JSTestMediaQueryListListener::getOwnPropertySlot):
        * bindings/scripts/test/JS/JSTestMediaQueryListListener.h:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::JSTestObjConstructor::getOwnPropertySlotVirtual):
        (WebCore::JSTestObjConstructor::getOwnPropertySlot):
        (WebCore::JSTestObjPrototype::getOwnPropertySlotVirtual):
        (WebCore::JSTestObjPrototype::getOwnPropertySlot):
        (WebCore::JSTestObj::getOwnPropertySlotVirtual):
        (WebCore::JSTestObj::getOwnPropertySlot):
        * bindings/scripts/test/JS/JSTestObj.h:
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::getOwnPropertySlotVirtual):
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::getOwnPropertySlot):
        (WebCore::JSTestSerializedScriptValueInterface::getOwnPropertySlotVirtual):
        (WebCore::JSTestSerializedScriptValueInterface::getOwnPropertySlot):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.h:
        * bridge/objc/objc_runtime.h:
        * bridge/objc/objc_runtime.mm:
        (JSC::Bindings::ObjcFallbackObjectImp::getOwnPropertySlotVirtual):
        * bridge/qt/qt_instance.cpp:
        (JSC::Bindings::QtInstance::getOwnPropertySlot):
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::QtRuntimeMetaMethod::getOwnPropertySlotVirtual):
        (JSC::Bindings::QtRuntimeConnectionMethod::getOwnPropertySlotVirtual):
        * bridge/qt/qt_runtime.h:
        * bridge/runtime_array.cpp:
        (JSC::RuntimeArray::getOwnPropertySlotVirtual):
        * bridge/runtime_array.h:
        * bridge/runtime_method.cpp:
        (JSC::RuntimeMethod::getOwnPropertySlotVirtual):
        * bridge/runtime_method.h:
        * bridge/runtime_object.cpp:
        (JSC::Bindings::RuntimeObject::getOwnPropertySlotVirtual):
        * bridge/runtime_object.h:

2011-10-14  Ryosuke Niwa  <rniwa@webkit.org>

        Windows build fix attempt after r97533.

        * html/HTMLSelectElementWin.cpp:
        (WebCore::HTMLSelectElement::platformHandleKeydownEvent):

2011-10-14  Darin Adler  <darin@apple.com>

        Follow up the recent HTMLSelectElement improvements with a little bit more
        https://bugs.webkit.org/show_bug.cgi?id=70139

        Reviewed by Ryosuke Niwa.

        Refactoring, covered by existing tests.

        Mostly, this adds a toHTMLSelectElement and uses it wherever possible.

        * accessibility/AccessibilityListBox.cpp:
        (WebCore::AccessibilityListBox::canSetSelectedChildrenAttribute): Use toHTMLSelectElement.
        (WebCore::AccessibilityListBox::addChildren): Ditto. Also removed unneeded toHTMLElement.
        * accessibility/AccessibilityMenuListPopup.cpp:
        (WebCore::AccessibilityMenuListPopup::addChildren): Ditto.
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::isMultiSelectable): Ditto.
        (WebCore::AccessibilityRenderObject::stringValue): Removed checks on the type of the
        underlying node, since other code already assumes that a menu list renderer is only
        created for a select element. Streamlined the code a bit and removed some unneeded
        local variables.
        * bindings/js/JSHTMLOptionsCollectionCustom.cpp:
        (WebCore::JSHTMLOptionsCollection::indexSetter): Use toHTMLSelectElement.
        * bindings/js/JSHTMLSelectElementCustom.cpp:
        (WebCore::JSHTMLSelectElement::remove): Ditto.
        (WebCore::JSHTMLSelectElement::indexSetter): Ditto.
        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::selectAll): Ditto.
        * html/HTMLKeygenElement.cpp:
        (WebCore::HTMLKeygenElement::shadowSelect): Ditto.
        * html/HTMLOptGroupElement.cpp:
        (WebCore::HTMLOptGroupElement::recalcSelectOptions): Ditto.
        (WebCore::HTMLOptGroupElement::ownerSelectElement): Ditto.
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::selected): Changed code to call renamed
        updateListItemSelectedStates rather than the confusing old name
        recalcListItemsIfNeeded.
        (WebCore::HTMLOptionElement::childrenChanged): Changed to call
        optionElementChildrenChanged rather than calling childrenChanged,
        because the children of the select element did not change!
        (WebCore::HTMLOptionElement::ownerSelectElement): Use toHTMLSelectElement.
        * html/HTMLOptionsCollection.cpp:
        (WebCore::HTMLOptionsCollection::add): Use toHTMLSelectElement.
        (WebCore::HTMLOptionsCollection::remove): Use toHTMLSelectElement.
        (WebCore::HTMLOptionsCollection::selectedIndex): Use toHTMLSelectElement.
        (WebCore::HTMLOptionsCollection::setSelectedIndex): Use toHTMLSelectElement.
        (WebCore::HTMLOptionsCollection::setLength): Use toHTMLSelectElement.
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::setSelectedIndexByUser): Call setSelectedIndex
        without the now-unneeded internal suffix.
        (WebCore::HTMLSelectElement::parseMappedAttribute): When the code says that
        we should "determine selectedness of the items", call updateListItemSelectedStates
        rather than the confusingly named recalcListItemsIfNeeded.
        (WebCore::HTMLSelectElement::updateListItemSelectedStates): Renamed
        recalcListItemsIfNeeded to this, since that's what this function is for.
        (WebCore::HTMLSelectElement::optionElementChildrenChanged): Added. Does
        the same work as childrenChanged, although it does not call up to the
        base class childrenChanged function. Later we might find we can remove
        some of the work here, for example it's not clear we should call the
        accessibility childrenChanged function.
        (WebCore::HTMLSelectElement::nextValidIndex): Changed this to a member function
        and made it get the list items itself rather than requiring they be passed in.
        (WebCore::HTMLSelectElement::nextSelectableListIndex): Updated for change to
        nextValidIndex.
        (WebCore::HTMLSelectElement::previousSelectableListIndex): Ditto.
        (WebCore::HTMLSelectElement::firstSelectableListIndex): Ditto.
        (WebCore::HTMLSelectElement::lastSelectableListIndex): Ditto.
        (WebCore::HTMLSelectElement::nextSelectableListIndexPageAway): Ditto.
        (WebCore::HTMLSelectElement::listItems): Removed unneeded const_cast, since
        recalcListItems is now a const member function. Call recalcListItems by that
        name instead of recalcListItemsInternal.
        (WebCore::HTMLSelectElement::recalcListItems): Renamed from recalcListItemsInternal
        and made this a const member function. The data members that this needs to modify
        are now mutable.
        (WebCore::HTMLSelectElement::setSelectedIndex): Renamed from setSelectedIndexInternal.
        Changed call to updateValidity to instead call setNeedsValidityCheck, since both
        do the same thing.
        (WebCore::HTMLSelectElement::parseMultipleAttribute): Ditto.
        (WebCore::HTMLSelectElement::menuListDefaultEventHandler): Updated for change to
        nextValidIndex, removed unneeded comparison with zero that's already handled by
        casting to an unsigned type, and use setSelectedIndex instead of using
        setSelectedIndexInternal since they are both the same thing.
        (WebCore::HTMLSelectElement::listBoxDefaultEventHandler): Removed another unneeded
        comparision with zero that's handled by casting to an unsigned type.
        (WebCore::HTMLSelectElement::lastSelectedListIndex): Use size_t instead of unsigned
        for a vector index.
        (WebCore::HTMLSelectElement::typeAheadFind): Use setSelectedIndex instead of
        setSelectedIndexInternal.
        (WebCore::HTMLSelectElement::insertedIntoTree): Removed unneeded explicit boolean
        when calling a function that already has a default value of true.
        (WebCore::HTMLSelectElement::accessKeySetSelectedIndex): Use setSelectedIndex
        instead of setSelectedIndexInternal.

        * html/HTMLSelectElement.h: Made childrenChanged private. Added
        optionElementChildrenChanged. Renamed recalcListItemsIfNeeded to the clearer
        updateListItemSelectedStates. Removed unused listBoxSelectItem. Removed
        updateValidity after changing all callers to instead call setNeedsValidityCheck.
        Made canSelectAll and selectAll non-virtual. Removed recalcListItemsInternal
        since it's the same thing as recalcListItems now. Renamed setSelectedIndexInternal
        to setSelectedIndex since it's the same function, just with a few arguments we
        don't want to allow outside callers to pass. Changed nextValidIndex into a
        non-static member function. Made m_listItems and m_shouldRecalcListItems mutable.
        Added a toHTMLSelectElement function, modeled on the toElement function.

        * html/ValidityState.cpp:
        (WebCore::ValidityState::valueMissing): Use toHTMLSelectElement.
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::updateFromElement): Ditto.
        (WebCore::RenderListBox::scrollToRevealSelection): Ditto.
        (WebCore::RenderListBox::size): Ditto.
        (WebCore::RenderListBox::numItems): Ditto.
        (WebCore::RenderListBox::addFocusRingRects): Ditto.
        (WebCore::RenderListBox::paintItemForeground): Ditto.
        (WebCore::RenderListBox::paintItemBackground): Ditto.
        (WebCore::RenderListBox::panScroll): Ditto.
        (WebCore::RenderListBox::autoscroll): Ditto.
        (WebCore::RenderListBox::stopAutoscroll): Ditto.
        (WebCore::RenderListBox::valueChanged): Ditto.
        (WebCore::RenderListBox::nodeAtPoint): Ditto.
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::updateOptionsWidth): Ditto.
        (WebCore::RenderMenuList::updateFromElement): Ditto.
        (WebCore::RenderMenuList::setTextFromOption): Ditto.
        (WebCore::RenderMenuList::showPopup): Ditto.
        (WebCore::RenderMenuList::valueChanged): Ditto.
        (WebCore::RenderMenuList::listBoxSelectItem): Ditto.
        (WebCore::RenderMenuList::multiple): Ditto.
        (WebCore::RenderMenuList::didSetSelectedIndex): Ditto.
        (WebCore::RenderMenuList::didUpdateActiveOption): Ditto.
        (WebCore::RenderMenuList::itemText): Ditto.
        (WebCore::RenderMenuList::itemAccessibilityText): Ditto.
        (WebCore::RenderMenuList::itemToolTip): Ditto.
        (WebCore::RenderMenuList::itemIsEnabled): Ditto. Also use the
        disabled function instead of the virtual isEnabledFormControl
        function to check if the optgroup is enabled.
        (WebCore::RenderMenuList::itemStyle): Ditto.
        (WebCore::RenderMenuList::itemBackgroundColor): Ditto.
        (WebCore::RenderMenuList::listSize): Ditto.
        (WebCore::RenderMenuList::selectedIndex): Ditto.
        (WebCore::RenderMenuList::itemIsSeparator): Ditto.
        (WebCore::RenderMenuList::itemIsLabel): Ditto.
        (WebCore::RenderMenuList::itemIsSelected): Ditto.
        (WebCore::RenderMenuList::setTextFromItem): Ditto.

2011-10-14  Mark Hahnenberg  <mhahnenberg@apple.com>

        Rename virtual put to putVirtual
        https://bugs.webkit.org/show_bug.cgi?id=69851

        Reviewed by Darin Adler.

        No new tests.

        Renamed virtual versions of put to putVirtual in prepration for 
        adding the static put to the MethodTable in ClassInfo since the 
        compiler gets mad if the virtual and static versions have the same 
        name.

        * WebCore.exp.in:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::putVirtual):
        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::putVirtual):
        * bindings/js/JSDOMWindowShell.h:
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::putDelegate):
        * bindings/js/JSPluginElementFunctions.cpp:
        (WebCore::runtimeObjectCustomPut):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::CloneDeserializer::putProperty):
        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject setValue:forKey:]):
        (-[WebScriptObject setWebScriptValueAtIndex:value:]):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):
        (GenerateImplementation):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::JSTestObj::putVirtual):
        * bindings/scripts/test/JS/JSTestObj.h:
        * bridge/NP_jsobject.cpp:
        (_NPN_SetProperty):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::setMember):
        (JavaJSObject::setSlot):
        * bridge/objc/objc_runtime.h:
        * bridge/objc/objc_runtime.mm:
        (JSC::Bindings::ObjcFallbackObjectImp::putVirtual):
        * bridge/qt/qt_instance.cpp:
        (JSC::Bindings::QtInstance::put):
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertQVariantToValue):
        * bridge/runtime_array.cpp:
        (JSC::RuntimeArray::putVirtual):
        * bridge/runtime_array.h:
        * bridge/runtime_object.cpp:
        (JSC::Bindings::RuntimeObject::putVirtual):
        * bridge/runtime_object.h:
        * bridge/testqtbindings.cpp:
        (main):

2011-10-14  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97519.
        http://trac.webkit.org/changeset/97519
        https://bugs.webkit.org/show_bug.cgi?id=70156

        Broke 79+ tests on bots (Requested by dglazkov on #webkit).

        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::getFocusRingOutset):
        (WebCore::GraphicsContext::drawFocusRing):

2011-09-28  Robert Hogan  <robert@webkit.org>

        Replaced elements squeezed when width is specified as percentage inside a table with Auto layout
        https://bugs.webkit.org/show_bug.cgi?id=29447

        If inserting a 'replaced' element (e.g. image, plugin) in a table cell that is not descendant from
        a block with fixed layout then do not squeeze the element, let it use its intrinsic width and height.

        Reviewed by David Hyatt.

        Test: fast/replaced/table-percent-width.html

        * rendering/RenderBox.cpp:
        (WebCore::shouldExpandToIntrinsicDimension):
        (WebCore::RenderBox::containingBlockReplacedLogicalWidthForContent):
        (WebCore::RenderBox::computeReplacedLogicalWidthUsing):
        (WebCore::RenderBox::computeReplacedLogicalHeightUsing):
        * rendering/RenderBox.h:

2011-10-14  Cary Clark  <caryclark@google.com>

        [Chromium Skia on Mac] Improve focus ring
        https://bugs.webkit.org/show_bug.cgi?id=70124

        Reviewed by Eric Seidel.
        
        The focus ring code formerly outset the bounds of
        the component rectangles by fractional amounts. Because
        the rectangles are SkIRect (integer based), the fractional
        outset had no effect.

        The equivalent code in GraphicsContextMac.mm computes
        the curve radius and rectangle outset with integers, so
        the use of floats in Skia's case, besides not working,
        is unnecessary.

        The Skia code also failed to take the offset into account.
        In LayoutTests, the focus rings either have an offset of
        0 or 2. The CoreGraphics code increases the ring's rectangles
        by the offset, then passes the result to wkDrawFocusRing.

        I did not find any documentation about how wkDrawFocusRing
        further inflates the focus ring, but empirically I determined
        that adding 2 to the offset generated rings with identical
        outer diameters.
 
        With these adjustments, the layout tests generate focus rings
        in the Skia on Mac case that match the coverage of the
        Chromium CG-based platform, in particular, matching:
        
        editing/inserting/editable-inline-element.html
        editing/selection/3690703-2.html

        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::getFocusRingOutset):
        (WebCore::GraphicsContext::drawFocusRing):

2011-10-14  Chang Shu  <cshu@webkit.org>

        [Qt] Enable fullscreen api on Qt
        https://bugs.webkit.org/show_bug.cgi?id=70131

        As a result, we have 3 passed tests.

        Reviewed by Noam Rosenthal.

        * features.pri:

2011-10-14  Beth Dakin  <bdakin@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=70148
        Should switch to CoreUI version of CorrectionDot, GrammarDot, and SpellingDot
        -and corresponding-
        <rdar://problem/10208281>

        Reviewed by Anders Carlsson.

        Use NS*Dot whenever it's available, and fallback to *Dot only when it is not.
        * platform/graphics/mac/GraphicsContextMac.mm:
        (WebCore::createPatternColor):
        (WebCore::GraphicsContext::drawLineForTextChecking):

2011-10-14  Dmitry Lomov  <dslomov@google.com>

        https://bugs.webkit.org/show_bug.cgi?id=70120
        [Chromium] Pass MessagePortArray to SerializedScriptValue::serialize/deserialize.
        This patch augments SerializedScriptValue with MessagePortArray* parameter to implement MessagePort 
        transfer within the message in the future.

        Reviewed by David Levin.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateParametersCheck):
        * bindings/v8/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValue::create):
        (WebCore::SerializedScriptValue::SerializedScriptValue):
        (WebCore::SerializedScriptValue::deserialize):
        * bindings/v8/SerializedScriptValue.h:
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::handlePostMessageCallback):
        (WebCore::V8DOMWindow::postMessageCallback):
        (WebCore::V8DOMWindow::webkitPostMessageCallback):
        * bindings/v8/custom/V8DedicatedWorkerContextCustom.cpp:
        (WebCore::handlePostMessageCallback):
        (WebCore::V8DedicatedWorkerContext::postMessageCallback):
        (WebCore::V8DedicatedWorkerContext::webkitPostMessageCallback):
        * bindings/v8/custom/V8HistoryCustom.cpp:
        (WebCore::V8History::pushStateCallback):
        (WebCore::V8History::replaceStateCallback):
        * bindings/v8/custom/V8MessageEventCustom.cpp:
        (WebCore::V8MessageEvent::dataAccessorGetter):
        * bindings/v8/custom/V8MessagePortCustom.cpp:
        (WebCore::handlePostMessageCallback):
        (WebCore::V8MessagePort::postMessageCallback):
        (WebCore::V8MessagePort::webkitPostMessageCallback):
        * bindings/v8/custom/V8WorkerCustom.cpp:
        (WebCore::handlePostMessageCallback):
        (WebCore::V8Worker::postMessageCallback):
        (WebCore::V8Worker::webkitPostMessageCallback):
        * workers/Worker.idl:

2011-10-14  Jeff Miller  <jeffm@apple.com>

        InjectedBundleHitTestResult::imageRect() should return rect in WKView coordinates
        https://bugs.webkit.org/show_bug.cgi?id=69963
        
        Add infrastructure to convert from any frame view's coordinate system to the
        root view's coordinate system.

        Reviewed by Simon Fraser.

        No new tests (yet), this is covered by <https://bugs.webkit.org/show_bug.cgi?id=70136>.

        * WebCore.exp.in: Exported WebCore::ScrollView::contentsToRootView(), used by InjectedBundleHitTestResult.cpp.
        
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::rootViewToContents): Added (both point and rect versions).
        (WebCore::ScrollView::contentsToRootView): Ditto.
        
        * platform/ScrollView.h: Added member functions to convert to/from root view coordinates.
        
        * platform/Widget.cpp:
        (WebCore::Widget::convertFromRootView): Added (both point and rect versions).
        (WebCore::Widget::convertToRootView): Ditto.
        
        * platform/Widget.h: Added member functions to convert to/from root view coordinates.

2011-10-14  Andreas Kling  <kling@webkit.org>

        CSSParser: Remove StyleBase usage.
        https://bugs.webkit.org/show_bug.cgi?id=70150

        Reviewed by Darin Adler.

        Split CSSParser::m_parsedStyleObjects into two vectors of
        CSSRules and MediaLists.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::createMediaList):
        (WebCore::CSSParser::createCharsetRule):
        (WebCore::CSSParser::createImportRule):
        (WebCore::CSSParser::createMediaRule):
        (WebCore::CSSParser::createKeyframesRule):
        (WebCore::CSSParser::createStyleRule):
        (WebCore::CSSParser::createFontFaceRule):
        (WebCore::CSSParser::createPageRule):
        (WebCore::CSSParser::createKeyframeRule):
        * css/CSSParser.h:

2011-10-14  Adam Barth  <abarth@webkit.org>

        canvas getImageData should explain why it throws SECURITY_ERR
        https://bugs.webkit.org/show_bug.cgi?id=70088

        Reviewed by Darin Adler.

        Log as message to the console when getImageData fails because the
        canvas is tainted.

        * html/canvas/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::getImageData):

2011-10-14  Andreas Kling  <kling@webkit.org>

        Inspector: Remove StyleBase usage.
        https://bugs.webkit.org/show_bug.cgi?id=70138

        Reviewed by Antti Koivisto.

        Be fully specific about whether we're operating on a CSSRule or
        a CSSStyleSheet.

        No behavior change expected, this merely is a cleanup.

        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::parentStyleSheet):
        (WebCore::InspectorCSSAgent::asCSSStyleRule):
        * inspector/InspectorCSSAgent.h:
        * inspector/InspectorStyleSheet.cpp:
        (WebCore::asCSSRuleList):

2011-10-14  Mark Hahnenberg  <mhahnenberg@apple.com>

        Rename virtual deleteProperty to deletePropertyVirtual
        https://bugs.webkit.org/show_bug.cgi?id=69884

        Reviewed by Darin Adler.

        No new tests.

        Renamed virtual versions of deleteProperty to deletePropertyVirtual in prepration for 
        adding the static deleteProperty to the MethodTable in ClassInfo since the 
        compiler gets mad if the virtual and static versions have the same name.

        * WebCore.exp.in:
        * bindings/js/JSDOMStringMapCustom.cpp:
        (WebCore::JSDOMStringMap::deletePropertyVirtual):
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::deletePropertyVirtual):
        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::deletePropertyVirtual):
        * bindings/js/JSDOMWindowShell.h:
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::JSHistory::deletePropertyVirtual):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::deletePropertyVirtual):
        * bindings/js/JSStorageCustom.cpp:
        (WebCore::JSStorage::deletePropertyVirtual):
        * bindings/js/ScriptObject.cpp:
        (WebCore::ScriptGlobalObject::remove):
        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject removeWebScriptKey:]):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):
        * bridge/NP_jsobject.cpp:
        (_NPN_RemoveProperty):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::removeMember):
        * bridge/objc/objc_runtime.h:
        * bridge/objc/objc_runtime.mm:
        (JSC::Bindings::ObjcFallbackObjectImp::deletePropertyVirtual):
        * bridge/runtime_array.cpp:
        (JSC::RuntimeArray::deletePropertyVirtual):
        * bridge/runtime_array.h:
        * bridge/runtime_object.cpp:
        (JSC::Bindings::RuntimeObject::deletePropertyVirtual):
        * bridge/runtime_object.h:

2011-10-14  Simon Fraser  <simon.fraser@apple.com>

        Web Inspector: WebProcess crashes hard when inspecting elements with border-images applied
        https://bugs.webkit.org/show_bug.cgi?id=70105

        Reviewed by Dave Hyatt.
        
        Fix three different crashes related to getting computed style for border-image.
        In both valueForNinePieceImageSlice() and valueForNinePieceImageQuad(),
        assign 'right' to 'left' because we've computed a value for 'right' already.
        Otherwise this would leave 'right' as null, causing later crashes in cssText().
        
        In mapNinePieceImage(), borderImage->imageValue() can be null for a border-image
        shorthand that is missing the image value.

        Test: fast/css/getComputedStyle/computed-style-border-image.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::valueForNinePieceImageSlice):
        (WebCore::valueForNinePieceImageQuad):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::mapNinePieceImage):

2011-10-14  Ryosuke Niwa  <rniwa@webkit.org>

        Mac build fix after r97497.

        * editing/markup.cpp:
        (WebCore::isNonTableCellHTMLBlockElement):

2011-10-14  Daniel Cheng  <dcheng@chromium.org>

        Context-aware HTML paste for Chromium
        https://bugs.webkit.org/show_bug.cgi?id=62112

        Reviewed by Ryosuke Niwa.

        Add createFragmentFromMarkupWithContext which understands enough about DOM structure to
        retain necessary elements to preserve structure and appearance when extracting a subset of
        a DOM tree.

        Covered by existing layout tests.

        * editing/MarkupAccumulator.h:
        * editing/markup.cpp:
        (WebCore::isNonTableCellHTMLBlockElement):
        (WebCore::isHTMLBlockElement):
        (WebCore::ancestorToRetainStructureAndAppearanceForBlock):
        (WebCore::ancestorToRetainStructureAndAppearance):
        (WebCore::ancestorToRetainStructureAndAppearanceWithNoRenderer):
        (WebCore::findNodesSurroundingContext):
        (WebCore::trimFragment):
        (WebCore::createFragmentFromMarkupWithContext):
        * editing/markup.h:
        * platform/chromium/ChromiumDataObject.cpp:
        (WebCore::ChromiumDataObject::getData):
        * platform/chromium/DataTransferItemChromium.cpp:
        (WebCore::DataTransferItemChromium::getAsString):
        * platform/chromium/PasteboardChromium.cpp:
        (WebCore::Pasteboard::documentFragment):
        * platform/chromium/PlatformSupport.h:

2011-10-14  Peter Beverloo  <peter@chromium.org>

        [Chromium] Inherit settings from Chromium's envsetup.sh, address a NDK todo
        https://bugs.webkit.org/show_bug.cgi?id=70028

        Reviewed by Adam Barth.

        * WebCore.gyp/WebCore.gyp:

2011-10-14  Nate Chapin  <japhet@chromium.org>

        Check CachedResourceClient types with ASSERTs rather
        than if statements.
        https://bugs.webkit.org/show_bug.cgi?id=70113

        Reviewed by Adam Barth.

        No new tests, no functionality change.

        * loader/cache/CachedCSSStyleSheet.cpp:
        * loader/cache/CachedFont.cpp:
        * loader/cache/CachedImage.cpp:
        * loader/cache/CachedResourceClientWalker.h:
        * loader/cache/CachedXSLStyleSheet.cpp:

2011-10-14  Andreas Kling  <kling@webkit.org>

        Don't assert that CSSRules are CSSRules.

        Rubber-stamped by Antti Koivisto.

        * css/CSSRule.h:
        (WebCore::CSSRule::isRule):
        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::append):
        (WebCore::CSSStyleSheet::insert):

2011-10-14  Beth Dakin  <bdakin@apple.com>

        Attempted Leopard build fix.

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::createCompatibleBuffer):

2011-10-14  Andreas Kling  <kling@webkit.org>

        CSSStyleSheet should only ever contain CSSRules.
        https://bugs.webkit.org/show_bug.cgi?id=70116

        Reviewed by Antti Koivisto.

        Move child management from the StyleSheet class down into
        CSSStyleSheet and XSLStyleSheet. XSLStyleSheet continues to
        manage StyleBase objects, while CSSStyleSheet now only contains
        CSSRule.

        This is enforced at both compile time and runtime with explicit
        types and assertions.

        * css/CSSRule.h:
        (WebCore::CSSRule::isRule):

            Promoted to a public method so we can use it in assertions.

        * css/CSSRuleList.h:
        (WebCore::CSSRuleList::create):
        (WebCore::CSSRuleList::styleSheet):
        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::CSSRuleList):
        * bindings/js/JSCSSRuleListCustom.cpp:
        (WebCore::JSCSSRuleListOwner::isReachableFromOpaqueRoots):

            Change backing to a CSSStyleSheet instead of a StyleSheet.

        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::item):

            Remove redundant assertions.

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::isLoading):
        (WebCore::CSSStyleSheet::addSubresourceStyleURLs):
        * css/CSSStyleSelector.cpp:
        (WebCore::RuleSet::addRulesFromSheet):
        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::collectStyleSheets):
        * page/PageSerializer.cpp:
        (WebCore::PageSerializer::serializeCSSStyleSheet):

            Use more specific CSSRule* since that's what we get from
            CSSStyleSheet::item() now.

        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::~StyleSheet):
        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::~CSSStyleSheet):
        * xml/XSLStyleSheetLibxslt.cpp:
        (WebCore::XSLStyleSheet::~XSLStyleSheet):
        * xml/XSLStyleSheetQt.cpp:
        (WebCore::XSLStyleSheet::~XSLStyleSheet):

            Orphaning logic from ~StyleSheet() moved to subclass dtors.

        * css/StyleSheet.h:
        * css/CSSStyleSheet.h:
        (WebCore::CSSStyleSheet::length):
        (WebCore::CSSStyleSheet::item):
        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::append):
        (WebCore::CSSStyleSheet::insert):
        (WebCore::CSSStyleSheet::remove):

            Moved from StyleSheet and changed to only accept CSSRules.

        * css/StyleSheet.h:
        * xml/XSLStyleSheet.h:
        (WebCore::XSLStyleSheet::length):
        (WebCore::XSLStyleSheet::item):
        (WebCore::XSLStyleSheet::append):
        (WebCore::XSLStyleSheet::insert):
        (WebCore::XSLStyleSheet::remove):

            Moved from StyleSheet though still uses StyleBase.

2011-10-14 Yuji Sanachan <sanachan.y@gmail.com>

        Include dom/ExceptionCode.h instead of Filesystem APIs headers
        to fix compile error when ENABLE_WORKERS=1 and ENABLE_FILE_SYSTEM=0
        https://bugs.webkit.org/show_bug.cgi?id=70036

        Reviewed by Darin Adler.

        * workers/WorkerContext.cpp:
        (WebCore::WorkerContext::importScript):

2011-10-14  Darin Adler  <darin@apple.com>

        Text drawn via -webkit-background-clip:text should be non-blurry with all scaling 
        techniques
        https://bugs.webkit.org/show_bug.cgi?id=68641

        Reviewed by Simon Fraser. Committed by Beth Dakin.

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::createCompatibleBuffer): Allocate a buffer based on the 
        scale
        factor of the context.
        * platform/graphics/GraphicsContext.h: Added createCompatibleBuffer.

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended): Use 
        createCompatibleBuffer.

2011-10-14  Ryosuke Niwa  <rniwa@webkit.org>

        Move selectionStartStyle and selectionHasStyle to EditingStyle
        https://bugs.webkit.org/show_bug.cgi?id=69882

        Reviewed by Enrica Casucci.

        Moved selectionHasStyle and selectionStartStyle from Editor to EditingStyle.
        Also moved much of code in Editor::selectionStartCSSPropertyValue to method of EditingStyle.

        In addition, moved Range::editingStartPosition to htmlediting where it belongs
        and renamed it to adjustedSelectionStartForStyleComputation.

        * dom/Range.cpp:
        * dom/Range.h:
        * editing/EditingStyle.cpp:
        (WebCore::EditingStyle::triStateOfStyle): Extracted from selectionHasStyle.
        (WebCore::EditingStyle::legacyFontSize): Extracted from selectionStartCSSPropertyValue.
        (WebCore::EditingStyle::styleAtSelectionStart): Moved from Editor::selectionStartStyle.
        * editing/EditingStyle.h:
        * editing/Editor.cpp:
        (WebCore::Editor::fontForSelection):
        (WebCore::Editor::selectionStartHasStyle):
        (WebCore::Editor::selectionHasStyle):
        (WebCore::Editor::selectionStartCSSPropertyValue):
        * editing/Editor.h:
        * editing/EditorCommand.cpp:
        (WebCore::executeToggleStyleInList):
        * editing/htmlediting.cpp:
        (WebCore::adjustedSelectionStartForStyleComputation): Moved from Range::editingStartPosition.
        * editing/htmlediting.h:

2011-10-14  Ryosuke Niwa  <rniwa@webkit.org>

        Redundant comparison in AccessibilityObject.cpp updateAXLineStartForVisiblePosition
        https://bugs.webkit.org/show_bug.cgi?id=70074

        Reviewed by Chris Fleizach.

        Removed redundant code.

        * accessibility/AccessibilityObject.cpp:
        (WebCore::updateAXLineStartForVisiblePosition):

2011-10-12  Ryosuke Niwa  <rniwa@webkit.org>

        Make the interface of locationAndLengthFromRange and rangeFromLocationAndLength consistent
        https://bugs.webkit.org/show_bug.cgi?id=69964

        Reviewed by Enrica Casucci.

        Extracted the logic to determine the scope element as FrameSelection::rootEditableElementOrDocumentElement
        and deployed it in WebKit layer. Made locationAndLengthFromRange take a scope element and renamed it to
        getLocationAndLengthFromRange.

        * WebCore.exp.in:
        * editing/FrameSelection.cpp:
        (WebCore::FrameSelection::rootEditableElementOrDocumentElement):
        * editing/FrameSelection.h:
        * editing/TextIterator.cpp:
        (WebCore::TextIterator::getLocationAndLengthFromRange):
        * editing/TextIterator.h:

2011-10-13  Arko Saha  <arko@motorola.com>

        Microdata: Basic implementation of document.getItems() method.
        https://bugs.webkit.org/show_bug.cgi?id=68610

        Reviewed by Ryosuke Niwa.

        Added ENABLE(MICRODATA) feature flag. Implement document.getItems() DOM API.
        Spec: http://www.whatwg.org/specs/web-apps/current-work/complete/microdata.html

        Tests: fast/dom/MicroData/001.html
               fast/dom/MicroData/002.html
               fast/dom/MicroData/003.html
               fast/dom/MicroData/004.html
               fast/dom/MicroData/005.html
               fast/dom/MicroData/006.html
               fast/dom/MicroData/007.html
               fast/dom/MicroData/008.html
               fast/dom/MicroData/009.html

        * CMakeLists.txt:
        * DerivedSources.make:
        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * dom/Document.cpp:
        (WebCore::Document::getItems): Returns NodeList of the element in the Document that
        create items, that are not part of other items, and that are of one of the types
        given in the argument. If no tokens specified/undefined in the argument, then
        return a NodeList containing all top level microdata items.
        (WebCore::Document::removeCachedMicroDataItemList): Remove Microdata item node list
        from cache.
        * dom/Document.h:
        * dom/Document.idl: Added getItems() microdata DOM API.
        * dom/MicroDataItemList.cpp: Added.
        (WebCore::MicroDataItemList::MicroDataItemList):
        (WebCore::MicroDataItemList::~MicroDataItemList):
        (WebCore::MicroDataItemList::nodeMatches):
        * dom/MicroDataItemList.h: Added.
        (WebCore::MicroDataItemList::create):
        * dom/Node.cpp:
        (WebCore::Node::itemTypeAttributeChanged): It is responsible to invalidate the Microdata
        item node cache when itemType attribute changes.
        (WebCore::NodeListsNodeData::invalidateCachesThatDependOnAttributes):
        (WebCore::NodeListsNodeData::invalidateMicrodataItemListCaches): Invalidate Microdata item
        list cache.
        (WebCore::NodeListsNodeData::isEmpty):
        * dom/Node.h:
        * dom/NodeRareData.h:
        * features.pri:
        * html/HTMLAttributeNames.in: Added itemid, itemprop, itemscope, itemtype attributes.
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::parseMappedAttribute): Handle itemtype attribute change.
        * html/HTMLElement.idl: Added itemid, itemprop, itemscope, itemtypes microdata attributes.

2011-10-14  Andreas Kling  <kling@webkit.org>

        Stricter management of WebKitCSSKeyframeRules.
        https://bugs.webkit.org/show_bug.cgi?id=70109

        Reviewed by Antti Koivisto.

        Covered by existing tests.

        * css/CSSParser.h:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseKeyframeRule):

            Return a WebKitCSSKeyframeRule instead of a CSSRule.

        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::deleteRule):
        * css/WebKitCSSKeyframesRule.cpp:
        (WebCore::WebKitCSSKeyframesRule::deleteRule):

            Moved style sheet orphaning logic for @-webkit-keyframe
            from CSSRuleList into WebKitCSSKeyframesRule::deleteRule()
            since that's the only caller operating on those rules.

        * css/WebKitCSSKeyframesRule.cpp:
        (WebCore::WebKitCSSKeyframesRule::~WebKitCSSKeyframesRule):
        (WebCore::WebKitCSSKeyframesRule::length):
        (WebCore::WebKitCSSKeyframesRule::item):
        (WebCore::WebKitCSSKeyframesRule::insertRule):

            Change isKeyframeRule() checks to assertions since we know
            our rules are always WebKitCSSKeyframeRules. Also tidied up.

2011-10-14  Andreas Kling  <kling@webkit.org>

        Unreviewed, actually remove StyleList.* after r97640.

        * css/StyleList.cpp: Removed.
        * css/StyleList.h: Removed.

2011-10-14  Andreas Kling  <kling@webkit.org>

        Merge StyleList into StyleSheet.
        https://bugs.webkit.org/show_bug.cgi?id=70100

        Reviewed by Antti "printf" Koivisto.

        Merge all functionality from StyleList into StyleSheet,
        since StyleSheet was the only subclass of StyleList anyway.

        Also removed FIXME's about throwing exceptions in CSSRuleList
        since they were incorrect. The call sites already handle the
        relevant cases.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSCSSRuleListCustom.cpp:
        (WebCore::JSCSSRuleListOwner::isReachableFromOpaqueRoots):
        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::CSSRuleList):
        (WebCore::CSSRuleList::length):
        (WebCore::CSSRuleList::item):
        (WebCore::CSSRuleList::deleteRule):
        (WebCore::CSSRuleList::append):
        (WebCore::CSSRuleList::insertRule):
        * css/CSSRuleList.h:
        (WebCore::CSSRuleList::create):
        (WebCore::CSSRuleList::styleSheet):
        * css/StyleList.cpp: Removed.
        * css/StyleList.h: Removed.
        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::StyleSheet):
        (WebCore::StyleSheet::append):
        (WebCore::StyleSheet::insert):
        (WebCore::StyleSheet::remove):
        * css/StyleSheet.h:
        (WebCore::StyleSheet::length):
        (WebCore::StyleSheet::item):

2011-10-14  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSS Regions] Change -webkit-flow to -webkit-flow-into
        https://bugs.webkit.org/show_bug.cgi?id=70014

        Reviewed by David Hyatt.

        1. -webkit-flow is renamed to -webkit-flow-into
        2. -webkit-flow-into takes <ident> instead of strings

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::validFlowName):
        (WebCore::CSSParser::parseFlowThread):
        * css/CSSPropertyNames.in:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):

2011-10-12  Hans Wennborg  <hans@chromium.org>

        IndexedDB: Remove SQLite backing store
        https://bugs.webkit.org/show_bug.cgi?id=69620

        Reviewed by Darin Fisher.

        Remove the SQLite backing store implementation; it is not used anymore.
        Also remove the maximumSize parameter, it is not used either.

        No new functionality, so no new tests.

        * GNUmakefile.list.am:
        * WebCore.gypi:
        * storage/IDBBackingStore.h:
        * storage/IDBFactory.cpp:
        (WebCore::IDBFactory::getDatabaseNames):
        (WebCore::IDBFactory::open):
        * storage/IDBFactoryBackendImpl.cpp:
        (WebCore::computeFileIdentifier):
        (WebCore::computeUniqueIdentifier):
        (WebCore::IDBFactoryBackendImpl::getDatabaseNames):
        (WebCore::IDBFactoryBackendImpl::open):
        (WebCore::IDBFactoryBackendImpl::openBackingStore):
        * storage/IDBFactoryBackendImpl.h:
        * storage/IDBFactoryBackendInterface.h:
        * storage/IDBLevelDBBackingStore.cpp:
        (WebCore::IDBLevelDBBackingStore::open):
        * storage/IDBLevelDBBackingStore.h:
        * storage/IDBSQLiteBackingStore.cpp: Removed.
        * storage/IDBSQLiteBackingStore.h: Removed.

2011-10-14  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed. Fix mac builds. r97448 broke them.

        * WebCore.xcodeproj/project.pbxproj: Set ImageBySizeCache.h role to private.

2011-10-14  Justin Schuh  <jschuh@chromium.org>

        Clear WebMediaPlayerClientImpl back pointer on destruction
        https://bugs.webkit.org/show_bug.cgi?id=69973

        Reviewed by James Robinson.

        Clear the backpointer and remove the unused m_currentFrame

        * platform/graphics/chromium/VideoLayerChromium.cpp:
        (WebCore::VideoLayerChromium::VideoLayerChromium):
        (WebCore::VideoLayerChromium::cleanupResources):
        (WebCore::VideoLayerChromium::updateCompositorResources):
        (WebCore::VideoLayerChromium::releaseProvider):
        * platform/graphics/chromium/VideoLayerChromium.h:

2011-10-13  Hans Wennborg  <hans@chromium.org>

        IndexedDB: Make IDBCursor.value() return an IDBAny object
        https://bugs.webkit.org/show_bug.cgi?id=70024

        Reviewed by Tony Chang.

        This is to work around the fact that the V8 bindings mechanism does
        eager deserialization of SerializedScriptValue attributes. This means
        that the value is fetched from the back-end only once, when the
        IDBCursor is first wrapped. When the cursor's value changes, this is
        not reflected.

        We work around this by making IDBCursor.value() return the
        SerializedScriptValue wrapped in an IDBAny object.

        * storage/IDBCursor.cpp:
        (WebCore::IDBCursor::value):
        * storage/IDBCursor.h:
        * storage/IDBCursorWithValue.idl:

2011-10-14  Rémi Duraffort  <remi.duraffort@st.com>

        Fix compilation when the JS Debugger is disabled.
        https://bugs.webkit.org/show_bug.cgi?id=70007

        Reviewed by Antti Koivisto.

        * inspector/InspectorInstrumentation.cpp:
        (WebCore::InspectorInstrumentation::willEvaluateWorkerScript):
        * inspector/InspectorRuntimeAgent.cpp:
        * inspector/InspectorRuntimeAgent.h:
        * inspector/WorkerInspectorController.cpp:
        * inspector/WorkerInspectorController.h:
        * workers/WorkerMessagingProxy.cpp:
        (WebCore::WorkerMessagingProxy::disconnectFromInspector):
        (WebCore::WorkerMessagingProxy::sendMessageToInspector):

2011-10-13  Nikolas Zimmermann  <nzimmermann@rim.com>

        Prepare SVGImage intrinsic size negotiation: Introduce an IntSize <-> SVGImage cache in CachedImage
        https://bugs.webkit.org/show_bug.cgi?id=69416

        Reviewed by Antti Koivisto.

        Refactor ImageBySizeCache out of CSSImageGeneratorValue as CachedImage wants to use the same type of cache for its purposes.
        When introducing the SVGImage intrinsic size negotiation the container size of an SVGImage is dependant on the place where
        it gets embedded (eg width/height attributes of host documents <img> force a certain size).

        Currently CachedImage only contains a single RefPtr<Image>, which it constructs out of the decoded data.
        Multiple RenderObjects share the same CachedImages, when embedding eg. a SVG document in a <html:img> or using it in a background-image for a <div>.
        Consider the case where two RenderObjects use the same CachedImage, each with a different container size (200x100 vs 100x200) and the embedded
        document contains a viewBox and some arbitary preserveAspectRatio settings. To honour these we have to relayout the document with the desired
        size (percentual unit resolving etc, all depend on the RenderSVGRoots size).

        With the current design this is hard to realize, w/o requring to relayout the embedded document for each embedder that uses an SVGImage.
        This patch introduces a cache right within CachedImage, which manages a map of images to certain sizes, by utilizing the new ImageBySizeCache.

        CachedImage::imageForRenderer() takes a RenderObject* parameter, which it uses to look up the last set image container size for a renderer.
        Using that size it queries the cache whether it already has an SVGImage for that size, if not it gets created, by creating a whole
        new instance of SVGImage, filling it with the already decoded data, and passing on a fixed image container size, which overrides the
        size that RenderSVGRoot reports, when computeReplacedLogicalWidth/Height is called and thus laying out the document at the desired size.
        This image is then put in the cache for further reusability.

        Likewise CachedImage::setContainerSizeForRenderer() now takes a RenderObject* parameter and stores that in the cache with an associated container size.
        It requires to touch several files which use CachedImage throughout WebCore/WebKit/WebKit2.

        The actual cache is not yet turned on yet, so this is not a functional change so far, as it needs some other changes to SVGImage,
        which will come with the master patch in bug 47156.

        No new tests yet, as the new cache isn't turned on yet.

        * CMakeLists.txt: Add rendering/ImageBySizeCache.* to build.
        * GNUmakefile.list.am: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.pro: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::accessibilityIsIgnored): Use new CachedImage::imageSizeForRenderer(RenderObject*) method.
        * bindings/objc/DOM.mm: Ditto (for CachedImage::image()).
        (-[DOMElement image]):
        (-[DOMElement _imageTIFFRepresentation]):
        * bridge/qt/qt_pixmapruntime.cpp:
        (JSC::Bindings::QtPixmapInstance::variantFromObject): Ditto (for CachedImage::image()).
        * css/CSSCanvasValue.cpp: s/m_clients/clients()/, which now live in the ImageBySizeCache instead of CSSImageGeneratorValue.
        (WebCore::CSSCanvasValue::canvasChanged):
        (WebCore::CSSCanvasValue::canvasResized):
        (WebCore::CSSCanvasValue::image):
        * css/CSSGradientValue.cpp: Ditto.
        (WebCore::CSSGradientValue::image):
        * css/CSSImageGeneratorValue.cpp: Move the sizes/clients/images cache into a new ImageBySizeCache class, to make it usable for CachedImage as well.
        (WebCore::CSSImageGeneratorValue::addClient): Adapt to move.
        (WebCore::CSSImageGeneratorValue::removeClient): Ditto.
        (WebCore::CSSImageGeneratorValue::getImage): Ditto.
        (WebCore::CSSImageGeneratorValue::putImage): Ditto.
        * css/CSSImageGeneratorValue.h:
        (WebCore::CSSImageGeneratorValue::clients): Forwarded to the ImageBySizeCache.
        * editing/DeleteButtonController.cpp: 
        (WebCore::isDeletableElement): CachedImage::canRender() now takes a RenderObject* parameter.
        * html/HTMLImageElement.cpp:
        (WebCore::HTMLImageElement::width): Use new CachedImage::imageSizeForRenderer(RenderObject*) method.
        (WebCore::HTMLImageElement::height): Ditto.
        (WebCore::HTMLImageElement::naturalWidth): Ditto.
        (WebCore::HTMLImageElement::naturalHeight): Ditto.
        * html/ImageDocument.cpp:
        (WebCore::ImageDocumentParser::finish): Ditto.
        (WebCore::ImageDocument::scale): Ditto.
        (WebCore::ImageDocument::resizeImageToFit): Ditto.
        (WebCore::ImageDocument::imageUpdated): Ditto.
        (WebCore::ImageDocument::restoreImageSize): Ditto.
        (WebCore::ImageDocument::imageFitsInWindow): Ditto.
        * html/canvas/CanvasRenderingContext.cpp:
        (WebCore::CanvasRenderingContext::wouldTaintOrigin): Use new CachedImage::imageForRenderer(RenderObject*) method.
        * html/canvas/CanvasRenderingContext2D.cpp:
        (WebCore::isOriginClean): Ditto.
        (WebCore::size): Ditto (for CachedImage::imageSizeForRenderer()).
        (WebCore::CanvasRenderingContext2D::drawImage): Ditto.
        (WebCore::CanvasRenderingContext2D::createPattern): Ditto.
        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::texImage2D): Ditto.
        (WebCore::WebGLRenderingContext::texSubImage2D): Ditto.
        * loader/cache/CachedImage.cpp: Add currently _disabled_ cache for SVGImages. The intrinsic size negotiation will need to use multiple SVGImages
        for each requested size (equal to the size of the embedding place for the image) - make it possible to cache these SVGImages, and maintain a cache
        for them. The hash code is a 1:1 refactoring from the already present code in CSSImageGeneratorValue, now named 'ImageBySizeCache'.
        (WebCore::CachedImage::lookupImageForSize): Looks up an Image from the cache for a given IntSize. Currently turned off.
        (WebCore::CachedImage::lookupImageForRenderer): Looks up an Image from the cache for a given renderer. Currently turned off.
        (WebCore::CachedImage::lookupOrCreateImageForRenderer): Looks up an Image from the cache or creates a new SVGImage for a given size and caches it, if possible. Currently turned off.
        All following changes share this: Don't operate on m_image directly, instead always look up one from the cache for a given size or renderer - if that's not present fallback to m_image.
        When an SVGImage is first created by CachedImage::createImage() and stored in m_image, the cache remains empty.

        If eg. <img width="30" height="70" src="foo.svg"> is used which implies a container size of 30x70 a new SVGImage is created with the additional information of a 30x70 container size
        which is immediately passed to the SVGImage after its creation. This SVGImage is put in the ImageBySizeCache associated with a container size of 30x70.
        We now have two SVGImage objects present, one living in CachedImage::m_image, created by createImage() during data decoding, and one living in the ImageBySizeCache
        created by lookupOrCreateImageForRenderer() associated with the 30x70 container. The first SVGImage::size() will return a value as defined in the referenced foo.svg,
        whereas the SVGImage::size() call of the new SVGImage living in the cache reports 30x70 and renders according to that.

        Whenever any method of CachedImage is called with a RenderObject* or IntSize, we can't just operate on m_image anymore but instead have to lookup the right
        images for a certain renderer/size from the cache and operate on these. When calling eg. CachedImage::image() with a null renderer, m_image is returned.
        When passing with a valid renderer only cache lookups are done if the m_image is actually a SVGImage, otherwhise lookupImageForSize/Renderer will just return the m_image.
        There is no logical change induced for non-SVGImage derived images.

        CachedImage::image() of course needs a RenderObject* parameter now, to identify which of the images from the cache to use, if the underlying image is a SVGImage.
        Luckily these information are already present in StyleCachedImage/StyleImage & friends and only need to be added for some additional methods.
        (WebCore::CachedImage::image): FIXME
        (WebCore::CachedImage::imageForRenderer): Call lookupOrCreateImageForRenderer() instead of returning m_image, if it's not null. Its a no-op for non SVGImage derived objects.
        (WebCore::CachedImage::setContainerSizeForRenderer): For non-SVGImages, just pass on the size to the m_image. For SVGImages, associate the passed in renderer with the IntSize in the cache.
                                                             This does NOT create the SVGImage yet, this is delayed until imageForRenderer() is called for a given renderer that wants this size.
        (WebCore::CachedImage::imageSize): Don't operate on m_image, ask lookupImageForRenderer() with the incoming renderer.
        (WebCore::CachedImage::imageRect): Ditto.
        (WebCore::CachedImage::clear): Force clearing the m_svgImageCache.
        (WebCore::CachedImage::data): Call m_image->size() instead of imageSize(), to avoid having to pass a null renderer to imageSize() as here no renderer is available yet.
        (WebCore::CachedImage::destroyDecodedData): Don't destroy decoded data for SVG images, as m_data needs to be accessable at any time to construct a cloned SVGImage.
                                                    In future we don't need this anymore if we make sure multiple SVGImages share the same trees, but that's for a follow-up patch.
        (WebCore::CachedImage::decodedSizeChanged): Don't operate on m_image, ask lookupImageForRenderer() with the incoming renderer.
        (WebCore::CachedImage::didDraw): Ditto.
        (WebCore::CachedImage::shouldPauseAnimation): Ditto.
        (WebCore::CachedImage::animationAdvanced): Ditto.
        (WebCore::CachedImage::changedInRect): Ditto. (eg. when leaving out this change animated SVG images wouldn't update anymore, as the animation didn't happen on m_image!)
        * loader/cache/CachedImage.h: imageForRenderer/canRender/setContainerSizeForRenderer/imageSizeForRenderer now all take a RenderObject* parameter to identifiy the current user of the image.
        (WebCore::CachedImage::canRender): Pass on the incoming renderer to imageSizeForRenderer().
        * page/DragController.cpp:
        (WebCore::getImage): Use new CachedImage::imageForRenderer(RenderObject*) method.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::selectCursor): Ditto.
        * page/PageSerializer.cpp:
        (WebCore::PageSerializer::serializeFrame): Ditto.
        (WebCore::PageSerializer::addImageToResources): Ditto.
        (WebCore::PageSerializer::retrieveResourcesForCSSDeclaration): Ditto.
        * page/PageSerializer.h:
        * platform/chromium/ClipboardChromium.cpp:
        (WebCore::writeImageToDataObject): Ditto.
        * platform/chromium/PasteboardChromium.cpp:
        (WebCore::Pasteboard::writeImage): Ditto.
        * platform/graphics/Image.h:
        (WebCore::Image::isSVGImage): Add boolean helper to identify SVGImages, just like isBitmapImage().
        * platform/gtk/ClipboardGtk.cpp:
        (WebCore::ClipboardGtk::declareAndWriteDragImage): Use new CachedImage::imageForRenderer(RenderObject*) method.
        * platform/gtk/PasteboardGtk.cpp:
        (WebCore::Pasteboard::writeImage): Ditto.
        * platform/mac/HTMLConverter.mm:
        (fileWrapperForElement): Ditto.
        * platform/mac/PasteboardMac.mm:
        (WebCore::Pasteboard::writeImage): Ditto.
        * platform/qt/ClipboardQt.cpp:
        (WebCore::ClipboardQt::declareAndWriteDragImage): Ditto.
        * platform/qt/PasteboardQt.cpp:
        (WebCore::Pasteboard::writeImage): Ditto.
        * platform/win/ClipboardWin.cpp:
        (WebCore::writeImageToDataObject): Ditto.
        * platform/win/PasteboardWin.cpp:
        (WebCore::Pasteboard::writeImage): Ditto.
        * platform/wince/PasteboardWinCE.cpp:
        (WebCore::Pasteboard::writeImage): Ditto.
        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::image): Ditto.
        * rendering/ImageBySizeCache.cpp: Copied from WebCore/css/CSSImageGeneratorValue.cpp, to preserve history for the original cache code.
        (WebCore::ImageBySizeCache::ImageBySizeCache): Straight copy from CSSImageGeneratorValue, renamed to ImageBySizeCache, removing all but the cache relevant code.
        (WebCore::ImageBySizeCache::addClient): Ditto.
        (WebCore::ImageBySizeCache::removeClient): Ditto.
        (WebCore::ImageBySizeCache::getImage): Ditto.
        (WebCore::ImageBySizeCache::putImage): Ditto.
        (WebCore::ImageBySizeCache::clear): New function, that clears the cache, introduced for the needs of CachedImage.
        (WebCore::ImageBySizeCache::imageForSize): New function to query an Image* for a given IntSize, introduced for the needs of CachedImage.
        (WebCore::ImageBySizeCache::sizeForClient): New function to query an IntSize for a given renderer.
        * rendering/ImageBySizeCache.h: Copied from WebCore/css/CSSImageGeneratorValue.h.
        (WebCore::ImageBySizeCache::clients):
        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::paintFillLayer): CachedImage::canRender() now takes a RenderObject* parameter.
        (WebCore::InlineFlowBox::paintBoxDecorations): Ditto.
        (WebCore::InlineFlowBox::paintMask): Ditto.
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::paintMaskImages): Ditto.
        (WebCore::RenderBox::repaintLayerRectsForImage): Ditto.
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended): Ditto.
        (WebCore::RenderBoxModelObject::calculateFillTileSize): Ditto (for CachedImage::setContainerSizeForRenderer()).
        (WebCore::RenderBoxModelObject::paintNinePieceImage): Ditto.
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::imageSizeForError): Use new CachedImage::imageForRenderer(RenderObject*) method.
        (WebCore::RenderImage::setImageSizeForAltText): Ditto.
        (WebCore::RenderImage::computeReplacedLogicalWidth): FIXME
        * rendering/RenderImageResource.cpp:
        (WebCore::RenderImageResource::setContainerSizeForRenderer): Pass on m_renderer to CachedImage::setContainerSizeForRenderer().
        * rendering/RenderImageResource.h: Remove constness from setContainerSizeForRenderer.
        (WebCore::RenderImageResource::image): Pass on m_renderer to CachedImage::image().
        (WebCore::RenderImageResource::imageSize): Pass on m_renderer to CachedImage::imageSizeForRenderer().
        * rendering/RenderImageResourceStyleImage.h:
        (WebCore::RenderImageResourceStyleImage::setContainerSizeForRenderer): Remove constness, pass on m_renderer to StyleImage::setContainerSizeForRenderer().
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::isDirectlyCompositedImage): Use new CachedImage::imageForRenderer(RenderObject*) method.
        (WebCore::RenderLayerBacking::updateImageContents): Ditto.
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::computePreferredLogicalWidths): CachedImage::setContainerSizeForRenderer() now takes a RenderObject* parameter.
        * rendering/RenderObject.cpp:
        (WebCore::mustRepaintFillLayers): CachedImage::canRender() now takes a RenderObject* parameter.
        (WebCore::RenderObject::borderImageIsLoadedAndCanBeRendered): Ditto.
        * rendering/style/StyleCachedImage.cpp:
        (WebCore::StyleCachedImage::canRender): Pass on incoming renderer to CachedImage::canRender().
        (WebCore::StyleCachedImage::imageSize): Pass on incoming renderer to CachedImage::imageSizeForRenderer().
        (WebCore::StyleCachedImage::setContainerSizeForRenderer): Pass on incoming renderer to CachedImage::setContainerSizeForRenderer().
        (WebCore::StyleCachedImage::addClient): Remove unneeded return statment in void method.
        (WebCore::StyleCachedImage::removeClient): Ditto.
        (WebCore::StyleCachedImage::image): Pass on incoming renderer to CachedImage::image().
        * rendering/style/StyleCachedImage.h: Add RenderObject* parameter to canRender()/setContainerSizeForRenderer(). image() already has one, that was unused so far.
        * rendering/style/StyleGeneratedImage.cpp: Inlined setContainerSizeForRenderer.
        * rendering/style/StyleGeneratedImage.h: 
        (WebCore::StyleGeneratedImage::setContainerSizeForRenderer): Add RenderObject* parameter.
        * rendering/style/StyleImage.h:
        (WebCore::StyleImage::canRender): Ditto.
        * rendering/style/StylePendingImage.h:
        (WebCore::StylePendingImage::setContainerSizeForRenderer): Ditto.
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::build): Use new CachedImage::imageForRenderer(RenderObject*) method.
        * svg/graphics/SVGImage.cpp: Cleanup file, the include hack seems not needed anymore.
        (WebCore::SVGImage::setContainerSize): s/LayoutSize/IntSize/ to match the code in platform/.
        * svg/graphics/SVGImage.h: Ditto.
        (WebCore::SVGImage::isSVGImage): Return true.

2011-10-13  Kenichi Ishibashi  <bashi@chromium.org>

        [Chromium] Uninitialized read in WebCore::*Font* / HB_GSUB_Select_Feature
        https://bugs.webkit.org/show_bug.cgi?id=70087

        Reviewed by Kent Tamura.

        Initialize local variables in ComplexTextControllerLinux::setupfontFeatures.

        No new tests because there is no behavior change. Manually tested with valgrind.

        * platform/graphics/chromium/ComplexTextControllerLinux.cpp:
        (WebCore::setupFontFeatures):

2011-10-13  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt][Win] Unreviewed buildfix after r97433.

        * platform/MemoryPressureHandler.h: Add a missing include.

2011-10-13  Adam Barth  <abarth@webkit.org>

        Spelling error in v8WebSocket::constructorCallback error
        https://bugs.webkit.org/show_bug.cgi?id=63943

        Reviewed by Kent Tamura.

        Fix typo.

        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):

2011-10-13  Mark Hahnenberg  <mhahnenberg@apple.com>

        Rename virtual getConstructData to getConstructDataVirtual
        https://bugs.webkit.org/show_bug.cgi?id=69872

        Reviewed by Geoffrey Garen.

        No new tests.

        Renamed virtual getConstructData functions to getConstructDataVirtual to 
        avoid conflicts when we add static getConstructData to the MethodTable.

        * WebCore.exp.in:
        * bindings/js/JSAudioConstructor.cpp:
        (WebCore::JSAudioConstructor::getConstructDataVirtual):
        * bindings/js/JSAudioConstructor.h:
        * bindings/js/JSImageConstructor.cpp:
        (WebCore::JSImageConstructor::getConstructDataVirtual):
        * bindings/js/JSImageConstructor.h:
        * bindings/js/JSOptionConstructor.cpp:
        (WebCore::JSOptionConstructor::getConstructDataVirtual):
        * bindings/js/JSOptionConstructor.h:
        * bindings/js/ScriptFunctionCall.cpp:
        (WebCore::ScriptFunctionCall::construct):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateConstructorDeclaration):
        (GenerateConstructorDefinition):
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterfaceConstructor::getConstructDataVirtual):
        * bridge/runtime_object.cpp:
        (JSC::Bindings::RuntimeObject::getConstructDataVirtual):
        * bridge/runtime_object.h:

2011-10-13  Simon Fraser  <simon.fraser@apple.com>

        Remove #include of <QuartzCore/QuartzCore.h> in a widely-used header.

        Reviewed by Sam Weinig.

        * platform/PlatformScreen.h: Typedef PlatformDisplayID to a uint32_t.
        * platform/graphics/DisplayRefreshMonitor.h: Typedef CVDisplayLinkRef as
        an opaque type to avoid bringing in QuartzCore.h, and move displayLinkCallback
        to the .cpp file since it uses Core Video types.
        * platform/graphics/mac/DisplayRefreshMonitorMac.cpp:
        (WebCore::displayLinkCallback): Make this a local static function, that
        calls a member fuction on the object.
        (WebCore::DisplayRefreshMonitor::requestRefreshCallback):
        (WebCore::DisplayRefreshMonitor::displayLinkFired):

2011-10-13  Michael Saboff  <msaboff@apple.com>

        REGRESSION: High frequency memory warnings cause Safari to hog the CPU doing useless garbage collection
        https://bugs.webkit.org/show_bug.cgi?id=69774

        Throttle the processing of memory pressure events to no more often than once every 5 seconds.

        Reviewed by Geoffrey Garen.

        No new tests.

        * platform/MemoryPressureHandler.cpp:
        (WebCore::MemoryPressureHandler::MemoryPressureHandler):
        * platform/MemoryPressureHandler.h:
        * platform/mac/MemoryPressureHandlerMac.mm:
        (WebCore::MemoryPressureHandler::respondToMemoryPressure):

2011-10-13  Kentaro Hara  <haraken@chromium.org>

        Implement an OverflowEvent constructor for V8
        https://bugs.webkit.org/show_bug.cgi?id=70017

        Reviewed by Adam Barth.

        Test: fast/events/constructors/overflow-event-constructor.html

        * bindings/v8/custom/V8EventConstructors.cpp: Added an OverflowEvent constructor.
        * dom/OverflowEvent.idl: Replaced 'JSCustomConstructor' with 'CustomConstructor'.

2011-10-13  Anantanarayanan G Iyengar  <ananta@chromium.org>

        https://bugs.webkit.org/show_bug.cgi?id=70064
        
        The NPObjectWrapper class used by V8 bindings in Chromium to wrap the window
        script object was allocating an instance of itself in the NPAllocate
        implementation and returning this pointer. It should be returning a pointer
        to the wrapped NPObject structure (NPProxyObject). The member function
        getUnderlyingNPObject should return 0 if we fail to find the underlying NPObject
        for the call. It was incorrectly returning a pointer to the same NPObject in
        this case which could cause recursion. 

        Reviewed by Nate Chapin.

        No new tests as there is no change in functionality.

        * bindings/v8/NPObjectWrapper.cpp:
        (WebCore::NPObjectWrapper::getObjectForCall):
        (WebCore::NPObjectWrapper::NPAllocate):
        * bindings/v8/NPObjectWrapper.h:

2011-10-13  Arthur Hsu  <arthurhsu@chromium.org>

        Ensure font loaded before calling Skia to drawPosText in Chrome sandbox
        https://bugs.webkit.org/show_bug.cgi?id=69370

        Reviewed by James Robinson.

        * platform/graphics/chromium/FontChromiumWin.cpp:
        (WebCore::Font::drawGlyphs):

2011-10-13  Kentaro Hara  <haraken@chromium.org>

        Regarding constructor, replace [ConstructorWith=...] IDL with [CallWith=...] IDL
        https://bugs.webkit.org/show_bug.cgi?id=69801

        As for constructors, [ConstructorWith=...] has the same meaning as [CallWith=...].
        We should deprecate [ConstructorWith=...]. This is a clean-up bug for the bug 65839.

        Reviewed by Adam Barth.

        No new tests, since no change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm: Replaced [ConstructorWith=...] IDL with [CallWith=...] IDL.
        (GenerateConstructorCallback):
        * bindings/scripts/test/TestInterface.idl: Ditto.
        * fileapi/FileReader.idl: Ditto.
        * p2p/PeerConnection.idl: Ditto.
        * page/EventSource.idl: Ditto.
        * workers/Worker.idl: Ditto.

2011-10-13  Kentaro Hara  <haraken@chromium.org>

        Constructor should not be called if the object is being constructed inside WebCore
        https://bugs.webkit.org/show_bug.cgi?id=70015

        Reviewed by Adam Barth.

        Summary: A DOM object can be created from the JS context and from the WebCore context.
        Constructor should be called if the object is created from the JS context,
        but should not be called if the object is created from the WebCore context.

        Details:
        - Expected behavior when the object is created from the JS context (e.g. "new Event()"):
        (1) V8XXXX::constructorCallback() is called.
        (2) V8XXXX::constructorCallback() calls XXXX::create().
        (3) XXXX::create() creates a C++ object.
        (4) V8XXXX::constructorCallback() calls toV8() for the C++ object.
        (5) toV8() wraps the C++ object and returns the wrapped JS object.

        - Actual behavior when the object is created from the JS context (e.g. "new Event()"):
        As described above (1) - (5). That's fine!!

        - Expected behavior when the object is created from the WebCore context.
        (e.g. "window.addEventListener("load", function (event) { ... });". In this case,
        the Event object is created inside the WebCore context):
        (1) WebCore calls XXXX::create().
        (2) XXXX::create() creates a C++ object.
        (3) WebCore calls toV8() for the C++ object.
        (4) toV8() wraps the C++ object and returns the wrapped JS object.

        - Actual behavior when the object is created from the WebCore context.
        (e.g. "window.addEventListener("load", function (event) { ... });"):
        (1) WebCore calls XXXX::create().
        (2) XXXX::create() creates a C++ object.
        (3) WebCore calls toV8() for the C++ object.
        (4) toV8() can call XXXX::constructorCallback(). (Whether or not toV8() calls
        XXXX::constructorCallback() depends on the implementation of toV8().)
        (5) V8XXXX::constructorCallback() calls XXXX::create().
        (6) XXXX::create() creates __another__ C++ object.
        (7) V8XXXX::constructorCallback() calls toV8() for the C++ object.
        (8) toV8() wraps the C++ object and returns the wrapped JS object.

        This actual behavior definitely causes the following problems:

        - Problem1: The object returned to JS is not the object created in (2)
        but the object created in (6). However, I do not yet know a test case that causes
        some visible bug because of this problem.

        - Problem2: In (4), XXXX::constructorCallback() can be called with no argument.
        If XXXX::constructorCallback() expects at least one argument, XXXX::constructorCallback()
        throws TypeError, resulting in crash. For example, Event caused this problem
        when I implemented constructor for Event. Based on the discussion with Dominicc,
        we solved this problem by adding the following two lines of code to Event::constructorCallback()
        (See here: http://codesearch.google.com/codesearch#OAMlx_jo-ck/src/third_party/WebKit/Source/WebCore/bindings/v8/custom/V8EventConstructors.cpp&exact_package=chromium&q=allowallocation&type=cs):

        XXXX::constructorCallback(...) {
            ...;
            if (AllowAllocation::current())
                return args.Holder();
            ...;
        }

        This if check means "XXXX::constructorCallback() returns immediately if it is called
        from the WebCore context".

        With these observations, we think that all constructorCallback() should have the above
        if check. This patch adds the if check to CodeGeneratorV8.pm. After this patch is landed,
        I would like to add the if check to all existing custom V8 constructors.

        No new tests, since we could not find a test case that causes some visible bug without the if check.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateConstructorCallback): Generates a constructor so that it returns immediately without doing anything if the constructor is called from the WebCore context.
        * bindings/scripts/test/V8/V8TestInterface.cpp: Updated the result.
        (WebCore::V8TestInterface::constructorCallback):
        * bindings/scripts/test/V8/V8TestObj.cpp: Ditto.
        (WebCore::V8TestObj::constructorCallback):

2011-10-13  Kentaro Hara  <haraken@chromium.org>

        Implement a BeforeLoadEvent constructor for V8
        https://bugs.webkit.org/show_bug.cgi?id=69980

        Reviewed by Adam Barth.

        Test: fast/events/constructors/before-load-event-constructor.html

        * bindings/v8/custom/V8EventConstructors.cpp: Added a BeforeLoadEvent constructor.
        * dom/BeforeLoadEvent.idl: Replaced 'JSCustomConstructor' with 'CustomConstructor'.

2011-10-13  Joshua Bell  <jsbell@chromium.org>

        make IDBFactory.open wait for pending setVersion transactions to complete
        https://bugs.webkit.org/show_bug.cgi?id=69307

        Reviewed by Tony Chang.

        Added a queue of pending open calls, similar to the queue of pending
        setVersion calls. Ensure pending calls are processed in the correct
        order when transactions complete.

        Tests: storage/indexeddb/open-close-version.html
               storage/indexeddb/two-version-changes.html
               storage/indexeddb/version-change-exclusive.html

        * storage/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::PendingOpenCall::create):
        (WebCore::IDBDatabaseBackendImpl::PendingOpenCall::callbacks):
        (WebCore::IDBDatabaseBackendImpl::PendingOpenCall::PendingOpenCall):
        (WebCore::IDBDatabaseBackendImpl::setVersion):
        (WebCore::IDBDatabaseBackendImpl::transactionStarted):
        (WebCore::IDBDatabaseBackendImpl::transactionFinished):
        (WebCore::IDBDatabaseBackendImpl::processPendingCalls):
        (WebCore::IDBDatabaseBackendImpl::openConnection):
        (WebCore::IDBDatabaseBackendImpl::close):
        * storage/IDBDatabaseBackendImpl.h:
        * storage/IDBFactoryBackendImpl.cpp:
        (WebCore::IDBFactoryBackendImpl::open):
        * storage/IDBTransactionBackendImpl.cpp:
        (WebCore::IDBTransactionBackendImpl::abort):
        (WebCore::IDBTransactionBackendImpl::start):
        (WebCore::IDBTransactionBackendImpl::commit):

2011-10-13  Chris Marrin  <cmarrin@apple.com>

        Fix Leopard build

        Unreviewed.

        * platform/graphics/DisplayRefreshMonitor.h: Added.

2011-10-12  Chris Marrin  <cmarrin@apple.com>

        Sync requestAnimationFrame callback to CVDisplayLink on Mac
        https://bugs.webkit.org/show_bug.cgi?id=68911

        Reviewed by Simon Fraser.

        Test: fast/animation/request-animation-frame-iframe.html

        Implement CVDisplayLink which checks to see if any scheduleAnimation requests
        have come in. If so, remember the timestamp and do a callOnMainThread to fire
        the callbacks. A DisplayRefreshMonitorManager is a singleton which has a list
        of DisplayRefreshMonitors, one for each display. Each monitor has one or more
        DisplayRefreshMonitorClients, which is a abstract virtual class implemented
        by ScriptAnimationController. When an animation is scheduled, the
        displayRefreshFired method is called on the client, which in turn calls the
        requestAnimationFrame callbacks. 

        DisplayRefreshMonitor and therefore the CVDisplayLink it owns is discarded
        when it no longer has any clients. This minimizes the number of concurrent
        CVDisplayLink threads.

        * WebCore.exp.in:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/Document.cpp:
        (WebCore::Document::windowScreenDidChange):
        (WebCore::Document::webkitRequestAnimationFrame):
        * dom/Document.h:
        * dom/ScriptedAnimationController.cpp:
        (WebCore::ScriptedAnimationController::ScriptedAnimationController):
        (WebCore::ScriptedAnimationController::windowScreenDidChange):
        (WebCore::ScriptedAnimationController::scheduleAnimation):
        * dom/ScriptedAnimationController.h:
        (WebCore::ScriptedAnimationController::displayRefreshFired):
        * page/Page.cpp:
        (WebCore::Page::Page):
        (WebCore::Page::windowScreenDidChange):
        * page/Page.h:
        (WebCore::Page::displayID):
        * platform/PlatformScreen.h:
        * platform/graphics/DisplayRefreshMonitor.cpp: Added.
        (WebCore::DisplayRefreshMonitorClient::DisplayRefreshMonitorClient):
        (WebCore::DisplayRefreshMonitorClient::~DisplayRefreshMonitorClient):
        (WebCore::DisplayRefreshMonitorClient::fireDisplayRefreshIfNeeded):
        (WebCore::DisplayRefreshMonitor::DisplayRefreshMonitor):
        (WebCore::DisplayRefreshMonitor::refreshDisplayOnMainThread):
        (WebCore::DisplayRefreshMonitorManager::sharedManager):
        (WebCore::DisplayRefreshMonitorManager::findMonitor):
        (WebCore::DisplayRefreshMonitorManager::registerClient):
        (WebCore::DisplayRefreshMonitorManager::unregisterClient):
        (WebCore::DisplayRefreshMonitorManager::scheduleAnimation):
        (WebCore::DisplayRefreshMonitorManager::windowScreenDidChange):
        * platform/graphics/DisplayRefreshMonitor.h: Added.
        (WebCore::DisplayRefreshMonitorClient::scheduleAnimation):
        (WebCore::DisplayRefreshMonitor::hasClients):
        (WebCore::DisplayRefreshMonitor::addClient):
        (WebCore::DisplayRefreshMonitor::removeClient):
        (WebCore::DisplayRefreshMonitor::displayID):
        (WebCore::DisplayRefreshMonitorManager::DisplayRefreshMonitorManager):
        * platform/graphics/mac/DisplayRefreshMonitorMac.cpp: Added.
        (WebCore::DisplayRefreshMonitor::displayLinkCallback):
        (WebCore::DisplayRefreshMonitor::~DisplayRefreshMonitor):
        (WebCore::DisplayRefreshMonitor::scheduleAnimation):

2011-10-13  Abhishek Arya  <inferno@chromium.org>

        Unreviewed. Qt compile fix.

        * css/CSSFontFaceSource.cpp: include Document.h.

2011-10-12  Abhishek Arya  <inferno@chromium.org>

        Register custom fonts at their creation time,  
        rather than at retirement time.
        https://bugs.webkit.org/show_bug.cgi?id=68929

        Reviewed by Dan Bernstein.

        Test: fast/text/custom-font-data-crash2.html

        * css/CSSFontFace.cpp:
        * css/CSSFontFace.h: remove function added in r94508,
        which is no longer needed. We now register custom fonts
        at creation time.
        * css/CSSFontFaceSource.cpp:
        (WebCore::CSSFontFaceSource::pruneTable): no longer need
        to delete/retire font data here, it will be handled in ~Document.
        (WebCore::CSSFontFaceSource::getFontData): register custom
        font to document's m_customFonts.
        * css/CSSFontSelector.cpp:
        * css/CSSFontSelector.h: remove function added in r94508,
        which is no longer needed. We now register custom fonts
        at creation time.
        * css/CSSSegmentedFontFace.cpp:
        (WebCore::CSSSegmentedFontFace::pruneTable): no longer need
        to delete/retire font data here, it will be handled in ~Document.
        (WebCore::CSSSegmentedFontFace::getFontData): register custom
        font to document's m_customFonts.
        * dom/Document.cpp: Change function names to registerCustomFont
        , deleteCustomFonts and local to m_customFont.
        (WebCore::Document::~Document):
        (WebCore::Document::recalcStyle): yanking out the comment. We
        no longer keep retired custom fonts. We clear all custom fonts
        on Document destruction.
        (WebCore::Document::registerCustomFont): 
        (WebCore::Document::deleteCustomFonts):
        * dom/Document.h:

2011-10-13  Ryosuke Niwa  <rniwa@webkit.org>

        Crash in DeleteSelectionCommand::handleGeneralDelete
        https://bugs.webkit.org/show_bug.cgi?id=70045

        Reviewed by Darin Adler.

        Exit early when m_upstreamStart is null.

        No new tests because we don't have a reduction.

        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::handleGeneralDelete):

2011-10-13  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=70049
        
        [CSS Regions] Add a test of a float being pushed down because it can't fit
        next to another float and make sure it re-evaluates its position when it changes
        regions as a result of the push.

        Reviewed by Sam Weinig.

        Added new test in fast/regions.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::computeLogicalLocationForFloat):

2011-10-13  Adam Barth  <abarth@webkit.org>

        Move XSTL to script-src in Content-Security-Policy
        https://bugs.webkit.org/show_bug.cgi?id=63637

        Reviewed by Eric Seidel.

        The spec was unclear about how to treat XSLT.  My reading was that they
        should fall under style-src, but further discussion on the mailing list
        settled on using script-src because an XSLT can inject arbitrary DOM
        and script into a page, which is more risky than including style.

        Tests: http/tests/security/contentSecurityPolicy/xsl-unaffected-by-style-src-1.php
               http/tests/security/contentSecurityPolicy/xsl-unaffected-by-style-src-2.php

        * loader/cache/CachedResourceLoader.cpp:
        (WebCore::CachedResourceLoader::canRequest):

2011-10-13  Zeno Albisser  <zeno.albisser@nokia.com>

        [Qt] QtWebKit build error for Mac 32bit
        https://bugs.webkit.org/show_bug.cgi?id=69914

        In WebCore.pro and QtWebKit.pro we define NSGEOMETRY_TYPES_SAME_AS_CGGEOMETRY_TYPES
        when compiling with ENABLE_VIDEO and with WTF_USE_QTKIT.
        But this is meant to be defined in NSGeometry.h under certain preconditions.
        Without setting NS_BUILD_32_LIKE_64 none of these preconditions is
        met and therefore NSGeometry.h will create several conflicting type definitions.

        With this patch we create consistent definitions again.
        Due to the order of include files we cannot remove
        NSGEOMETRY_TYPES_SAME_AS_CGGEOMETRY_TYPES from WebCore.pro.

        Reviewed by Andreas Kling.

        * WebCore.pro:

2011-10-13  Tom Hudson  <tomhudson@google.com>

        Revert border radius clips (r95239) for Chromium due to performance issues. Update test expectations to skip border radius clip layout tests.
        https://bugs.webkit.org/show_bug.cgi?id=69844

        Reviewed by Simon Fraser.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::clipToRect): Only process border radius clips #if !PLATFORM(CHROMIUM)

2011-10-13  Julien Chaffraix  <jchaffraix@webkit.org>

        Deprecate event.layerX and event.layerY in WebKit
        https://bugs.webkit.org/show_bug.cgi?id=69951

        Reviewed by Darin Adler.

        layerX and layerY were concepts of the old Netscape code that stayed
        in WebKit for a long time without changes. Now the code is completely
        wrong and Mozilla has expressed some interest in removing it from their
        API too.

        This is a first step in the removal as layerX and layerY are exposed
        in some APIs. Chromium and Win are fine with removing the property
        directly, but ObjC needs to deprecate them first.

        * bindings/objc/PublicDOMInterfaces.h: Mark the API as deprecated.

        * dom/MouseRelatedEvent.cpp:
        (WebCore::MouseRelatedEvent::layerX):
        (WebCore::MouseRelatedEvent::layerY):
        * dom/UIEvent.cpp:
        (WebCore::UIEvent::layerX):
        (WebCore::UIEvent::layerY):
        Added a call to warnDeprecatedLayerXYUsage in the previous functions.

        (WebCore::UIEvent::warnDeprecatedLayerXYUsage): Print a warning in the
        console about the removal of event.layerX and event.layerY in the near future.

        * dom/UIEvent.h: Added warnDeprecatedLayerXYUsage.

2011-10-03  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: inline-replaced-height-008.htm
        https://bugs.webkit.org/show_bug.cgi?id=69273

        Reviewed by Simon Fraser.

        Test: css2.1/20110323/inline-block-replaced-height-008.html

        Per http://www.w3.org/TR/CSS21/visudet.html#inline-replaced-height,  if 'height' has computed value of 
        'auto', the replaced element has an intrinsic ratio and its used width is known or resolved, then 
        the used value of 'height' is determined by the equation (used width) / (intrinsic ratio).

        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::computeReplacedLogicalHeight):
        * rendering/RenderReplaced.h:

2011-10-13  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r97362.
        http://trac.webkit.org/changeset/97362
        https://bugs.webkit.org/show_bug.cgi?id=70039

        Relies on V8 APIs that have been reverted upstream. (Requested
        by dglazkov on #webkit).

        * English.lproj/localizedStrings.js:
        * bindings/js/ScriptProfiler.cpp:
        * bindings/js/ScriptProfiler.h:
        * bindings/v8/ScriptProfiler.cpp:
        * bindings/v8/ScriptProfiler.h:
        * inspector/Inspector.json:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::create):
        (WebCore::InspectorProfilerAgent::InspectorProfilerAgent):
        * inspector/InspectorProfilerAgent.h:
        * inspector/front-end/DetailedHeapshotGridNodes.js:
        (WebInspector.HeapSnapshotGridNode.prototype.hasHoverMessage.false.hoverMessage):
        (WebInspector.HeapSnapshotGenericObjectNode):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.get data):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.hoverMessage):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.shortenWindowURL):
        * inspector/front-end/DetailedHeapshotView.js:
        (WebInspector.DetailedHeapshotView.prototype._showStringContentPopover):
        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype.dispose):
        (WebInspector.HeapSnapshot.prototype.updateStaticData):
        (WebInspector.HeapSnapshotNodesProvider.prototype._serialize):
        * inspector/front-end/HeapSnapshotProxy.js:
        * inspector/front-end/RemoteObject.js:
        * inspector/front-end/heapProfiler.css:

2011-10-13  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=69932
        
        Layout repainting messed up for objects in regions. There were two bugs here.
        The first is that the regionOverflowRect needs to at least be the size of the 
        region's rect. When you're in the middle of layout, you haven't computed the
        overflow rect for the flow thread yet (the flow thread's height could even be 0),
        and so you just need to enforce a minimum size. Also removed the region-overflow:break
        clipping behavior, since it was established that was wrong.
        
        The second bug is that when you tell a region to repaint, you need to disable layout state,
        since applying layout deltas from the flow thread makes no sense. The region is in a totally
        different place in the render tree, so the current flow thread layout state can't be used
        to determine your coordinate offset.

        Reviewed by Dan Bernstein.

        Added fast/repaint test.

        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::repaintRectangleInRegions):
        * rendering/RenderRegion.cpp:
        (WebCore::RenderRegion::regionOverflowRect):

2011-10-13  Renata Hodovan  <reni@webkit.org>

        FEComponentTransfer element doesn't support dynamic invalidation
        https://bugs.webkit.org/show_bug.cgi?id=69747

        The dynamic changes are captured by the svgAttributeChange() function, and
        invalidate the filter primitive if necessary.
        invalidateFilterPrimitiveParent() is a new free function in
        SVGFilterPrimitiveStanardAttributes what makes the invalidation possible
        by objects not inherited from SVGFilterPrimitiveStanardAttributes too.
        This solution was used in SVGFEMergeNodeElement::svgAttributeChanged()
        previously and now it can use this new function too.

        Reviewed by Nikolas Zimmermann.

        Tests: svg/dynamic-updates/SVGFEComponentTransferElement-dom-amplitude-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-exponent-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-intercept-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-offset-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-slope-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-tableValues-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-dom-type-attr.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-amplitude-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-exponent-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-intercept-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-offset-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-slope-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-tableValues-prop.html
               svg/dynamic-updates/SVGFEComponentTransferElement-svgdom-type-prop.html

        * svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::svgAttributeChanged):
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::build):
        * svg/SVGFEMergeNodeElement.cpp:
        (WebCore::SVGFEMergeNodeElement::svgAttributeChanged):
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::invalidateFilterPrimitiveParent):
        * svg/SVGFilterPrimitiveStandardAttributes.h:

2011-10-13  Deepak Sherveghar  <bpwv64@motorola.com>

        REGRESSION (r95381): Standalone video can be focused and draws a focus ring.
        https://bugs.webkit.org/show_bug.cgi?id=69097

        Reviewed by Eric Carlson.

        We don't want to focus a media element in a standalone document.

        Test: fast/events/media-focus-in-standalone-media-document.html

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::supportsFocus): return false if media element is in a standalone media document.

2011-10-13  Mikhail Naganov  <mnaganov@chromium.org>

        Web Inspector: [Chromium] Add an ability to look up and explore an object from a heap profile.
        https://bugs.webkit.org/show_bug.cgi?id=61179

        This is exteremely helpful when dealing with DOM wrappers, as
        their properties are mostly implemented with getters and thus not
        stored in heap snapshots.

        Reviewed by Pavel Feldman.

        * English.lproj/localizedStrings.js:
        * bindings/js/ScriptProfiler.cpp:
        (WebCore::ScriptProfiler::objectByHeapObjectId):
        * bindings/js/ScriptProfiler.h:
        * bindings/v8/ScriptProfiler.cpp:
        (WebCore::ScriptProfiler::objectByHeapObjectId):
        * bindings/v8/ScriptProfiler.h:
        * inspector/Inspector.json:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::create):
        (WebCore::InspectorProfilerAgent::InspectorProfilerAgent):
        (WebCore::InspectorProfilerAgent::getObjectByHeapObjectId):
        * inspector/InspectorProfilerAgent.h:
        * inspector/front-end/DetailedHeapshotGridNodes.js:
        (WebInspector.HeapSnapshotGridNode.prototype.hasHoverMessage.false.queryObjectContent):
        (WebInspector.HeapSnapshotGenericObjectNode):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.get data):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.queryObjectContent.else.formatResult):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.queryObjectContent):
        (WebInspector.HeapSnapshotGenericObjectNode.prototype.shortenWindowURL):
        * inspector/front-end/DetailedHeapshotView.js:
        (WebInspector.DetailedHeapshotView.prototype._showObjectPopover):
        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get canBeQueried):
        (WebInspector.HeapSnapshotNode.prototype.get flags):
        (WebInspector.HeapSnapshotNode.prototype.get isDOMWindow):
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype.dispose):
        (WebInspector.HeapSnapshot.prototype._flagsOfNode):
        (WebInspector.HeapSnapshot.prototype._calculateFlags):
        (WebInspector.HeapSnapshot.prototype.updateStaticData):
        (WebInspector.HeapSnapshotNodesProvider.prototype._serialize):
        * inspector/front-end/HeapSnapshotProxy.js:
        (WebInspector.HeapSnapshotProxy.prototype.get nodeFlags):
        * inspector/front-end/RemoteObject.js:
        (WebInspector.RemoteObject.fromError):
        * inspector/front-end/heapProfiler.css:
        (.detailed-heapshot-view tr:not(.selected) td.object-column span.highlight):

2011-10-13  Adam Barth  <abarth@webkit.org>

        script-src * should allow all URLs
        https://bugs.webkit.org/show_bug.cgi?id=70011

        Reviewed by Eric Seidel.

        This patch gets us slightly ahead of the spec.  Technically, script-src
        means "any host" and inherits the current scheme.  However, that's not
        what developers expect and it's even contradicted by examples in the
        spec itself.  After this patch, * matches all URLs.

        Test: http/tests/security/contentSecurityPolicy/script-src-star-cross-scheme.html

        * page/ContentSecurityPolicy.cpp:
        (WebCore::CSPSourceList::CSPSourceList):
        (WebCore::CSPSourceList::matches):
        (WebCore::CSPSourceList::parseSource):
        (WebCore::CSPSourceList::addSourceStar):

2011-10-13  Kentaro Hara  <haraken@chromium.org>

        Implement an OverflowEvent constructor for JSC
        https://bugs.webkit.org/show_bug.cgi?id=69907

        Reviewed by Adam Barth.

        There is no spec for the OverflowEvent constructor
        since it is WebKit-specific. However, judging from the current
        IDL of initOverflowEvent(), the constructor IDL should be as follows.

        [Constructor(DOMString type, optional OverflowEventInit eventInitDict)]
        interface OverflowEvent : Event {
            ...;
        }

        dictionary OverflowEventInit : EventInit {
            unsigned short orient;
            boolean horizontalOverflow;
            boolean verticalOverflow;
        }

        Note: In initOverflowEvent(), we cannot specify |bubbles| and |cancelable|.
        I do not know why, but we can find a comment in fast/events/script-tests/init-events.js
        that says "initOverflowEvent has an interface that has a design that's
        inconsistent with the init functions from other events".
        On the other hand, the above constructor enables to specify |bubbles| and |cancelable|,
        which is consistent with other constructors.

        Test: fast/events/constructors/overflow-event-constructor.html

        * bindings/generic/EventConstructors.h: Added a definition for the OverflowEvent constructor.
        * bindings/js/JSEventConstructors.cpp: Added #includes for OverflowEvent.
        * dom/OverflowEvent.cpp:
        (WebCore::OverflowEventInit::OverflowEventInit):
        (WebCore::OverflowEvent::OverflowEvent):
        (WebCore::OverflowEvent::initOverflowEvent):
        * dom/OverflowEvent.h: Added a definition for OverflowEventInit.
        (WebCore::OverflowEvent::create):
        (WebCore::OverflowEvent::orient):
        (WebCore::OverflowEvent::horizontalOverflow):
        (WebCore::OverflowEvent::verticalOverflow):
        * dom/OverflowEvent.idl: Makes OverflowEvent constructible.

2011-10-13  Kent Tamura  <tkent@chromium.org>

        Cleanup of HTMLSelectElement
        https://bugs.webkit.org/show_bug.cgi?id=69908

        Reviewed by Darin Adler.

        - Change the m_listItems type: Vector<Element*> -> Vector<HTMLElement*>
        - Rename a member: m_recalcListItems -> m_shouldRecalcListItems
        - Fold checkListItems() into listItems()
        - Style fixes

        No new tests, just a cleanup.

        * accessibility/AccessibilityListBox.cpp:
        (WebCore::AccessibilityListBox::addChildren):
        * accessibility/AccessibilityListBoxOption.cpp:
        (WebCore::AccessibilityListBoxOption::listBoxOptionIndex):
        * accessibility/AccessibilityMenuListPopup.cpp:
        (WebCore::AccessibilityMenuListPopup::addChildren):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::stringValue):
        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (optionFromSelection):
        (webkit_accessible_selection_get_selection_count):
        * dom/OptionElement.cpp:
        (WebCore::OptionElement::optionIndex):
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::HTMLSelectElement):
        (WebCore::HTMLSelectElement::add):
        (WebCore::HTMLSelectElement::value):
        (WebCore::HTMLSelectElement::setValue):
        (WebCore::HTMLSelectElement::parseMappedAttribute):
        (WebCore::HTMLSelectElement::recalcListItemsIfNeeded):
        (WebCore::HTMLSelectElement::setOption):
        (WebCore::HTMLSelectElement::setLength):
        (WebCore::HTMLSelectElement::nextValidIndex):
        (WebCore::HTMLSelectElement::firstSelectableListIndex):
        (WebCore::HTMLSelectElement::nextSelectableListIndexPageAway):
        (WebCore::HTMLSelectElement::selectAll):
        (WebCore::HTMLSelectElement::saveLastSelection):
        (WebCore::HTMLSelectElement::setActiveSelectionAnchorIndex):
        (WebCore::HTMLSelectElement::updateListBoxSelection):
        (WebCore::HTMLSelectElement::listBoxOnChange):
        (WebCore::HTMLSelectElement::listItems):
        (WebCore::HTMLSelectElement::setRecalcListItems):
        (WebCore::HTMLSelectElement::recalcListItemsInternal):
        (WebCore::HTMLSelectElement::selectedIndex):
        (WebCore::HTMLSelectElement::setSelectedIndexInternal):
        (WebCore::HTMLSelectElement::optionToListIndex):
        (WebCore::HTMLSelectElement::listToOptionIndex):
        (WebCore::HTMLSelectElement::dispatchFocusEvent):
        (WebCore::HTMLSelectElement::deselectItemsWithoutValidation):
        (WebCore::HTMLSelectElement::saveFormControlState): Use StringBuilder.
        (WebCore::HTMLSelectElement::restoreFormControlState):
        (WebCore::HTMLSelectElement::appendFormData):
        (WebCore::HTMLSelectElement::reset):
        (WebCore::HTMLSelectElement::menuListDefaultEventHandler):
        (WebCore::HTMLSelectElement::updateSelectedState):
        (WebCore::HTMLSelectElement::listBoxDefaultEventHandler):
        (WebCore::HTMLSelectElement::lastSelectedListIndex):
        Optimize the code by iterating in the reverse order.
        (WebCore::HTMLSelectElement::typeAheadFind):
        (WebCore::HTMLSelectElement::accessKeySetSelectedIndex):
        (WebCore::HTMLSelectElement::length):
        (WebCore::toSelectElement):
        * html/HTMLSelectElement.h:
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::updateFromElement):
        (WebCore::RenderListBox::addFocusRingRects):
        (WebCore::RenderListBox::paintItemForeground):
        (WebCore::RenderListBox::paintItemBackground):
        (WebCore::RenderListBox::nodeAtPoint):
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::updateOptionsWidth):
        (WebCore::RenderMenuList::setTextFromOption):
        (WebCore::RenderMenuList::itemText):
        (WebCore::RenderMenuList::itemAccessibilityText):
        (WebCore::RenderMenuList::itemToolTip):
        (WebCore::RenderMenuList::itemIsEnabled):
        (WebCore::RenderMenuList::itemStyle):
        (WebCore::RenderMenuList::itemBackgroundColor):
        (WebCore::RenderMenuList::itemIsSeparator):
        (WebCore::RenderMenuList::itemIsLabel):
        (WebCore::RenderMenuList::itemIsSelected):

2011-10-13  Adam Barth  <abarth@webkit.org>

        DOMWindow subobjects can be re-created after navigation
        https://bugs.webkit.org/show_bug.cgi?id=68849

        Reviewed by Sam Weinig.

        Test: http/tests/security/xss-DENIED-getSelection-from-inactive-domwindow.html

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::~DOMWindow):
            - Add ASSERTs to show that we're not recreating these objects.
            - Add a call to clear() as defense in depth in case we have any of
              these objects hanging around.
        (WebCore::DOMWindow::clear):
            - Clear out a couple of objects that weren't getting cleared.
              These are actually not likely to cause problems, but clearing
              them out is the safe thing to do.
        (WebCore::DOMWindow::isActive):
            - Add a concept of whether the DOMWindow is "active" in its frame.
              We had this concept in a couple places already, but centralizing
              it into a helper function make it easier to use and talk about.
        (WebCore::DOMWindow::orientation):
            - Whitespace nit.
        (WebCore::DOMWindow::screen):
        (WebCore::DOMWindow::history):
        (WebCore::DOMWindow::crypto):
        (WebCore::DOMWindow::locationbar):
        (WebCore::DOMWindow::menubar):
        (WebCore::DOMWindow::personalbar):
        (WebCore::DOMWindow::scrollbars):
        (WebCore::DOMWindow::statusbar):
        (WebCore::DOMWindow::toolbar):
        (WebCore::DOMWindow::console):
        (WebCore::DOMWindow::applicationCache):
        (WebCore::DOMWindow::navigator):
        (WebCore::DOMWindow::performance):
        (WebCore::DOMWindow::location):
        (WebCore::DOMWindow::sessionStorage):
        (WebCore::DOMWindow::localStorage):
        (WebCore::DOMWindow::webkitNotifications):
        (WebCore::DOMWindow::webkitIndexedDB):
        (WebCore::DOMWindow::getSelection):
        (WebCore::DOMWindow::styleMedia):
        (WebCore::DOMWindow::webkitURL):
        (WebCore::DOMWindow::webkitStorageInfo):
            - Avoid creating these objects when we're not active.  That can
              only lead to sadness.
        (WebCore::DOMWindow::webkitRequestFileSystem):
        (WebCore::DOMWindow::webkitResolveLocalFileSystemURL):
        (WebCore::DOMWindow::openDatabase):
        (WebCore::DOMWindow::postMessage):
            - While not techincally creating subobjects, these functions also
              seem unwise when the DOMWindow is inactive.
        (WebCore::DOMWindow::find):
        (WebCore::DOMWindow::length):
        (WebCore::DOMWindow::getMatchedCSSRules):
            - These functions operate on the active Document.  When we're not
              active, that's not us!
        (WebCore::DOMWindow::document):
            - Update to use the new concept of being active rather than having
              this function roll its own implementation.
        (WebCore::DOMWindow::webkitConvertPointFromNodeToPage):
        (WebCore::DOMWindow::webkitConvertPointFromPageToNode):
        (WebCore::DOMWindow::scrollBy):
        (WebCore::DOMWindow::scrollTo):
            - These functions also look unwise to run when inactive because
              they're reading information from the active document.
            - I added a RefPtr for node because the call to
              updateLayoutIgnorePendingStylesheets() seems likely to be able to
              run script somehow.
        (WebCore::DOMWindow::addEventListener):
        (WebCore::DOMWindow::removeEventListener):
        (WebCore::DOMWindow::dispatchLoadEvent):
        (WebCore::DOMWindow::dispatchEvent):
            - I don't think these functions worked when inactive anyway, but
              explicitly blocking them seems wise.
        (WebCore::DOMWindow::setLocation):
        (WebCore::DOMWindow::isInsecureScriptAccess):
        (WebCore::DOMWindow::open):
        (WebCore::DOMWindow::showModalDialog):
            - These already have checks for being active, but it can't hurt to
              be explicit at the top of the function.
        * page/DOMWindow.h:

2011-10-13  Kent Tamura  <tkent@chromium.org>

        REGRESSION(r89915): <input type=email multiple> don't show the default value
        https://bugs.webkit.org/show_bug.cgi?id=69895

        Reviewed by Hajime Morita.

        m_valueIfDirty became unexpectedly empty because
        EmailInputType::sanitizeValue() returned an empty string for a
        null input string.

        To solve this issue, HTMLInputElement::sanitizeValue() checks
        nullness, and remove the null check of sanitizeValue() of
        InputType subclasses.
        Also, we make InputType::sanitizeValue() const.

        * html/ColorInputType.cpp:
        (WebCore::ColorInputType::sanitizeValue):
        - Make this const.
        - Remove null check.
        * html/ColorInputType.h: Make sanitizeValue() const.
        * html/EmailInputType.cpp:
        (WebCore::EmailInputType::sanitizeValue): Make this const.
        * html/EmailInputType.h: Make sanitizeValue() const.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::sanitizeValue):
        (WebCore::HTMLInputElement::updateValueIfNeeded):
        * html/InputType.cpp:
        (WebCore::InputType::sanitizeValue):
        Returns a null string if the input string is null, and
        don't call InputType::sanitizeValue() in this case.
        * html/InputType.h: Make sanitizeValue() const.
        * html/NumberInputType.cpp:
        (WebCore::NumberInputType::sanitizeValue): Make this const.
        * html/NumberInputType.h: Make sanitizeValue() const.
        * html/RangeInputType.cpp:
        (WebCore::RangeInputType::sanitizeValue):
        - Make this const.
        - Remove null check.
        * html/RangeInputType.h: Make sanitizeValue() const.
        * html/TextFieldInputType.cpp:
        (WebCore::TextFieldInputType::sanitizeValue): Make this const.
        * html/TextFieldInputType.h: Make sanitizeValue() const.

2011-10-12  Joseph Pecoraro  <joepeck@webkit.org>

        Pass Parsed Accept Attribute MIME Types to WebKit Clients
        https://bugs.webkit.org/show_bug.cgi?id=69598

        Reviewed by David Kilzer.

        No new tests. No new functionality in WebCore, just
        exposing more information to the WebKit port.

        * html/FileInputType.cpp:
        (WebCore::FileInputType::handleDOMActivateEvent):
        (WebCore::FileInputType::receiveDropForDirectoryUpload):
        Set the MIME type list on the FileChooser settings.

        * html/HTMLInputElement.h:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::acceptMIMETypes):
        Accessor for a parsed list of MIME types from the accept attribute.
        
        * platform/FileChooser.h:
        Add a slot for a MIME type list on the chooser settings.

2011-10-12  Joseph Pecoraro  <joepeck@webkit.org>

        Pass Parsed Accept Attribute MIME Types to WebKit Clients
        https://bugs.webkit.org/show_bug.cgi?id=69598

        Reviewed by Kent Tamura.

        Deprecate the old String version of getting the "accept"
        mime type values. Instead we will change to include a
        list of MIME types.

        * html/FileInputType.cpp:
        (WebCore::FileInputType::handleDOMActivateEvent):
        (WebCore::FileInputType::receiveDropForDirectoryUpload):
        * platform/FileChooser.h:

2011-10-12  Adam Barth  <abarth@webkit.org>

        Remove ENABLE(XHTMLMP) and associated code
        https://bugs.webkit.org/show_bug.cgi?id=69729

        Reviewed by David Levin.

        As discussed on webkit-dev, we are removing this feature as part of our
        cleanup of unmaintained code in WebKit.

        * Configurations/FeatureDefines.xcconfig:
        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMImplementation.cpp:
        (WebCore::DOMImplementation::createDocument):
        * dom/Document.cpp:
        (WebCore::Document::Document):
        * dom/Document.h:
        (WebCore::Document::isMediaDocument):
        * dom/Node.cpp:
        * dom/make_names.pl:
        (usesDefaultJSWrapper):
        * features.pri:
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::rendererIsNeeded):
        * html/HTMLElementsAllInOne.cpp:
        * html/HTMLNoScriptElement.cpp: Removed.
        * html/HTMLNoScriptElement.h: Removed.
        * html/HTMLTagNames.in:
        * html/HTMLViewSourceDocument.cpp:
        (WebCore::HTMLViewSourceDocument::createParser):
        * loader/FrameLoader.cpp:
        * platform/wince/MIMETypeRegistryWinCE.cpp:
        (WebCore::MIMETypeRegistry::getPreferredExtensionForMIMEType):
        * xml/parser/XMLDocumentParser.h:
        (WebCore::XMLDocumentParser::isXHTMLDocument):
        * xml/parser/XMLDocumentParserLibxml2.cpp:
        (WebCore::XMLDocumentParser::XMLDocumentParser):
        (WebCore::XMLDocumentParser::startElementNs):
        (WebCore::XMLDocumentParser::endElementNs):
        (WebCore::XMLDocumentParser::endDocument):
        (WebCore::XMLDocumentParser::internalSubset):
        (WebCore::getEntityHandler):
        (WebCore::externalSubsetHandler):
        * xml/parser/XMLDocumentParserQt.cpp:
        (WebCore::XMLDocumentParser::XMLDocumentParser):
        (WebCore::XMLDocumentParser::parse):
        (WebCore::XMLDocumentParser::parseStartElement):
        (WebCore::XMLDocumentParser::parseEndElement):
        (WebCore::XMLDocumentParser::endDocument):
        (WebCore::XMLDocumentParser::parseDtd):

2011-10-12  Kentaro Hara  <haraken@chromium.org>

        Implement a WebKitTransitionEvent constructor for V8
        https://bugs.webkit.org/show_bug.cgi?id=69911

        Reviewed by Adam Barth.

        Test: fast/events/constructors/webkit-transition-event-constructor.html

        * bindings/v8/custom/V8EventConstructors.cpp: Added a WebKitTransitionEvent constructor.
        * dom/WebKitTransitionEvent.idl: Replaced 'JSCustomConstructor' with 'CustomConstructor'.

2011-10-12  Kentaro Hara  <haraken@chromium.org>

        Implement a BeforeLoadEvent constructor for JSC
        https://bugs.webkit.org/show_bug.cgi?id=69893

        Reviewed by Adam Barth.

        There is no spec for the BeforeLoadEvent constructor
        since it is WebKit-specific. However, judging from the current
        IDL of initBeforeLoadEvent(), the constructor IDL
        should be as follows.

        [Constructor(DOMString type, optional BeforeLoadEventInit eventInitDict)]
        interface BeforeLoadEvent : Event {
            ...;
        }

        dictionary BeforeLoadEventInit : EventInit {
            DOMString url;
        }

        Test: fast/events/constructors/before-load-event-constructor.html

        * bindings/generic/EventConstructors.h: Added a definition for the BeforeLoadEvent constructor.
        * bindings/js/JSEventConstructors.cpp: Added #includes for BeforeLoadEvent.
        * dom/BeforeLoadEvent.h: Added a definition for BeforeLoadEventInit.
        (WebCore::BeforeLoadEventInit::BeforeLoadEventInit):
        (WebCore::BeforeLoadEvent::create):
        (WebCore::BeforeLoadEvent::initBeforeLoadEvent):
        (WebCore::BeforeLoadEvent::BeforeLoadEvent):
        * dom/BeforeLoadEvent.idl: Makes BeforeLoadEvent constructible.

2011-10-12  Ben Wells  <benwells@chromium.org>

        [skia] Implement Path.currentPoint for skia
        https://bugs.webkit.org/show_bug.cgi?id=69817

        Replace FIXME with implementation.

        Reviewed by Kenneth Russell.

        * platform/graphics/skia/PathSkia.cpp:
        (WebCore::Path::currentPoint):

2011-10-12  Ben Wells  <benwells@chromium.org>

        Incorrect rendering with one-sided thick border and border-radius
        https://bugs.webkit.org/show_bug.cgi?id=38787

        Reviewed by Simon Fraser.

        Incorrect rendering resulted when the inner border could not be properly represented as a rounded
        rectangle. When this happens, and the inner border is clipped out, the clipping code clips out the
        enclosing rectangle instead.

        This change addresses this by clipping in a different way in this case only. The inside is clipped
        out one side at a time with a rounded rect created by adjusting the unrenderable inner border
        rounded rectangle. The side polygon which is clipped to is also increased in this case to include
        the inside of the border so that no areas are missing.

        Test: fast/borders/border-radius-complex-inner.html

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintOneBorderSide):
        (WebCore::RenderBoxModelObject::paintBorder):
        (WebCore::calculateSideRectIncludingInner):
        (WebCore::calculateAdjustedInnerBorder):
        (WebCore::RenderBoxModelObject::clipBorderSideForComplexInnerPath):
        * rendering/RenderBoxModelObject.h:

2011-10-12  Luke Macpherson   <macpherson@chromium.org>

        Clean up CSSPropertyTextDecoration implementation and ETextDecoration usage.
        https://bugs.webkit.org/show_bug.cgi?id=67625

        Reviewed by Eric Seidel.

        No new tests - no functionality changed.

        The implementation of CSSPropertyTextDecoration is simlified because
        1) CSSValueListIterator produces a valid iterator when no results available.
        2) CSSParser only allows CSSValueNone or a list of appropriate idents.
        3) CSSParser will treat a zero-length list as invalid at parse time.

        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::operator ETextDecoration):
        Implement cast from CSSPrimitiveValue to ETextDecoration.
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * rendering/style/RenderStyle.h:
        Use ETextDecoration enum instead of int throughout.
        (WebCore::InheritedFlags::textDecorationsInEffect):
        (WebCore::InheritedFlags::textDecoration):
        (WebCore::InheritedFlags::addToTextDecorationsInEffect):
        (WebCore::InheritedFlags::setTextDecorationsInEffect):
        (WebCore::InheritedFlags::setTextDecoration):
        * rendering/style/RenderStyleConstants.h:
        Introduce constant for number of bits required to represent enum.
        (WebCore::operator|):
        Implement | operator for bitfield enum.
        (WebCore::operator|=):
        Implement |= operator for bitfield enum.
        * rendering/style/StyleVisualData.h:
        Use ETextDecoration instead of int.

2011-10-12  Tony Chang  <tony@chromium.org>

        Implement -webkit-flex-align for cross axis alignment in flex-flow: row
        https://bugs.webkit.org/show_bug.cgi?id=69808

        Reviewed by David Hyatt.

        Tests: css3/flexbox/flex-align-percent-height.html
               css3/flexbox/flex-align-vertical-writing-mode.html
               css3/flexbox/flex-align.html

        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::isFlowAwareLogicalHeightAuto):
        (WebCore::RenderFlexibleBox::flowAwareContentLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareBorderAndPaddingLogicalHeight):
        (WebCore::RenderFlexibleBox::flowAwareMarginLogicalHeightForChild):
        (WebCore::RenderFlexibleBox::flowAwareLogicalLocationForChild):
        (WebCore::RenderFlexibleBox::layoutInlineDirection):
        (WebCore::RenderFlexibleBox::availableLogicalHeightForChild):
        (WebCore::RenderFlexibleBox::marginBoxAscent):
        (WebCore::RenderFlexibleBox::layoutAndPlaceChildrenInlineDirection):
        (WebCore::RenderFlexibleBox::adjustLocationLogicalTopForChild):
        (WebCore::RenderFlexibleBox::alignChildrenBlockDirection):
        * rendering/RenderFlexibleBox.h:

2011-10-12  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSS Regions]Remove -webkit-content-order property
        https://bugs.webkit.org/show_bug.cgi?id=69848

        Reviewed by Tony Chang.

        -webkit-content-order property is removed from latest CSS Regions spec.

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSPropertyNames.in:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * dom/Node.cpp:
        (WebCore::Node::diff):
        * rendering/RenderFlowThread.cpp:
        (WebCore::compareRenderRegions):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::writeRenderFlowThreads):
        * rendering/style/RenderStyle.h:
        * rendering/style/StyleRareNonInheritedData.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        * rendering/style/StyleRareNonInheritedData.h:

2011-10-12  Adam Bergkvist  <adam.bergkvist@ericsson.com>

        Update PeerConnection to use WebCore platform interfaces
        https://bugs.webkit.org/show_bug.cgi?id=68462

        Reviewed by Adam Barth.

        Currently not testable.

        * WebCore.gypi:
        * WebCore.pro:
        * bindings/js/JSPeerConnectionCustom.cpp:
        (WebCore::JSPeerConnectionConstructor::constructJSPeerConnection):
        * bindings/v8/custom/V8PeerConnectionCustom.cpp: Removed.
        * dom/MediaStreamList.cpp:
        (WebCore::MediaStreamList::item):
        (WebCore::MediaStreamList::append):
        (WebCore::MediaStreamList::remove):
        (WebCore::MediaStreamList::contains):
        * dom/MediaStreamList.h:
        * p2p/PeerConnection.cpp:
        (WebCore::PeerConnection::create):
        (WebCore::PeerConnection::PeerConnection):
        (WebCore::PeerConnection::processSignalingMessage):
        (WebCore::PeerConnection::readyState):
        (WebCore::PeerConnection::send):
        (WebCore::PeerConnection::addStream):
        (WebCore::PeerConnection::removeStream):
        (WebCore::PeerConnection::localStreams):
        (WebCore::PeerConnection::remoteStreams):
        (WebCore::PeerConnection::close):
        (WebCore::PeerConnection::iceProcessingCompleted):
        (WebCore::PeerConnection::sdpGenerated):
        (WebCore::PeerConnection::dataStreamMessageReceived):
        (WebCore::PeerConnection::remoteStreamAdded):
        (WebCore::PeerConnection::remoteStreamRemoved):
        (WebCore::PeerConnection::scriptExecutionContext):
        (WebCore::PeerConnection::stop):
        (WebCore::PeerConnection::scheduleInitialNegotiation):
        (WebCore::PeerConnection::initialNegotiationTimerFired):
        (WebCore::PeerConnection::ensureStreamChangeScheduled):
        (WebCore::PeerConnection::streamChangeTimerFired):
        (WebCore::PeerConnection::scheduleReadyStateChange):
        (WebCore::PeerConnection::readyStateChangeTimerFired):
        (WebCore::PeerConnection::changeReadyState):
        * p2p/PeerConnection.h:
        (WebCore::PeerConnection::refEventTarget):
        (WebCore::PeerConnection::derefEventTarget):
        * p2p/PeerConnection.idl:
        * page/MediaStreamClient.h:
        * page/MediaStreamController.cpp:
        (WebCore::MediaStreamController::MediaStreamController):
        * page/MediaStreamController.h:
        * page/MediaStreamFrameController.cpp:
        * page/MediaStreamFrameController.h:

2011-10-12  Chris Fleizach  <cfleizach@apple.com>

        AX: CrashTracer: [USER] 296 crashes in WebProcess at com.apple.WebCore: WebCore::AccessibilityScrollbar::document const + 29
        https://bugs.webkit.org/show_bug.cgi?id=69936

        AX Scrollbars have a weak pointer to their parent. They need to become AccessibilityMockObjects, so that they can
        participate in the detachFromParent() methods that happens when those parents go away.
        Could not reproduce the crash, but the backtrace is unequivocal.

        Reviewed by Darin Adler.

        * accessibility/AccessibilityScrollView.cpp:
        (WebCore::AccessibilityScrollView::removeChildScrollbar):
        * accessibility/AccessibilityScrollbar.cpp:
        (WebCore::AccessibilityScrollbar::AccessibilityScrollbar):
        * accessibility/AccessibilityScrollbar.h:
        (WebCore::AccessibilityScrollbar::scrollbar):
        (WebCore::AccessibilityScrollbar::isAccessibilityScrollbar):

2011-10-12  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=69950
        
        REGRESSION: Printing broken because of the isWritingModeRoot addition for unsplittable
        paginated content. Make sure not to include the RenderView when checking for writing mode
        roots. We only care about children that differ from their parents.

        Reviewed by Dimitri Glazkov.

        * rendering/LayoutState.cpp:
        (WebCore::LayoutState::LayoutState):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::adjustForUnsplittableChild):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::isUnsplittableForPagination):
        * rendering/RenderBox.h:

2011-10-12  Anna Cavender  <annacc@chromium.org>

        Moving ScriptExecutionContext to the front of the argument list for
        IDL constructors that use ConstructorWith=ScriptExecutionContext.
        https://bugs.webkit.org/show_bug.cgi?id=69799

        Reviewed by Adam Barth.

        Tests:
        - http/tests/eventsource/* (for EventSource)
        - fast/filesystem/* (for Worker)

        * bindings/js/JSEventSourceCustom.cpp:
        (WebCore::JSEventSourceConstructor::constructJSEventSource):
        * bindings/js/JSWorkerCustom.cpp:
        (WebCore::JSWorkerConstructor::constructJSWorker):
        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateConstructorCallback):
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        (WebCore::V8TestInterface::constructorCallback):
        * page/EventSource.cpp:
        (WebCore::EventSource::create):
        * page/EventSource.h:
        * workers/Worker.cpp:
        (WebCore::Worker::create):
        * workers/Worker.h:

2011-10-11  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=69896
        
        [CSS Regions] Make positioned blocks work with variable width regions.
        
        Make positioned objects able to position and size independently in each region. This involves
        lifting the restriction in renderBoxRegionInfo for positioned objects and passing in region
        information to computeLogicalWidthForPositioned so that it can compute answers for a given
        region.

        In order to make mixed writing modes work with positioned objects, this patch also takes some
        baby steps towards fixing differing writing modes in paginated environments.

        Reviewed by Sam Weinig.

        Added many new tests in fast/regions.

        * rendering/LayoutState.cpp:
        (WebCore::LayoutState::LayoutState):
        Disable pagination whenever differing writing modes are encountered. The block effectively becomes
        unsplittable (as though it was an image).

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::layoutBlock):
        Remove a FIXME that looks incorrect now.

        (WebCore::RenderBlock::adjustPositionedBlock):
        Patch static inline position caching to call a new method that unshifts the position to put it back
        in the overall block's space rather than having it be per-region.

        (WebCore::RenderBlock::layoutPositionedObjects):
        Make sure to attempt to set a logicalTop for positioned objects before they lay out so that they
        have a chance of paginating correctly the first time around. If for some reason the top estimate proves
        to be incorrect, we lay out again. Technically this bug exists for multi-column and printing as well, but
        for now just fixing it for regions.

        (WebCore::RenderBlock::adjustForUnsplittableChild):
        Add writing mode roots to the set of objects we consider to be unsplittable.

        (WebCore::RenderBlock::setStaticInlinePositionForChild):
        New helper function that handles shifting the inline static position back into the overall block's space
        rather than leaving it in a translated region-specific space.

        * rendering/RenderBlock.h:
        (WebCore::RenderBlock::startOffsetForContent):
        New helper function for computing the start offset when no regions are involved.

        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::setStaticPositions):
        (WebCore::RenderBlock::LineBreaker::nextLineBreak):
        Patched to call the new helper function, setStaticInlinePositionForChild.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::positionLineBox):
        Patched to call the new helper function, setStaticInlinePositionForChild.

        (WebCore::RenderBox::computeLogicalWidthInRegion):
        Pass region information into the positioning logical width computation function.

        (WebCore::RenderBox::renderBoxRegionInfo):
        Remove the positioning restriction and properly compute shifting and left/right offsets for positioned
        objects.

        (WebCore::RenderBox::computeLogicalHeight):
        Add code for perpendicular flows that just positions the object within the first region it is encountered
        in. Since the object is unsplittable, this will work out. Should the object be so tall that it can't fit
        in any region, then the resulting rendering will potentially be terrible, but the expectation is that authors should
        avoid having perpendicular flows break across pages.

        (WebCore::RenderBox::containingBlockLogicalWidthForPositioned):
